'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = build;

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _rimraf = require('rimraf');

var _rimraf2 = _interopRequireDefault(_rimraf);

var _updateWebpackConfig = require('../config/updateWebpackConfig');

var _updateWebpackConfig2 = _interopRequireDefault(_updateWebpackConfig);

var _context = require('./common/context');

var _context2 = _interopRequireDefault(_context);

var _generateEntryFile = require('./common/generateEntryFile');

var _generateEntryFile2 = _interopRequireDefault(_generateEntryFile);

var _getPackagePath = require('./common/getPackagePath');

var _getPackagePath2 = _interopRequireDefault(_getPackagePath);

var _installSubmoduleDependencies = require('./common/installSubmoduleDependencies');

var _installSubmoduleDependencies2 = _interopRequireDefault(_installSubmoduleDependencies);

var _initialize = require('./common/initialize');

var _initialize2 = _interopRequireDefault(_initialize);

var _warning = require('../common/warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// 使用webpack打包并启动
/**
 * 项目编译命令
 * 相当于umi的npm run build的build命令
 */

function dist(mainPackage, env) {
  var entryName = _context2['default'].choerodonConfig.entryName;
  // 生成react项目的入口文件

  (0, _generateEntryFile2['default'])(mainPackage, entryName);
  var webpackConfig = (0, _updateWebpackConfig2['default'])('build', env);
  webpackConfig.plugins.push(new _webpack2['default'].DefinePlugin({
    'process.env.NODE_ENV': JSON.stringify(env)
  }));

  // 用webpack打包文件到dist目录
  (0, _webpack2['default'])(webpackConfig, function (err, stats) {
    if (err !== null) {
      // warning(true, err);
    } else if (stats.hasErrors()) {
      // warning(true, stats.toString('errors-only'));
    }
  });
}

function build(program) {
  // 生成context对象存webpack配置文件，context = {choerodonConfig}
  (0, _initialize2['default'])(program);
  var output = _context2['default'].choerodonConfig.output;

  var env = program.env || process.env.NODE_ENV || 'production';
  _rimraf2['default'].sync(output);
  _mkdirp2['default'].sync(output);
  /**
   * yqcloud-front-build --config ./config.js => program.args = [] 进不去if
   * yqcloud-front-build --config ./config.js yqcloud-front-im/src/package.json => program.args = [yqcloud-front-im/src/package.json] 进去if
   */
  if (program.args.length) {
    (0, _installSubmoduleDependencies2['default'])(program, function (mainPackage) {
      return dist(mainPackage, env);
    });
  } else {
    var mainPackagePath = (0, _getPackagePath2['default'])();
    var mainPackage = require(mainPackagePath);
    dist(mainPackage, env);
  }
}