'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _warning = require('../../common/warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var isInitialized = false; /**
                            * 初始化配置文件
                            * 1.生成一个配置文件，choerodonConfig：{...webpack配置}
                            * 2.挂载一个缓存目录路径，tmpDirPath: '__dirname/tmp'
                            * 返回：
                            *   {choerodonConfig, tmpDirPath}
                            */

exports.initialize = function initialize(context) {
  if (isInitialized) {
    (0, _warning2['default'])(false, '`context` had been initialized');
    return;
  }
  var tmpDirPath = _path2['default'].join(__dirname, '../../../tmp');
  context.tmpDirPath = tmpDirPath;
  _mkdirp2['default'].sync(tmpDirPath);
  (0, _extends3['default'])(exports, context);
  isInitialized = true;
};