'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = generateEntryFile;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nunjucks = require('nunjucks');

var _nunjucks2 = _interopRequireDefault(_nunjucks);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _getRoutesPath = require('./getRoutesPath');

var _getRoutesPath2 = _interopRequireDefault(_getRoutesPath);

var _getDashBoardPath = require('./getDashBoardPath');

var _getDashBoardPath2 = _interopRequireDefault(_getDashBoardPath);

var _escapeWinPath = require('./escapeWinPath');

var _escapeWinPath2 = _interopRequireDefault(_escapeWinPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var entryTemplate = _fs2['default'].readFileSync(_path2['default'].join(__dirname, '../../nunjucks/entry.nunjucks.js')).toString(); /**
                                                                                                                                     * 功能：
                                                                                                                                     * 1.生成entry.index.js文件
                                                                                                                                     * 2.使用nunjuck注入route.index.js的内容到entry.index.js，从而实现完整的react路由启动文件
                                                                                                                                     */
function generateEntryFile(mainPackage, configEntryName) {
  var tmpDirPath = _context2['default'].tmpDirPath;
  // ./tmp/entry.index.js

  var entryPath = _path2['default'].join(tmpDirPath, 'entry.' + configEntryName + '.js');
  // ./tmp/dashboard.js
  var dashboardPath = (0, _getDashBoardPath2['default'])(configEntryName);
  // ./tmp/routes.index.js
  var routesPath = (0, _getRoutesPath2['default'])(mainPackage, configEntryName, dashboardPath);
  _fs2['default'].writeFileSync(entryPath,
  // 用nunjucks引擎把路由文件route.index.js内容注入到routesPath变量，生成entry.index.js文件
  _nunjucks2['default'].renderString(entryTemplate, {
    routesPath: (0, _escapeWinPath2['default'])(routesPath)
  }));
}