'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

exports['default'] = getPackageRoute;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function getPackageRoute(packageInfo) {
  var base = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '.';

  if (packageInfo) {
    var main = packageInfo.main,
        name = packageInfo.name;

    return (0, _defineProperty3['default'])({}, name.slice(name.lastIndexOf('-') + 1), _path2['default'].join(base, main));
  }
} /**
   * 获取子模块package.json的入口文件
   * 返回格式
   *  以子模块name的中划线最后的内容作为key
   *  例子：
   *    yqcloud-front-itsm => return  {itsm: '[USER_PATH]/yqcloud-front-itsm/itsm/src/app/itsm/containers/ITSMIndex.js'} 
   *    yqcloud-front-iam  => return {iam: '[USER_PATH]/yqcloud-front-iam/iam/src/app/iam/containers/IAMIndex.js'}
   */