'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = getRoutesPath;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nunjucks = require('nunjucks');

var _nunjucks2 = _interopRequireDefault(_nunjucks);

var _getPackageRoute = require('./getPackageRoute');

var _getPackageRoute2 = _interopRequireDefault(_getPackageRoute);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _escapeWinPath = require('./escapeWinPath');

var _escapeWinPath2 = _interopRequireDefault(_escapeWinPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// route入口文件字符串， 是一个react语法的字符串
/**
 * 功能：
 * 1.生成一个临时文件 ./tmp/routes.index.js
 * 2.返回临时文件路径 ./tmp/routes.index.js
 */

var routesTemplate = _fs2['default'].readFileSync(_path2['default'].join(__dirname, '../../nunjucks/routes.nunjucks.js')).toString();

function getRoutesPath(packageInfo, configEntryName, dashboardPath) {
  var tmpDirPath = _context2['default'].tmpDirPath,
      isDev = _context2['default'].isDev,
      routes = _context2['default'].choerodonConfig.routes;
  // 子模块入口文件路径

  var configRoutes = routes || (0, _getPackageRoute2['default'])(packageInfo);
  // 需要生成的子模块路由文件路径
  var routesPath = _path2['default'].join(tmpDirPath, 'routes.' + configEntryName + '.js');
  _nunjucks2['default'].configure(routesPath, {
    autoescape: false
  });

  _fs2['default'].writeFileSync(routesPath,
  // 用nunjuck是模板引擎解析react模板字符串
  _nunjucks2['default'].renderString(routesTemplate, {
    // 用语法字符串替换根route文件里的route变量 createRoute('itsm', function(){return import '[USER_PATH]/yqcloud-front-itsm/itsm/src/app/itsm/containers/ITSMIndex.js'})
    routes: Object.keys(configRoutes).map(function (key) {
      return 'createRoute("/' + key + '", function() { return import("' + (0, _escapeWinPath2['default'])(_path2['default'].join(process.cwd(), configRoutes[key])) + '"); })';
    }).join(',\n'),
    dashboardPath: (0, _escapeWinPath2['default'])(dashboardPath),
    source: isDev ? 'src' : 'lib'
  }));
  return routesPath;
}