'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = initialize;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _getChoerodonConfig = require('../../config/getChoerodonConfig');

var _getChoerodonConfig2 = _interopRequireDefault(_getChoerodonConfig);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 * 
 * @param {*} program 
 *  传入一个配置文件路径
 *  --config ./config.js => program: {config: './config.js'}
 */
function initialize(program) {
  // 项目根目录config文件路径   [USERPATH]/yqcloud-front/config.js
  var configFile = _path2['default'].join(process.cwd(), program.config || 'choerodon.config.js');
  // 获取webpack文件，这个文件 = 默认配置 + 用户自定义的配置
  var choerodonConfig = (0, _getChoerodonConfig2['default'])(configFile);
  // 挂到context = { choerodonConfig }
  _context2['default'].initialize({ choerodonConfig: choerodonConfig });
} /**
   * 生成context对象挂载配置文件
   * 返回：
   * {
   *    choerodonConfig: {...}
   * }
   */