'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _sanitizeHtml = require('sanitize-html');

var _sanitizeHtml2 = _interopRequireDefault(_sanitizeHtml);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/* defautl options
allowedTags: [ 'h3', 'h4', 'h5', 'h6', 'blockquote', 'p', 'a', 'ul', 'ol',
  'nl', 'li', 'b', 'i', 'strong', 'em', 'strike', 'code', 'hr', 'br', 'div',
  'table', 'thead', 'caption', 'tbody', 'tr', 'th', 'td', 'pre' ],

allowedAttributes: {
  a: [ 'href', 'name', 'target' ],
  // We don't currently allow img itself by default, but this
  // would make sense if we did
  img: [ 'src' ]
},

  // Lots of these won't come up by default because we don't allow them
selfClosing: [ 'img', 'br', 'hr', 'area', 'base', 'basefont', 'input', 'link', 'meta' ],
  // URL schemes we permit
allowedSchemes: [ 'http', 'https', 'ftp', 'mailto' ],
allowedSchemesByTag: {},
allowProtocolRelative: true
*/

var externalTags = ['img', 'h1', 'h2', 'h7', 'font', 'span', 'del', 'u', 'sub', 'sup', 'figure'];

var allowedTags = _sanitizeHtml2['default'].defaults.allowedTags.concat(externalTags);
var allowedAttr = ['src', 'style', 'class', 'id', 'role', 'data-id', 'data-type', 'data-card-editable', 'data-syntax', 'data-value', 'target', 'checked', 'data-yqmention', 'yqmention-type', 'tenantid', 'width', 'height'];

var allowedAttributes = {};
var allowedSchemes = ['data', 'http', 'https'];

allowedTags.forEach(function (tag) {
  allowedAttributes[tag] = allowedAttr;
});

var sanitizeOptions = {
  allowedTags: allowedTags,
  allowedAttributes: allowedAttributes,
  allowedSchemes: allowedSchemes
};

exports['default'] = sanitizeOptions;