'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 * webpack 配置文件生成
 * {
 *    ...本文件定义的默认配置
 *    ...项目自定义的配置
 * }
 */

var defaultConfig = {
  port: 9090,
  output: './dist',
  htmlTemplate: 'index.template.html',
  devServerConfig: {},
  postcssConfig: {
    plugins: [(0, _autoprefixer2['default'])({
      browsers: ['last 2 versions', 'Firefox ESR', '> 1%', 'ie >= 8', 'iOS >= 8', 'Android >= 4']
    })]
  },
  babelConfig: function babelConfig(config, mode, env) {
    return config;
  },
  webpackConfig: function webpackConfig(config, mode, env) {
    return config;
  },
  enterPoints: function enterPoints(mode, env) {
    return {};
  },

  // 本地环境变量值的配置
  entryName: 'index',
  root: '/',
  routes: null,
  local: true,
  server: 'http://api.example.com',
  fileServer: 'http://file.example.com',
  wsServer: 'wss://report.dev.cloopm.com',
  servicePortalsUrl: 'https://servicePortals.staging.hand-ams.com',
  wsServerDownload: 'wss://scheduler.staging.cloopm.com',
  wsServerKnowledge: 'wss://knowledge.staging.hand-ams.com',
  closeErrorMessageConfig: '403',
  knowledgeSpaceDomain: 'https://orgCode.cloopm.com/knowledgespace/',
  webSocketUrl: 'wss://notify.dev.cloopm.com',
  uploadFrag: 'Y',
  clientid: 'localhost',
  titlename: '宁德时代共享服务管理平台',
  favicon: 'favicon.ico',
  theme: {
    'primary-color': '#2196f3'
  },
  chatHost: 'https://chatbot.dev.cloopm.com',
  maixinRecord: 'http://icctest.maixintech.com:81/data',
  customerServiceUrl: 'https://csframe.demo.cloopm.com',
  workStationHost: 'https://workstation.dev.cloopm.com',
  dashboard: false
};

module.exports = function getChoerodonConfig(configFile) {
  var customizedConfig = fs.existsSync(configFile) ? require(configFile) : {};
  var config = (0, _extends3['default'])({}, defaultConfig, customizedConfig);
  // config.index = resolve.sync(config.index, { basedir: process.cwd() });
  return config;
};