'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeCookie = exports.getCookie = exports.setCookie = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _universalCookie = require('universal-cookie');

var _universalCookie2 = _interopRequireDefault(_universalCookie);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var isLocal = _constants.CLIENT_ID === 'localhost';

var cookies = new _universalCookie2['default']();

var setOptions = function setOptions(option) {
  // 如果是http设置的部署，不作安全处理
  // console.log('CURRENT PROTOCOL == ', process.env.ENV_PROTOCOL)
  if (process.env.ENV_PROTOCOL !== 'http') {
    return (0, _extends3['default'])({}, option, { Secure: !isLocal });
  }
  return (0, _extends3['default'])({}, option, { Secure: false });
};

// eslint-disable-next-line prefer-object-spread
var setCookie = function setCookie(name, value) {
  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return cookies.set(name, value, setOptions(option));
};

var getCookie = function getCookie(name) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return cookies.get(name, setOptions(option));
};

var removeCookie = function removeCookie(name) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return cookies.remove(name, setOptions(option));
};

exports.setCookie = setCookie;
exports.getCookie = getCookie;
exports.removeCookie = removeCookie;