'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style2 = require('yqcloud-ui/lib/message/style');

var _message = require('yqcloud-ui/lib/message');

var _message2 = _interopRequireDefault(_message);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _v = require('uuid/v1');

var _v2 = _interopRequireDefault(_v);

var _authorize = require('../../common/authorize');

var _accessToken = require('../../common/accessToken');

var _constants = require('../../common/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var closeErrorMessageConfig = '' + process.env.CLOSE_ERROR_MESSAGE_CONFIG;

// axios 配置
/**
 * Created by smilesoul on 2017/6/23.
 */
/* eslint-disable */
_axios2['default'].defaults.timeout = 30000;
_axios2['default'].defaults.baseURL = '' + process.env.API_HOST;
console.log(process.env);
// history.go(0);
// http request 拦截器);
_axios2['default'].interceptors.request.use(function (config) {
  var newConfig = config;
  console.log(newConfig);
  newConfig.headers['Content-Type'] = 'application/json';
  newConfig.headers['Cache-Control'] = 'no-cache';
  newConfig.headers.Pragma = 'no-cache';
  // newConfig.headers['If-Modified-Since'] = new Date();
  // newConfig.headers['Cache-Control'] = 'max-age=3600';
  newConfig.headers.Accept = 'application/json';
  // 跨域请求设置范围
  newConfig.headers['Access-Control-Allow-Origin'] = 'ENV_YQ_HOST';
  // 自定义
  newConfig.headers['X-Request-ID'] = (0, _v2['default'])();
  // eslint-disable-next-line
  newConfig.headers['X-Menu-Code'] = (window.location.href.split('/#/')[1] || '').split('?')[0] || 'system/home';

  newConfig.headers['X-Client-ID'] = _constants.CLIENT_ID;
  newConfig.headers['X-Client-Type'] = _constants.CLIENT_TYPE;

  var accessToken = (0, _accessToken.getAccessToken)() || '';
  // console.log('axios accessToken == ', accessToken, getAccessToken())
  if (accessToken) {
    newConfig.headers.Authorization = accessToken;
  }
  return newConfig;
}, function (err) {
  var error = err;
  return Promise.reject(error);
});

// http response 拦截器
_axios2['default'].interceptors.response.use(function (response) {
  if (response.status === 204) {
    return Promise.resolve(response);
  }

  // const orgIndex = response.config.url.split('/').findIndex(value => value === 'v1') + 1;

  // const orgId1 = parseInt(response.config.url.split('/')[orgIndex]);

  // const orgId2 = parseInt(response.config.url.split('/')[orgIndex + 1]);

  // const isOrg = !isNaN(orgId1 || orgId2);

  // const { failed, code } = response.data;
  // if (!isOrg && failed && response.config.url.indexOf('/fnd/v1/sys/messages/queryCode?messageCode=') === -1) {
  //   axios.get(`/fnd/v1/sys/messages/queryCode?messageCode=${code}`)
  //     .then((data) => {
  //       const { failed: infailed } = data;
  //       if (!infailed) {
  //         message.error(data.content, undefined, undefined, 'leftBottom');
  //       } else {
  //         message.error(code, undefined, undefined, 'leftBottom');
  //       }
  //     })
  //     .catch(() => {
  //       message.error(code, undefined, undefined, 'leftBottom');
  //     });
  // } else if (isOrg && failed && response.config.url.indexOf('/sys/select_by_Code?messageCode=') === -1) {
  //   axios.get(`/fnd/v1/${orgId1 || orgId2}/sys/select_by_Code?messageCode=${code}`)
  //     .then((data) => {
  //       const { failed: infailed } = data;
  //       if (!infailed) {
  //         message.error(data.content, undefined, undefined, 'leftBottom');
  //       } else {
  //         message.error(code, undefined, undefined, 'leftBottom');
  //       }
  //     })
  //     .catch(() => {
  //       message.error(code, undefined, undefined, 'leftBottom');
  //     });
  // }
  // continue sending response to the then() method
  var _response$data = response.data,
      success = _response$data.success,
      errorCode = _response$data.errorCode,
      errorMsg = _response$data.errorMsg;


  if (success !== undefined && (!success || success === 'false')) {
    response.data = { failed: true };
    _message2['default'].error(errorMsg || errorCode, undefined, undefined, 'leftBottom');
  }

  return Promise.resolve(response.data);
}, function (error) {
  var response = error.response;

  if (response) {
    var status = response.status;

    switch (status) {
      case 401:
        {
          (0, _authorize.logout)();
          break;
        }
      case 403:
        {
          // message.error(403, undefined, undefined, 'leftBottom');
          isThorwErrorMessage('403');
          break;
        }
      case 500:
        {
          // message.error(500, undefined, undefined, 'leftBottom');
          isThorwErrorMessage('500');
          break;
        }
      default:
        break;
    }
  }
  return Promise.reject(error);
});

function isThorwErrorMessage(flag) {
  console.log('closeErrorMessageConfig ===>', closeErrorMessageConfig);
  if (closeErrorMessageConfig && closeErrorMessageConfig.indexOf(flag) > -1) {
    // 如果包含关闭的就啥也不做, 403  /  500 等
  } else {
    _message2['default'].error(flag, undefined, undefined, 'leftBottom');
  }
}

exports['default'] = _axios2['default'];