'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Card = require('./Card');

var _Card2 = _interopRequireDefault(_Card);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Column = (_dec = (0, _mobxReact.inject)('DashboardStore'), _dec(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3['default'])(Column, _Component);

  function Column() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, Column);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, (_ref = Column.__proto__ || Object.getPrototypeOf(Column)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      dragOver: false
    }, _this.handleDragStart = function (data) {
      var _this$props = _this.props,
          onDragStart = _this$props.onDragStart,
          column = _this$props.column,
          sort = _this$props.sort;

      if (typeof onDragStart === 'function') {
        onDragStart(data, column, sort);
      }
    }, _this.handleDragEnd = function () {
      var onDragEnd = _this.props.onDragEnd;

      if (typeof onDragEnd === 'function') {
        onDragEnd();
      }
    }, _this.handleDropEnter = function () {
      _this.setState({
        dragOver: true
      });
    }, _this.handleDropLeave = function () {
      _this.setState({
        dragOver: false
      });
    }, _this.handleDrop = function (e, data, side) {
      var _this$props2 = _this.props,
          onDrop = _this$props2.onDrop,
          column = _this$props2.column,
          sort = _this$props2.sort;

      if (typeof onDrop === 'function') {
        onDrop(data, column, side, sort);
      }
      _this.setState({
        dragOver: false
      });
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  (0, _createClass3['default'])(Column, [{
    key: 'renderCard',
    value: function renderCard(data) {
      var dashboardCode = data.dashboardCode,
          dashboardNamespace = data.dashboardNamespace,
          sort = data.sort;

      var key = dashboardNamespace + '/' + dashboardCode;
      var _props = this.props,
          prefixCls = _props.prefixCls,
          components = _props.components,
          dragData = _props.dragData;

      return _react2['default'].createElement(_Card2['default'], {
        key: key + '-' + sort,
        prefixCls: prefixCls,
        data: data,
        dragData: dragData,
        component: components[key],
        onDragStart: this.handleDragStart,
        onDragEnd: this.handleDragEnd,
        onDrop: this.handleDrop
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          column = _props2.column,
          DashboardStore = _props2.DashboardStore;

      if (column.length > 0 && (DashboardStore.editing || column.filter(function (_ref2) {
        var visible = _ref2.visible;
        return visible;
      }).length > 0)) {
        return _react2['default'].createElement(
          'div',
          null,
          column.map(function (item) {
            return _this2.renderCard(item);
          })
        );
      } else {
        var _props3 = this.props,
            prefixCls = _props3.prefixCls,
            dragData = _props3.dragData;
        var dragOver = this.state.dragOver;

        var columnProps = {
          className: (0, _classnames2['default'])(prefixCls + '-column-empty', (0, _defineProperty3['default'])({}, prefixCls + '-column-drag-over', dragOver))
        };
        if (dragData) {
          (0, _extends3['default'])(columnProps, {
            onMouseEnter: this.handleDropEnter,
            onMouseLeave: this.handleDropLeave,
            onMouseUp: this.handleDrop
          });
        }
        return _react2['default'].createElement('div', columnProps);
      }
    }
  }]);
  return Column;
}(_react.Component), _class2.defaultProps = {
  column: []
}, _temp2)) || _class) || _class);
exports['default'] = Column;