'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style6 = require('yqcloud-ui/lib/spin/style');

var _spin = require('yqcloud-ui/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _style7 = require('yqcloud-ui/lib/row/style');

var _row = require('yqcloud-ui/lib/row');

var _row2 = _interopRequireDefault(_row);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _style8 = require('yqcloud-ui/lib/col/style');

var _col = require('yqcloud-ui/lib/col');

var _col2 = _interopRequireDefault(_col);

var _style9 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style10 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Column = require('./Column');

var _Column2 = _interopRequireDefault(_Column);

require('./style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function normalizeColumns(items) {
  var columns = {
    0: [],
    1: [],
    2: []
  };
  items.slice().sort(function (_ref, _ref2) {
    var sort = _ref.sort;
    var sort2 = _ref2.sort;
    return sort - sort2;
  }).forEach(function (item) {
    columns[(item.sort - 1) % 3].push(item);
  });
  return columns;
}

function resortColumn(column, columnIndex) {
  if (column.length > 0) {
    column.forEach((0, _mobx.action)(function (data, index) {
      var sort = index * 3 + columnIndex + 1;
      data.sort = sort;
      return sort;
    }));
  }
}

var PREFIX_CLS = 'c7n-boot-dashboard';

var dragCard = {
  data: null,
  column: null,
  sort: null
};

function clearDragCard() {
  (0, _extends3['default'])(dragCard, {
    data: null,
    column: null,
    sort: null
  });
}

var Dashboard = (_dec = (0, _mobxReact.inject)('DashboardStore'), _dec(_class = (0, _reactIntl.injectIntl)(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(Dashboard, _Component);

  function Dashboard() {
    var _ref3;

    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, Dashboard);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, (_ref3 = Dashboard.__proto__ || Object.getPrototypeOf(Dashboard)).call.apply(_ref3, [this].concat(args))), _this), _this.fetchData = function () {
      _this.props.DashboardStore.loadDashboardData();
    }, _this.handleEdit = function () {
      _this.props.DashboardStore.setEditing(true);
    }, _this.handleComplete = function () {
      var DashboardStore = _this.props.DashboardStore;

      if (DashboardStore.dirty) {
        DashboardStore.updateDashboardData().then(function () {
          _this.handleEditSuccess();
        });
      } else {
        _this.handleEditSuccess();
      }
    }, _this.handleDragStart = function (data, column, sort) {
      (0, _extends3['default'])(dragCard, {
        data: data,
        column: column,
        sort: sort
      });
      _this.forceUpdate();
    }, _this.handleDragEnd = function () {
      clearDragCard();
      _this.forceUpdate();
    }, _this.handleDrop = function (data, column, side, sort) {
      var dragData = dragCard.data,
          dragColumn = dragCard.column,
          dragSort = dragCard.sort;

      if (dragData && dragColumn && column) {
        dragColumn.splice(dragColumn.indexOf(dragData), 1);
        var index = column.indexOf(dragData);
        if (index > -1) {
          column.splice(index, 1);
        }
        if (data && side) {
          var newIndex = column.indexOf(data) + (side === 'bottom' ? 1 : 0);
          column.splice(newIndex, 0, dragData);
        } else {
          column.push(dragData);
        }
        resortColumn(dragColumn, dragSort);
        resortColumn(column, sort);
        clearDragCard();
        var _this$props = _this.props,
            DashboardStore = _this$props.DashboardStore,
            intl = _this$props.intl;

        DashboardStore.updateDashboardData().then(function () {
          Choerodon.prompt(intl.formatMessage({ id: 'boot.dashboard.success' }));
        });
      }
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  (0, _createClass3['default'])(Dashboard, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.fetchData();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {
      this.fetchData();
    }
  }, {
    key: 'handleEditSuccess',
    value: function handleEditSuccess() {
      var _props = this.props,
          DashboardStore = _props.DashboardStore,
          intl = _props.intl;

      DashboardStore.setEditing(false);
      Choerodon.prompt(intl.formatMessage({ id: 'boot.dashboard.success' }));
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader(editing) {
      return _react2['default'].createElement(
        'header',
        { className: PREFIX_CLS + '-header' },
        _react2['default'].createElement(_icon2['default'], { type: 'home' }),
        _react2['default'].createElement(_reactIntl.FormattedMessage, { id: 'boot.dashboard.home' }),
        editing ? _react2['default'].createElement(
          _button2['default'],
          {
            icon: 'check',
            className: PREFIX_CLS + '-header-button',
            onClick: this.handleComplete
          },
          _react2['default'].createElement(_reactIntl.FormattedMessage, { id: 'boot.dashboard.complete' })
        ) : _react2['default'].createElement(
          _button2['default'],
          {
            icon: 'mode_edit',
            className: PREFIX_CLS + '-header-button',
            onClick: this.handleEdit
          },
          _react2['default'].createElement(_reactIntl.FormattedMessage, { id: 'boot.dashboard.customize' })
        )
      );
    }
  }, {
    key: 'renderColumns',
    value: function renderColumns() {
      var _this2 = this;

      var items = this.props.DashboardStore.getDashboardData;

      var columns = normalizeColumns(items);
      return Object.keys(columns).map(function (key) {
        return _react2['default'].createElement(
          _col2['default'],
          { key: key, span: 8 },
          _react2['default'].createElement(_Column2['default'], {
            prefixCls: PREFIX_CLS,
            column: columns[key],
            sort: key,
            components: _this2.props,
            dragData: dragCard.data,
            onDragStart: _this2.handleDragStart,
            onDragEnd: _this2.handleDragEnd,
            onDrop: _this2.handleDrop
          })
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props$DashboardStore = this.props.DashboardStore,
          editing = _props$DashboardStore.editing,
          loading = _props$DashboardStore.loading;

      var classString = (0, _classnames2['default'])(PREFIX_CLS + '-container', (_classNames = {}, (0, _defineProperty3['default'])(_classNames, PREFIX_CLS + '-dragging', !!dragCard.data), (0, _defineProperty3['default'])(_classNames, PREFIX_CLS + '-editing', editing), _classNames));

      return _react2['default'].createElement(
        'div',
        { className: PREFIX_CLS },
        this.renderHeader(editing),
        _react2['default'].createElement(
          _spin2['default'],
          { spinning: loading, wrapperClassName: classString },
          _react2['default'].createElement(
            _row2['default'],
            { type: 'flex', gutter: 20 },
            this.renderColumns()
          )
        )
      );
    }
  }]);
  return Dashboard;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = Dashboard;