'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style11 = require('yqcloud-ui/lib/menu/style');

var _menu = require('yqcloud-ui/lib/menu');

var _menu2 = _interopRequireDefault(_menu);

var _style12 = require('yqcloud-ui/lib/progress/style');

var _progress = require('yqcloud-ui/lib/progress');

var _progress2 = _interopRequireDefault(_progress);

var _style13 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style14 = require('yqcloud-ui/lib/pagination/style');

var _pagination = require('yqcloud-ui/lib/pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _style15 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _style16 = require('yqcloud-ui/lib/tag/style');

var _tag = require('yqcloud-ui/lib/tag');

var _tag2 = _interopRequireDefault(_tag);

var _style17 = require('yqcloud-ui/lib/avatar/style');

var _avatar = require('yqcloud-ui/lib/avatar');

var _avatar2 = _interopRequireDefault(_avatar);

var _style18 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style19 = require('yqcloud-ui/lib/date-picker/style');

var _datePicker = require('yqcloud-ui/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

var _style20 = require('yqcloud-ui/lib/input/style');

var _input = require('yqcloud-ui/lib/input');

var _input2 = _interopRequireDefault(_input);

var _dec, _class; /**
                   * Create By Steven King on 2019.05.21
                   */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _mobxReact = require('mobx-react');

var _reactRouterDom = require('react-router-dom');

var _quillDeltaToHtml = require('quill-delta-to-html');

var _index = require('../index');

require('./index.scss');

var _globalSearch = require('../../data/globalSearch');

var _language = require('../../data/globalSearch/language');

var _language2 = _interopRequireDefault(_language);

var _constants = require('../../common/constants');

var _incident3x = require('../../../assets/images/globalSearch/incident@3x.svg');

var _incident3x2 = _interopRequireDefault(_incident3x);

var _task3x = require('../../../assets/images/globalSearch/task@3x.svg');

var _task3x2 = _interopRequireDefault(_task3x);

var _service3x = require('../../../assets/images/globalSearch/service@3x.svg');

var _service3x2 = _interopRequireDefault(_service3x);

var _problem3x = require('../../../assets/images/globalSearch/problem@3x.svg');

var _problem3x2 = _interopRequireDefault(_problem3x);

var _change3x = require('../../../assets/images/globalSearch/change@3x.svg');

var _change3x2 = _interopRequireDefault(_change3x);

var _other3x = require('../../../assets/images/globalSearch/other@3x.svg');

var _other3x2 = _interopRequireDefault(_other3x);

var _img = require('../../../assets/images/globalSearch/img.svg');

var _img2 = _interopRequireDefault(_img);

var _utils = require('../../../common/utils');

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _reactViewer = require('react-viewer');

var _reactViewer2 = _interopRequireDefault(_reactViewer);

require('react-viewer/dist/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Search = _input2['default'].Search;
var RangePicker = _datePicker2['default'].RangePicker;
var ORDER = _constants.SEARCH_TYPE.ORDER,
    KDB = _constants.SEARCH_TYPE.KDB,
    QDB = _constants.SEARCH_TYPE.QDB;

var PREFIX = _language2['default'].prefix;

var queryAnd = function queryAnd(data) {
  var arr = [];
  for (var key in data) {
    arr.push(key + '=' + data[key]);
  }
  return '?' + arr.join('&');
};

var GlobalSearchHome = (_dec = (0, _mobxReact.inject)('AppState', 'GlobalSearchStore'), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(GlobalSearchHome, _Component);

  function GlobalSearchHome(props) {
    (0, _classCallCheck3['default'])(this, GlobalSearchHome);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (GlobalSearchHome.__proto__ || Object.getPrototypeOf(GlobalSearchHome)).call(this, props));

    _this.showBigImg = function () {
      window.addEventListener('click', _this.hello = function (e) {
        if (e.target.src) {
          // 标记全屏查看图片
          e.stopPropagation();
          _this.open(e.target.src);
        } else if (e.target.id === 'noImg') {
          e.stopPropagation();
          _this.open(e.target.className);
        } else if (e.target.id === 'logoId') {
          _this.setState({
            open: false
          });
        }
      });
    };

    _this.open = function (src) {
      _this.setState({
        open: true,
        src: src
      });
    };

    _this.onSortClick = function (item) {
      var _this$props$GlobalSea = _this.props.GlobalSearchStore,
          setSearchField = _this$props$GlobalSea.setSearchField,
          setKwSearchField = _this$props$GlobalSea.setKwSearchField,
          setQASearchField = _this$props$GlobalSea.setQASearchField,
          menu = _this$props$GlobalSea.menu;

      item.asc = !item.asc;
      if (menu === ORDER) {
        setSearchField(item);
      } else if (menu === KDB) {
        setKwSearchField(item);
      } else {
        setQASearchField(item);
      }
    };

    _this.getSortListDom = function () {
      var _this$props$GlobalSea2 = _this.props.GlobalSearchStore,
          menu = _this$props$GlobalSea2.menu,
          searchField = _this$props$GlobalSea2.searchField,
          kwSearchField = _this$props$GlobalSea2.kwSearchField,
          QASearchField = _this$props$GlobalSea2.QASearchField,
          language = _this$props$GlobalSea2.language;

      var divide = _react2['default'].createElement('li', { className: 'ul-divider' });
      if (menu === ORDER) {
        var getTheFilterListDom = function getTheFilterListDom(filterList) {
          var filterChildElements = [];
          filterList && filterList.map(function (item, index) {
            var className = item.id === searchField.id ? 'ul-menu-checked' : '';
            var orderIcon = item.id === searchField.id ? item.asc ? _react2['default'].createElement(_icon2['default'], { type: 'arrow_upward', className: 'f14 color' }) : _react2['default'].createElement(_icon2['default'], { type: 'arrow_downward', className: 'f14 color' }) : null;
            var node = _react2['default'].createElement(
              'li',
              {
                key: item.id,
                className: 'ul-menu jflex-with-center ' + className,
                onClick: function onClick() {
                  return _this.onSortClick(item);
                }
              },
              language[PREFIX + item.name],
              orderIcon
            );

            if (index === filterList.length - 1) {
              filterChildElements.push(node);
            } else {
              filterChildElements.push(node, divide);
            }
          });
          return filterChildElements;
        };

        return getTheFilterListDom(_globalSearch.serviceFilterList);
      } else if (menu === KDB) {
        var _getTheFilterListDom = function _getTheFilterListDom(filterList) {
          var filterChildElements = [];
          filterList && filterList.map(function (item, index) {
            var className = item.id === kwSearchField.id ? 'ul-menu-checked' : '';
            var orderIcon = item.id === kwSearchField.id ? item.asc ? _react2['default'].createElement(_icon2['default'], { type: 'arrow_upward', className: 'f14 color' }) : _react2['default'].createElement(_icon2['default'], { type: 'arrow_downward', className: 'f14 color' }) : null;
            var node = _react2['default'].createElement(
              'li',
              {
                key: item.id,
                className: 'ul-menu jflex-with-center ' + className,
                onClick: function onClick() {
                  return _this.onSortClick(item);
                }
              },
              language[PREFIX + item.name],
              orderIcon
            );

            if (index === filterList.length - 1) {
              filterChildElements.push(node);
            } else {
              filterChildElements.push(node, divide);
            }
          });
          return filterChildElements;
        };

        return _getTheFilterListDom(_globalSearch.knowledgeFilterList);
      } else {
        var _getTheFilterListDom2 = function _getTheFilterListDom2(filterList) {
          var filterChildElements = [];
          filterList && filterList.map(function (item, index) {
            var className = item.id === QASearchField.id ? 'ul-menu-checked' : '';
            var orderIcon = item.id === QASearchField.id ? item.asc ? _react2['default'].createElement(_icon2['default'], { type: 'arrow_upward', className: 'f14 color' }) : _react2['default'].createElement(_icon2['default'], { type: 'arrow_downward', className: 'f14 color' }) : null;
            var node = _react2['default'].createElement(
              'li',
              {
                key: item.id,
                className: 'ul-menu jflex-with-center ' + className,
                onClick: function onClick() {
                  return _this.onSortClick(item);
                }
              },
              language[PREFIX + item.name],
              orderIcon
            );

            if (index === filterList.length - 1) {
              filterChildElements.push(node, divide);
            } else {
              filterChildElements.push(node, divide);
            }
          });
          return filterChildElements;
        };

        return _getTheFilterListDom2(_globalSearch.questionFilterList);
      }
    };

    _this.getTagListDom = function (tagList) {
      var data = tagList;
      return _react2['default'].createElement(
        'div',
        { className: 'tag-list jflex' },
        data && data.map(function (tag) {
          return _react2['default'].createElement(
            'div',
            { className: 'tag-button', key: tag },
            tag
          );
        })
      );
    };

    _this.getAvatarDom = function (data) {
      var avatar = data.avatar,
          author = data.author;

      return _react2['default'].createElement(
        _avatar2['default'],
        {
          className: 'avatar',
          src: avatar,
          realName: author
        },
        author && author.charAt(0)
      );
    };

    _this.getCommentDom = function (key, key1, data) {
      return _react2['default'].createElement(
        'div',
        { className: 'comment jflex-start-center jpt5', style: { marginBottom: 10 } },
        _this.getAvatarDom(data),
        _react2['default'].createElement('span', { className: 'jml10 jmr10', dangerouslySetInnerHTML: { __html: data.creator } }),
        _react2['default'].createElement('span', { className: 'jml10 jmr10', dangerouslySetInnerHTML: { __html: key } }),
        _react2['default'].createElement('span', { dangerouslySetInnerHTML: { __html: key1 } })
      );
    };

    _this.getQuestionFoot = function (key, key1, data) {
      return _react2['default'].createElement(
        'div',
        { className: 'comment jflex-start-center', style: { marginBottom: 10, marginTop: 10 } },
        _react2['default'].createElement('span', { style: { fontSize: 14, color: '#69758C', fontFamily: 'PingFangSC-Regular', marginRight: 30 }, dangerouslySetInnerHTML: { __html: key } }),
        _react2['default'].createElement('span', { style: { fontSize: 14, color: '#69758C', fontFamily: 'PingFangSC-Regular' }, dangerouslySetInnerHTML: { __html: key1 } })
      );
    };

    _this.getKnowledgeResultListDom = function () {
      var _this$props$GlobalSea3 = _this.props.GlobalSearchStore,
          kwlgResultList = _this$props$GlobalSea3.kwlgResultList,
          language = _this$props$GlobalSea3.language,
          organizationId = _this$props$GlobalSea3.organizationId,
          organizationName = _this$props$GlobalSea3.organizationName,
          menu = _this$props$GlobalSea3.menu,
          name = _this$props$GlobalSea3.organizationName,
          type = _this$props$GlobalSea3.type;

      var resultList = [];

      kwlgResultList && kwlgResultList.length && kwlgResultList.map(function (item) {
        var paragraph = item.paragraph,
            creator = item.creator,
            tagList = item.tagList;

        var paraTitleElement = _this.getKmBaseTitleDom(item);
        var tagListElements = _this.getTagListDom(tagList);
        var commentElement = _this.getCommentDom(item.createAt, item.serverPath, item);

        var param = { type: type, id: organizationId, name: name, organizationId: organizationId };
        var url = '/#/knowledge/detail/' + item.knowledgeId + queryAnd(param);

        var result = _react2['default'].createElement(
          'div',
          { className: 'paragraph', style: { margin: '0 0px 20px' } },
          paraTitleElement,
          tagListElements,
          _react2['default'].createElement(
            'a',
            { className: 'paragraph-link block', onClick: function onClick() {
                window.open('#/knowledge/search?type=organization&id=' + _this.organizationId + '&name=' + _this.organizationName + '&organizationId=' + _this.organizationId + '&knowledgeId=' + item.knowledgeId, '_blank');
              } },
            _react2['default'].createElement('div', { className: 'paragraph-content', dangerouslySetInnerHTML: { __html: paragraph } })
          ),
          commentElement
        );
        resultList.push(result);
      });

      return resultList;
    };

    _this.changeView = function (record) {
      var keyArray = _this.state.keyArray;
      var setMenu = _this.props.GlobalSearchStore.setMenu;

      keyArray.push(record);
      setMenu('QDB');
    };

    _this.cancelView = function (record) {
      var keyArray = _this.state.keyArray;
      var setMenu = _this.props.GlobalSearchStore.setMenu;

      keyArray.splice(keyArray.findIndex(function (item) {
        return item === record;
      }), 1);
      setMenu('QDB');
    };

    _this.getQAResultListDom = function () {
      var _this$props$GlobalSea4 = _this.props.GlobalSearchStore,
          QAsearchResultList = _this$props$GlobalSea4.QAsearchResultList,
          language = _this$props$GlobalSea4.language,
          organizationId = _this$props$GlobalSea4.organizationId,
          organizationName = _this$props$GlobalSea4.organizationName,
          menu = _this$props$GlobalSea4.menu,
          name = _this$props$GlobalSea4.organizationName,
          type = _this$props$GlobalSea4.type;

      var resultList = [];
      var contentId = _this.state.contentId;

      QAsearchResultList && QAsearchResultList.length && QAsearchResultList.map(function (item) {
        var answer = item.answer;

        var paraTitleElement = _this.getQAParagrapthTitleDom(item);
        var commentElement = _this.getQuestionFoot(item.creationDate, item.categoryName);
        var image = [];
        var jsonContent = '';
        var cfg = {};
        var answerCopy = (0, _utils.isJSON)(answer) ? answer : '{}';
        jsonContent = JSON.parse(answerCopy);
        /*      jsonContent.map((v, index) => {
          if (index === 0) {
            repalceContent.push({ insert: JSON.stringify(v.insert).replace(/↵/g, '') });
            console.log(repalceContent);
          } else {
            repalceContent = repalceContent.push(v);
            console.log('123123', repalceContent);
          }
        }); */

        var htmlContents = '';
        if (jsonContent.length > 1) {
          jsonContent.map(function (v, index) {
            var htmlContent = new _quillDeltaToHtml.QuillDeltaToHtmlConverter(jsonContent, cfg).convert();
            if (v.insert.image) {
              image.push(_react2['default'].createElement(
                'span',
                { style: { marginRight: 20, cursor: 'pointer' } },
                _react2['default'].createElement('img', { src: v.insert.image, width: '100px', height: '62px' })
              ));
              htmlContents = htmlContent.replace(/\<img[^>]*>/g, '<img src="' + _img2['default'] + '" id="logoId" width="15px" style="vertical-align: sub; margin-left: 5px; margin-right: 5px "/><span style=\'color: #2196F3; cursor: pointer; font-size: 14px; font-family: PingFangSC-Regular;\' id=\'noImg\' class=' + v.insert.image + '>' + language[PREFIX + 'viewImage'] + '</span>');
            }
          });
        } else {
          // jsonContent.map((v) => {
          var htmlContent = new _quillDeltaToHtml.QuillDeltaToHtmlConverter(jsonContent, cfg).convert();
          htmlContents = htmlContent;
          // });
        }
        var result = _react2['default'].createElement(
          'div',
          { className: 'paragraph', id: 'paragraph', style: { margin: '0 0px 20px' } },
          paraTitleElement,
          _react2['default'].createElement(
            'div',
            { style: { height: contentId.includes(item.questionId) ? _this.state.keyArray.includes(item.questionId) ? '' : 80 : '', overflow: contentId.includes(item.questionId) ? _this.state.keyArray.includes(item.questionId) ? '' : 'hidden' : '' } },
            _react2['default'].createElement(
              'div',
              { id: 'paragraph-content-' + item.questionId },
              _react2['default'].createElement('div', { className: 'paragraph-content-question', dangerouslySetInnerHTML: { __html: htmlContents } }),
              image
            )
          ),
          _react2['default'].createElement(
            'div',
            {
              className: 'paragraph-content-show',
              style: { cursor: 'pointer', display: contentId.includes(item.questionId) ? _this.state.keyArray.includes(item.questionId) ? 'none' : '' : 'none', color: '#2196F3', fontSize: 12 },
              onClick: _this.changeView.bind(_this, item.questionId)
            },
            language[PREFIX + 'expandAll']
          ),
          _react2['default'].createElement(
            'div',
            {
              style: { cursor: 'pointer', display: _this.state.keyArray.includes(item.questionId) ? '' : 'none', color: '#2196F3', fontSize: 12, marginTop: 10 },
              onClick: _this.cancelView.bind(_this, item.questionId)
            },
            language[PREFIX + 'collapse']
          ),
          commentElement
        );
        resultList.push(result);
      });

      return resultList;
    };

    _this.getParagrapthTitleDom = function (data) {
      var titleCode = data.titleCode,
          titleText = data.titleText,
          id = data.id;
      var _this$props$GlobalSea5 = _this.props.GlobalSearchStore,
          organizationId = _this$props$GlobalSea5.organizationId,
          organizationName = _this$props$GlobalSea5.organizationName,
          menu = _this$props$GlobalSea5.menu,
          name = _this$props$GlobalSea5.organizationName,
          type = _this$props$GlobalSea5.type;


      var param = { type: type, id: organizationId, name: name, organizationId: organizationId };
      var url = '/#/knowledge/detail/' + data.knowledgeId + queryAnd(param);

      if (menu === ORDER) {
        param.eventId = id;
        // param.menu = 'two'
        url = '/#/itsm/event/eventInfo' + queryAnd(param);
      }
      return _react2['default'].createElement(
        'a',
        { target: '_blank', href: url, className: 'paragraph-title h1-color bold' },
        _this.props.GlobalSearchStore.menu === ORDER ? _react2['default'].createElement('span', { className: 'ticket-num', dangerouslySetInnerHTML: { __html: titleCode } }) : null,
        _react2['default'].createElement('span', { dangerouslySetInnerHTML: { __html: titleText } })
      );
    };

    _this.getKmBaseTitleDom = function (data) {
      var titleCode = data.titleCode,
          titleText = data.titleText,
          id = data.id;
      var _this$props$GlobalSea6 = _this.props.GlobalSearchStore,
          organizationId = _this$props$GlobalSea6.organizationId,
          organizationName = _this$props$GlobalSea6.organizationName,
          menu = _this$props$GlobalSea6.menu,
          name = _this$props$GlobalSea6.organizationName,
          type = _this$props$GlobalSea6.type;

      return _react2['default'].createElement(
        'a',
        { className: 'paragraph-title h1-color bold', onClick: function onClick() {
            window.open('#/knowledge/search?type=organization&id=' + _this.organizationId + '&name=' + _this.organizationName + '&organizationId=' + _this.organizationId + '&knowledgeId=' + data.knowledgeId, '_blank');
          } },
        _react2['default'].createElement('span', { dangerouslySetInnerHTML: { __html: titleText } })
      );
    };

    _this.getQAParagrapthTitleDom = function (data) {
      var questionName = data.questionName,
          relatedQuestionList = data.relatedQuestionList;
      var language = _this.props.GlobalSearchStore.language;

      return _react2['default'].createElement(
        _tooltip2['default'],
        {
          overlayClassName: 'global-search-tooltip',
          placement: 'right',
          title: relatedQuestionList.length > 0 ? _react2['default'].createElement(
            'span',
            null,
            _react2['default'].createElement(
              _tag2['default'],
              { style: { backgroundColor: '#FF9500', borderColor: '#FF9500', color: '#FFFFFF', marginLeft: 10, marginTop: 10 } },
              language[PREFIX + 'sameQuestion']
            ),
            _react2['default'].createElement(
              'div',
              { className: 'marker' },
              relatedQuestionList.map(function (v) {
                return _react2['default'].createElement(
                  'li',
                  { className: 'marker-content' },
                  v.questionName
                );
              })
            )
          ) : ''
        },
        _react2['default'].createElement('span', { style: { fontSize: 16, fontFamily: 'PingFangSC-Medium', color: '#020E26' }, dangerouslySetInnerHTML: { __html: questionName } })
      );
    };

    _this.getOrderTypeIconDom = function (type) {
      type = type.toUpperCase();
      if (type === 'INCIDENT') {
        return _incident3x2['default'];
      } else if (type === 'TASK') {
        return _task3x2['default'];
      } else if (type === 'SERVICE_REQUEST') {
        return _service3x2['default'];
      } else if (type === 'PROBLEM') {
        return _problem3x2['default'];
      } else if (type === 'CHANGE') {
        return _change3x2['default'];
      } else {
        return _other3x2['default'];
      }
    };

    _this.getBitDomElement = function (label, value, color, icon) {
      var style = { background: 'inherit' };
      if (color) {
        style = { padding: '0 5px', color: '#fff', borderRadius: '3px', fontSize: '12px', background: color };
      }
      return _react2['default'].createElement(
        'div',
        { className: 'order-type-wrap-item', style: { width: '18%', marginRight: '2%' } },
        _react2['default'].createElement(
          'span',
          { className: 'label-color', style: { width: 68, flexShrink: 0 } },
          label
        ),
        icon ? _react2['default'].createElement('img', { style: { width: 18, height: 18, marginRight: 5 }, src: icon }) : null,
        _react2['default'].createElement('span', { className: 'h1-color ell', dangerouslySetInnerHTML: { __html: value }, style: style })
      );
    };

    _this.getBitDom = function (item) {
      var getBitDomElement = _this.getBitDomElement;
      var language = _this.props.GlobalSearchStore.language;

      return _react2['default'].createElement(
        'div',
        { className: 'order-type-wrap' },
        getBitDomElement(language[PREFIX + 'project'], item.project || '无'),
        getBitDomElement(language[PREFIX + 'ticketType'], item.orderType || '无', null, _this.getOrderTypeIconDom(item.orderTypesType)),
        getBitDomElement(language[PREFIX + 'status'], item.status || '无', item.statusColor)
      );
    };

    _this.getBitDom1 = function (item) {
      var getBitDomElement = _this.getBitDomElement;
      var language = _this.props.GlobalSearchStore.language;

      return _react2['default'].createElement(
        'div',
        { className: 'order-type-wrap' },
        getBitDomElement(language[PREFIX + 'ticketCreator'] || '提单人', item.creator || '无'),
        getBitDomElement(language[PREFIX + 'ticketCreatorGroup'] || '提单组', item.createEmployeeGroupName || '无'),
        getBitDomElement(language[PREFIX + 'handlor'], item.handlor || '无'),
        getBitDomElement(language[PREFIX + 'handlorGroup'] || '处理组', item.handleGroupName || '无'),
        getBitDomElement(language[PREFIX + 'ticketCreateAt'] || '提单时间', item.createAt || '无')
      );
    };

    _this.getOrderDetailRowDom = function (label, value) {
      return _react2['default'].createElement(
        'div',
        { className: 'jflex f12 jpt5 tl', style: { fontWeight: 300 } },
        _react2['default'].createElement(
          'div',
          { className: 'label-color', style: { width: '60px', flexShrink: 0 } },
          label,
          '\uFF1A'
        ),
        _react2['default'].createElement('div', { className: 'text-color', dangerouslySetInnerHTML: { __html: value } })
      );
    };

    _this.getServiceResultListDom = function () {
      var _this$props$GlobalSea7 = _this.props.GlobalSearchStore,
          searchResultList = _this$props$GlobalSea7.searchResultList,
          language = _this$props$GlobalSea7.language;
      var getBitDom = _this.getBitDom,
          getBitDom1 = _this.getBitDom1,
          getCommentDom = _this.getCommentDom,
          getParagrapthTitleDom = _this.getParagrapthTitleDom,
          getOrderDetailRowDom = _this.getOrderDetailRowDom;

      var resultElements = [];

      searchResultList && searchResultList.map(function (item) {
        var description = item.description,
            reason = item.reason,
            solution = item.solution,
            reply = item.reply;

        var paraTitleElement = getParagrapthTitleDom(item);
        var titleRowElement = getBitDom(item);
        var titleRowElement1 = getBitDom1(item);
        var commentElement = getCommentDom(item.creator, item.createAt, item);

        var result = _react2['default'].createElement(
          'div',
          { className: 'paragraph jpb20', style: { margin: '0 0 20px' } },
          paraTitleElement,
          titleRowElement,
          titleRowElement1,
          description && getOrderDetailRowDom(language[PREFIX + 'description'], description),
          reason && getOrderDetailRowDom(language[PREFIX + 'reason'], reason),
          solution && getOrderDetailRowDom(language[PREFIX + 'solution'], solution),
          reply && getOrderDetailRowDom(language[PREFIX + 'reply'], reply)
        );
        resultElements.push(result);
      });

      return resultElements;
    };

    _this.getNoDataDom = function () {
      var language = _this.props.GlobalSearchStore.language;

      if (_this.props.GlobalSearchStore.loading) {
        return;
      }
      return _react2['default'].createElement(
        'div',
        { className: 'tc jpb20' },
        language[PREFIX + 'noData']
      );
    };

    _this.getPageDom = function () {
      var menu = _this.props.GlobalSearchStore.menu;


      if (menu === ORDER) {
        var _this$props$GlobalSea8 = _this.props.GlobalSearchStore,
            serviceOrderCounts = _this$props$GlobalSea8.serviceOrderCounts,
            setPage = _this$props$GlobalSea8.setPage,
            setPageSize = _this$props$GlobalSea8.setSize,
            searchResultList = _this$props$GlobalSea8.searchResultList;

        if (!searchResultList || !searchResultList.length) {
          return _this.getNoDataDom();
        }
        return _react2['default'].createElement(
          'div',
          { className: 'jflex-end-center jpb20' },
          _react2['default'].createElement(_pagination2['default'], {
            hideOnSinglePage: true,
            total: serviceOrderCounts,
            showSizeChanger: true,
            current: _this.state.current,
            defaultPageSize: 10,
            onChange: function onChange(page, pageSize) {
              _this.setState({
                current: page
              }, function () {
                return setPage(_this.state.current);
              });
            },
            onShowSizeChange: function onShowSizeChange(current, size) {
              setPageSize(size);
            }
          })
        );
      } else if (menu === KDB) {
        var _this$props$GlobalSea9 = _this.props.GlobalSearchStore,
            knowledgeCounts = _this$props$GlobalSea9.knowledgeCounts,
            setThePage = _this$props$GlobalSea9.setThePage,
            setTheSize = _this$props$GlobalSea9.setThePageSize,
            kwlgResultList = _this$props$GlobalSea9.kwlgResultList;

        if (!kwlgResultList || !kwlgResultList.length) {
          return _this.getNoDataDom();
        }
        return _react2['default'].createElement(
          'div',
          { className: 'jflex-end-center jpb20' },
          _react2['default'].createElement(_pagination2['default'], {
            hideOnSinglePage: true,
            total: knowledgeCounts,
            showSizeChanger: true,
            onChange: function onChange(page, pageSize) {
              _this.setState({
                current: page
              }, function () {
                return setThePage(_this.state.current);
              });
            },
            onShowSizeChange: function onShowSizeChange(current, size) {
              setTheSize(size);
            }
          })
        );
      } else {
        var _this$props$GlobalSea10 = _this.props.GlobalSearchStore,
            QASearchCounts = _this$props$GlobalSea10.QASearchCounts,
            setQApage = _this$props$GlobalSea10.setQApage,
            _setTheSize = _this$props$GlobalSea10.setThePageSize,
            QAsearchResultList = _this$props$GlobalSea10.QAsearchResultList;

        if (!QAsearchResultList || !QAsearchResultList.length) {
          return _this.getNoDataDom();
        }
        return _react2['default'].createElement(
          'div',
          { className: 'jflex-end-center jpb20' },
          _react2['default'].createElement(_pagination2['default'], {
            hideOnSinglePage: true,
            total: QASearchCounts,
            showSizeChanger: true,
            onChange: function onChange(page, pageSize) {
              _this.setState({
                current: page
              }, function () {
                return setQApage(_this.state.current);
              });
            },
            onShowSizeChange: function onShowSizeChange(current, size) {
              _setTheSize(size);
            }
          })
        );
      }
    };

    _this.getKnowledgeFieldListDom = function () {
      var _this$props$GlobalSea11 = _this.props.GlobalSearchStore,
          menu = _this$props$GlobalSea11.menu,
          theSearchField = _this$props$GlobalSea11.theSearchField,
          theSearchRange = _this$props$GlobalSea11.theSearchRange,
          theSearchSource = _this$props$GlobalSea11.theSearchSource,
          theSearchAccurcy = _this$props$GlobalSea11.theSearchAccurcy,
          setTheSearchField = _this$props$GlobalSea11.setTheSearchField,
          setTheSearchRange = _this$props$GlobalSea11.setTheSearchRange,
          setTheSearchSource = _this$props$GlobalSea11.setTheSearchSource,
          setTheSearchAccurcy = _this$props$GlobalSea11.setTheSearchAccurcy,
          setTheBeginAt = _this$props$GlobalSea11.setTheBeginAt,
          setTheEndAt = _this$props$GlobalSea11.setTheEndAt,
          language = _this$props$GlobalSea11.language;
      var showField = _this.state.showField;

      if (menu === ORDER) {
        return;
      }
      if (menu === QDB) {
        return;
      }

      if (!showField) {
        return;
      }

      var rowElements = function rowElements(labelElement, list, selectValue, setFunc) {
        return _react2['default'].createElement(
          'ul',
          { key: list.id, className: 'jflex-start-center field-ul' },
          labelElement,
          list && list.map(function (item, index) {
            return _react2['default'].createElement(
              'li',
              null,
              _react2['default'].createElement(
                _button2['default'],
                {
                  className: 'field-li ' + (item.id === selectValue ? 'field-li-checked' : '') + ' ',
                  id: item.id,
                  onClick: function onClick() {
                    setFunc(item.id);
                  }
                },
                language[PREFIX + item.name]
              )
            );
          })
        );
      };
      var dateRowElements = function dateRowElements(labelElement) {
        return _react2['default'].createElement(
          'ul',
          { key: 'range_ul', className: 'jflex-start-center field-ul' },
          labelElement,
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(RangePicker, {
              className: 'field-li',
              format: 'YYYY-MM-DD',
              placeholder: [language[PREFIX + 'createAt'], language[PREFIX + 'endAt']],
              onChange: function onChange(valueArr) {
                setTheBeginAt(valueArr[0]);
                setTheEndAt(valueArr[1]);
              }
            })
          )
        );
      };

      var labelElements = [];
      _globalSearch.knowSearchTypeList.map(function (item) {
        labelElements.push(_react2['default'].createElement(
          'li',
          { id: item.id, className: 'label-li' },
          language[PREFIX + item.name]
        ));
      });

      var i = 0;
      var listArr = [_globalSearch.searchFieldList, _globalSearch.searchRangeList, _globalSearch.sourceList, _globalSearch.searchTypeList];
      var valueArr = [theSearchField, theSearchRange, theSearchSource, theSearchAccurcy];
      var setArr = [setTheSearchField, setTheSearchRange, setTheSearchSource, setTheSearchAccurcy];
      return _react2['default'].createElement(
        'div',
        { className: 'field-wrap' },
        rowElements(labelElements[i], listArr[i], valueArr[i], setArr[i++]),
        rowElements(labelElements[i], listArr[i], valueArr[i], setArr[i++]),
        rowElements(labelElements[i], listArr[i], valueArr[i], setArr[i++]),
        rowElements(labelElements[i], listArr[i], valueArr[i], setArr[i++]),
        dateRowElements(labelElements[i])
      );
    };

    _this.getSwitchButtonDom = function () {
      var _this$props$GlobalSea12 = _this.props.GlobalSearchStore,
          menu = _this$props$GlobalSea12.menu,
          language = _this$props$GlobalSea12.language;
      var showField = _this.state.showField;


      if (menu !== KDB) return;
      return _react2['default'].createElement(
        _button2['default'],
        {
          type: !showField ? '' : 'primary',
          funcType: 'raised',
          icon: !showField ? 'expand_more' : 'expand_less',
          onClick: function onClick() {
            _this.setState({ showField: !showField });
          }
        },
        language[PREFIX + 'filter']
      );
    };

    _this.getLoadingDom = function () {
      if (_this.props.GlobalSearchStore.loading) {
        return _react2['default'].createElement(
          'div',
          { style: { position: 'absolute', top: '20px', left: '50%', margin: '0 -25px' } },
          _react2['default'].createElement(_progress2['default'], { type: 'loading' })
        );
      }
    };

    _this.getContentDom = function () {
      var sortListElements = _this.getSortListDom();
      var switchButtonElements = _this.getSwitchButtonDom();
      var knowledgeFieldListElements = _this.getKnowledgeFieldListDom();
      var loadingElement = _this.getLoadingDom();
      var pageElements = _this.getPageDom();
      var menu = _this.props.GlobalSearchStore.menu;

      var color = '';
      if (_this.props.GlobalSearchStore.menu === ORDER) {
        color = '#CCD3D9';
      } else if (_this.props.GlobalSearchStore.menu === KDB) {
        color = '#fff';
      } else {
        color = '#CCD3D9';
      }
      return _react2['default'].createElement(
        'div',
        { className: 'search-content' },
        _react2['default'].createElement(
          'div',
          { className: 'jflex-wrap jpb10' },
          _react2['default'].createElement(
            'ul',
            { className: 'jflex-start-center sort-wrap', style: { flexGrow: 1, borderBottom: '1px solid ' + color } },
            sortListElements
          ),
          switchButtonElements
        ),
        knowledgeFieldListElements,
        _react2['default'].createElement(
          'div',
          { className: 'search-content-main', style: { position: 'relative' } },
          loadingElement,
          _react2['default'].createElement(
            'div',
            { style: { display: menu === ORDER ? 'inherit' : 'none' } },
            _this.getServiceResultListDom()
          ),
          _react2['default'].createElement(
            'div',
            { style: { display: menu === KDB ? 'inherit' : 'none' } },
            _this.getKnowledgeResultListDom()
          ),
          _react2['default'].createElement(
            'div',
            { style: { display: menu === QDB ? 'inherit' : 'none' } },
            _this.getQAResultListDom()
          ),
          pageElements
        )
      );
    };

    _this.getHotAreaDom = function () {
      if (_this.props.GlobalSearchStore.hot === 1) {
        var language = _this.props.GlobalSearchStore.language;

        return _react2['default'].createElement(
          'div',
          { className: 'hot-area' },
          _react2['default'].createElement(
            'div',
            { className: 'hot-area-title' },
            language[PREFIX + 'hot']
          ),
          _react2['default'].createElement('div', { className: 'hot-area-main' })
        );
      }
    };

    _this.onkeydown = function (e) {
      var keynum = void 0;
      if (window.event) {
        keynum = e.keyCode;
      } else if (e.which) {
        keynum = e.which;
      }
      if (keynum === 13) {
        _this.props.GlobalSearchStore.loadAll(false);
      }
    };

    _this.close = function () {
      _this.setState({
        showClose: false
      });
    };

    _this.reset = function () {
      _this.props.GlobalSearchStore.setSearchText('');
      _this.close();
    };

    _this.getHeaderDom = function () {
      var _this$props$GlobalSea13 = _this.props.GlobalSearchStore,
          searchText = _this$props$GlobalSea13.searchText,
          setSearchText = _this$props$GlobalSea13.setSearchText,
          checkPage = _this$props$GlobalSea13.checkPage,
          language = _this$props$GlobalSea13.language;

      return _react2['default'].createElement(
        'header',
        { className: 'global-search' },
        _react2['default'].createElement(
          'div',
          { className: 'jinput jflex-start-center' },
          _react2['default'].createElement(_icon2['default'], { type: 'search', style: { fontSize: 24, color: '#818999', cursor: 'pointer' }, onClick: function onClick(e) {
              return checkPage();
            } }),
          _react2['default'].createElement('input', {
            id: 'search',
            value: searchText,
            placeholder: language[PREFIX + 'searchFocus'],
            type: 'text',
            autoComplete: 'off',
            onChange: function onChange(e) {
              setSearchText(e.target.value);
              if (!e.target.value) {
                _this.setState({
                  showClose: false
                });
              } else {
                _this.setState({ showClose: true });
              }
            },
            onKeyDown: function onKeyDown(e) {
              return _this.onkeydown(e);
            }
          }),
          _this.state.showClose ? _react2['default'].createElement(_icon2['default'], { type: 'cancel', style: { fontSize: 24, color: '#818999', cursor: 'pointer' }, onClick: function onClick(e) {
              return _this.reset();
            } }) : null
        )
      );
    };

    _this.getTabMenuDom = function () {
      var _this$props$GlobalSea14 = _this.props.GlobalSearchStore,
          serviceOrderCounts = _this$props$GlobalSea14.serviceOrderCounts,
          knowledgeCounts = _this$props$GlobalSea14.knowledgeCounts,
          QASearchCounts = _this$props$GlobalSea14.QASearchCounts,
          menu = _this$props$GlobalSea14.menu,
          setMenu = _this$props$GlobalSea14.setMenu,
          language = _this$props$GlobalSea14.language;

      return _react2['default'].createElement(
        'section',
        null,
        _react2['default'].createElement(
          _menu2['default'],
          {
            onClick: function onClick(_ref) {
              var key = _ref.key;

              _this.setState({
                current: 1
              });
              setMenu(key);
            },
            selectedKeys: [menu],
            mode: 'horizontal'
          },
          _react2['default'].createElement(
            _menu2['default'].Item,
            { key: '' + ORDER, className: ' f18' },
            language[PREFIX + 'serviceOrder'],
            serviceOrderCounts ? '\uFF08' + serviceOrderCounts + '\uFF09' : null
          ),
          _react2['default'].createElement(
            _menu2['default'].Item,
            { key: '' + KDB, className: 'jmr20 f18' },
            language[PREFIX + 'knowledgeBase'],
            knowledgeCounts ? '\uFF08' + knowledgeCounts + '\uFF09' : null
          ),
          _react2['default'].createElement(
            _menu2['default'].Item,
            { key: '' + QDB, className: 'jmr20 f18' },
            language[PREFIX + 'questionBase'],
            QASearchCounts ? '\uFF08' + QASearchCounts + '\uFF09' : null
          )
        )
      );
    };

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.organizationName = _this.props.AppState.currentMenuType.name;
    _this.userInfo = _this.props.AppState.userInfo;
    _this.props.GlobalSearchStore.setUserInfo(_this.userInfo);
    _this.state = {
      showField: false,
      showClose: false,
      open: false,
      src: '',
      keyArray: [],
      contentId: [], // 存入问答库列表的id值
      current: 1
    };
    return _this;
  }

  (0, _createClass3['default'])(GlobalSearchHome, [{
    key: 'setLanguage',
    value: function setLanguage() {
      var _props = this.props,
          AppState = _props.AppState,
          GlobalSearchStore = _props.GlobalSearchStore;

      var languageKeyFields = _language2['default'].getLanguage();
      GlobalSearchStore.queryLanguage(GlobalSearchStore.organizationId, null, languageKeyFields);
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var isNoApiSearch = !!this.fromPageSetting();
      this.setLanguage();
      this.props.GlobalSearchStore.loadAll(isNoApiSearch);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var QAsearchResultList = this.props.GlobalSearchStore.QAsearchResultList;

      QAsearchResultList.forEach(function (item) {
        var contentHeight = document.getElementById('paragraph-content-' + item.questionId);
        if (contentHeight) {
          var contentSize = contentHeight.offsetHeight - 62;
          if (contentSize >= 42) {
            _this2.state.contentId.push(item.questionId);
          }
        }
      });
      this.showBigImg();
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate() {
      var _this3 = this;

      var QAsearchResultList = this.props.GlobalSearchStore.QAsearchResultList;

      QAsearchResultList.forEach(function (item) {
        var contentHeight = document.getElementById('paragraph-content-' + item.questionId);
        if (contentHeight) {
          var contentSize = contentHeight.offsetHeight - 62;
          if (contentSize >= 42) {
            _this3.state.contentId.push(item.questionId);
          }
        }
      });
    }

    // 图片放大缩小

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('click', this.hello);
    }

    // url默认数据提取

  }, {
    key: 'fromPageSetting',
    value: function fromPageSetting() {
      var query = '';
      var hot = '';
      var data = _queryString2['default'].parse(location.href.split('?')[1]);
      this.props.GlobalSearchStore.setMenu(data.menu);
      this.props.GlobalSearchStore.setSearchText(data.query);
      this.props.GlobalSearchStore.setOrganizationId(data.id);
      this.props.GlobalSearchStore.setOrganizationName(data.name);
      this.props.GlobalSearchStore.setType(data.type);

      if (data.query) {
        this.setState({
          showClose: true
        });
      }
      return data.noApi; // 默认为空 如果有值 则默认加载不搜索页面
    }

    // 排序动作


    // 排序条件列表


    // 标签列表


    // 头像


    // 评论区


    // 问答库区显示时间和分类


    // 知识库搜索结果列表


    // 问答库搜索结果列表


    // 段落标题


    /** 知识库标题 */


    // 问答库标题


    // 单据类型图标


    // 服务单分类条目项


    // 服务单分类条目


    // 服务单分类条目 第二行


    // 服务单显示条目


    // 服务单搜索结果列表


    // 暂无数据


    // 分页条


    // 知识库展示条件区域


    // 展开按钮


    // 加载样式


    // 搜索结果 + 分页条


    // 热门搜索


    // 回车搜索


    // 头部搜索


    // tab切换菜单

  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var headerElements = this.getHeaderDom();
      var tabMenuElements = this.getTabMenuDom();
      var contentElements = this.getContentDom();
      var hotAreaElements = this.getHotAreaDom();
      var _props$GlobalSearchSt = this.props.GlobalSearchStore,
          searchResultList = _props$GlobalSearchSt.searchResultList,
          language = _props$GlobalSearchSt.language;

      if (this.props.GlobalSearchStore.queryNull) {
        Choerodon.prompt('请输入查询内容');
      }

      if (!language['organization.globalsearch.itsm']) {
        return _react2['default'].createElement(
          'div',
          { style: { position: 'absolute', top: '50%', left: '50%', margin: '-25px' } },
          _react2['default'].createElement(_progress2['default'], { type: 'loading' })
        );
      }

      return _react2['default'].createElement(
        _index.Page,
        {
          service: ['yqcloud-itsm-service.elastic.selectEvent', 'yqc-biz-km.km-search.queryMatchAnyOne']
        },
        _react2['default'].createElement(
          'div',
          {
            className: 'j-container',
            style: {
              height: '100%',
              overflowY: 'scroll',
              overflowX: 'hidden'
            }
          },
          headerElements,
          tabMenuElements,
          _react2['default'].createElement(
            'section',
            { className: 'jflex jpt20 jpb20' },
            contentElements,
            hotAreaElements
          )
        ),
        this.state.open ? _react2['default'].createElement(_reactViewer2['default'], {
          visible: true,
          loop: false,
          changeable: false,
          onClose: function onClose() {
            _this4.setState({ open: false });
          },
          images: [{ src: this.state.src, alt: 'images' }]
        }) : null
      );
    }
  }]);
  return GlobalSearchHome;
}(_react.Component)) || _class) || _class);
exports['default'] = GlobalSearchHome;