'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _MenuType = require('./MenuType');

var _MenuType2 = _interopRequireDefault(_MenuType);

var _Logo = require('./Logo');

var _Logo2 = _interopRequireDefault(_Logo);

var _Setting = require('./Setting');

var _Setting2 = _interopRequireDefault(_Setting);

var _portalEnter = require('./portalEnter');

var _portalEnter2 = _interopRequireDefault(_portalEnter);

var _UserPreferences = require('./UserPreferences');

var _UserPreferences2 = _interopRequireDefault(_UserPreferences);

require('./style');

var _Inbox = require('./Inbox');

var _Inbox2 = _interopRequireDefault(_Inbox);

var _SearchBox = require('./SearchBox');

var _SearchBox2 = _interopRequireDefault(_SearchBox);

var _TaskCenter = require('./TaskCenter');

var _TaskCenter2 = _interopRequireDefault(_TaskCenter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Header = (_dec = (0, _mobxReact.inject)('AppState', 'HeaderStore', 'MenuStore'), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(Header, _Component);

  function Header() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, (_ref = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref, [this].concat(args))), _this), _this.loadLanguage = function () {
      var _this$props = _this.props,
          AppState = _this$props.AppState,
          HeaderStore = _this$props.HeaderStore;

      HeaderStore.queryLanguage(AppState.userInfo.currentOrganizationId, AppState.currentLanguage);
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  (0, _createClass3['default'])(Header, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          AppState = _props.AppState,
          HeaderStore = _props.HeaderStore;

      HeaderStore.getOrganizations(AppState.userInfo.currentOrganizationId).then(function (item) {
        if (item.typeCode !== 'PUBLIC') {
          document.title = item.name;
        }
      });
      this.loadLanguage();
      var MenuStore = this.props.MenuStore;

      MenuStore.loadMenuData({ type: 'site' }, false);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props2 = this.props,
          AppState = _props2.AppState,
          HeaderStore = _props2.HeaderStore,
          MenuStore = _props2.MenuStore;
      // MenuStore.loadMenuData({ type: 'site' }, false);

      HeaderStore.axiosGetOrgAndPro(AppState.getUserId);
    }

    // 获取语言

  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          AppState = _props3.AppState,
          MenuStore = _props3.MenuStore;

      var type = AppState.getType || sessionStorage.type;
      var menuTypeStyle = (0, _classnames2['default'])({
        'masterHead-hoverMaster': true,
        'masterHead-menuType': true,
        'masterHead-menuType-showBG': type !== 'site',
        'masterHead-menuType-hideBG': type === 'site'
      });
      var logoStyle = (0, _classnames2['default'])({
        'masterHead-hoverMaster': true,
        'masterHead-logo-wrap': true,
        'masterHead-menuType-showBG': type === 'site',
        'masterHead-menuType-hideBG': type !== 'site'
      });
      var imgUrl = void 0;
      var data = AppState.getUserInfo;
      if (data) {
        imgUrl = data.image_url;
      }
      return _react2['default'].createElement(
        'div',
        { className: 'master-head-wrap' },
        _react2['default'].createElement(
          'div',
          { className: 'master-head-left' },
          _react2['default'].createElement(_Logo2['default'], { history: this.props.history })
        ),
        _react2['default'].createElement(
          'ul',
          { className: 'master-head-center' },
          _react2['default'].createElement(
            'li',
            { className: menuTypeStyle },
            _react2['default'].createElement(_MenuType2['default'], null)
          ),
          MenuStore.getSiteMenuData.length > 0 && _react2['default'].createElement(
            'li',
            { className: logoStyle },
            _react2['default'].createElement(_Setting2['default'], null)
          ),
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(_portalEnter2['default'], null)
          )
        ),
        type !== 'site' && _react2['default'].createElement(_SearchBox2['default'], null),
        _react2['default'].createElement(
          'ul',
          { className: 'master-head-right' },
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(_TaskCenter2['default'], null)
          ),
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(_Inbox2['default'], null)
          ),
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(_UserPreferences2['default'], { imgUrl: imgUrl })
          )
        )
      );
    }
  }]);
  return Header;
}(_react.Component)) || _class) || _class);
exports['default'] = Header;