'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style8 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style9 = require('yqcloud-ui/lib/input/style');

var _input = require('yqcloud-ui/lib/input');

var _input2 = _interopRequireDefault(_input);

var _style10 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style11 = require('yqcloud-ui/lib/table/style');

var _table = require('yqcloud-ui/lib/table');

var _table2 = _interopRequireDefault(_table);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _style12 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style13 = require('yqcloud-ui/lib/select/style');

var _select = require('yqcloud-ui/lib/select');

var _select2 = _interopRequireDefault(_select);

var _style14 = require('yqcloud-ui/lib/tabs/style');

var _tabs = require('yqcloud-ui/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactRouterDom = require('react-router-dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _mobx = require('mobx');

var _findFirstLeafMenu2 = require('../util/findFirstLeafMenu');

var _findFirstLeafMenu3 = _interopRequireDefault(_findFirstLeafMenu2);

var _common = require('../../common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabPane = _tabs2['default'].TabPane;
var Option = _select2['default'].Option;


var intlPrefix = 'organization.header';

var MenuType = (_dec = (0, _mobxReact.inject)('AppState', 'HeaderStore', 'MenuStore'), (0, _reactRouterDom.withRouter)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(MenuType, _Component);

  function MenuType(props) {
    (0, _classCallCheck3['default'])(this, MenuType);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (MenuType.__proto__ || Object.getPrototypeOf(MenuType)).call(this, props));

    _this.showModal = function () {
      var HeaderStore = _this.props.HeaderStore;

      HeaderStore.setSelected(null);
      HeaderStore.setMenuTypeVisible(true);
      _this.setState({
        searchValue: '',
        handlesearch: false
      });
    };

    _this.handleOk = function () {
      var HeaderStore = _this.props.HeaderStore;

      HeaderStore.setMenuTypeVisible(false);
      _this.selectState(HeaderStore.getSelected);
    };

    _this.handleCancel = function () {
      _this.props.HeaderStore.setMenuTypeVisible(false);
    };

    _this.handleChange = function (value) {
      _this.setState({
        filterOrganization: value,
        activeKey: null
      });
    };

    _this.handleTabChange = function (activeKey) {
      _this.setState({
        activeKey: activeKey
      });
    };

    _this.searchInput = function (e) {
      _this.setState({
        searchValue: e.target.value
      });
    };

    _this.searchChange = function () {
      var searchValue = _this.state.searchValue;

      _this.setState({
        handlesearch: !!searchValue
      });
    };

    _this.selectState = function (value) {
      var _this$props = _this.props,
          AppState = _this$props.AppState,
          HeaderStore = _this$props.HeaderStore,
          MenuStore = _this$props.MenuStore,
          history = _this$props.history;
      var id = value.id,
          name = value.name,
          type = value.type,
          organizationId = value.organizationId;


      AppState.loadUserInfoByOrganizationId(id).then(function (res) {
        AppState.setUserInfo(res);

        HeaderStore.setRecentItem(value);
        MenuStore.loadMenuData({ type: type, id: id }, false).then(function (menus) {
          var route = void 0;
          var path = void 0;
          var domain = void 0;
          if (_common.dashboard) {
            route = '/';
          } else if (menus.length) {
            var _findFirstLeafMenu = (0, _findFirstLeafMenu3['default'])(menus[0]),
                menuRoute = _findFirstLeafMenu.route,
                menuDomain = _findFirstLeafMenu.domain;

            route = menuRoute;
            domain = menuDomain;
          }
          if (route) {
            path = route + '?type=' + type + '&id=' + id + '&name=' + name;
            if (organizationId) {
              path += '&organizationId=' + organizationId;
            }
          }
          if (path) {
            (0, _common.historyPushMenu)(history, path, domain);
            document.location.reload();
          }
        });
        AppState.setMenuExpanded(false);
        HeaderStore.setMenuTypeVisible(false);
      });
    };

    _this.handleExpand = function (record) {
      var _this$state = _this.state,
          expandRowKey = _this$state.expandRowKey,
          collapseRowKey = _this$state.collapseRowKey,
          handlesearch = _this$state.handlesearch;

      var keys = handlesearch ? collapseRowKey : expandRowKey;
      var key = record.key;

      var index = keys.indexOf(key);
      if (index !== -1) {
        keys.splice(index, 1);
      } else {
        keys.push(key);
      }
      _this.setState({
        expandRowKey: expandRowKey,
        collapseRowKey: collapseRowKey
      });
    };

    _this.handleReturnButtonClick = function () {
      _this.setState({
        searchValue: '',
        handlesearch: false
      });
    };

    _this.state = {
      filterOrganization: '',
      searchValue: '',
      handlesearch: false,
      expandRowKey: [],
      collapseRowKey: [],
      activeKey: null
    };
    return _this;
  }

  (0, _createClass3['default'])(MenuType, [{
    key: 'componentWillMount',
    value: function componentWillMount() {}

    // 展示modal


    // 确认模态框


    // 取消模态框


    // select 选择


    // search 搜索


    // 选择租户数据

  }, {
    key: 'renderDefaultExpandAllRows',
    value: function renderDefaultExpandAllRows(dataSource) {
      var _state = this.state,
          filterOrganization = _state.filterOrganization,
          expandRowKey = _state.expandRowKey,
          collapseRowKey = _state.collapseRowKey,
          handlesearch = _state.handlesearch;

      if (handlesearch) {
        return dataSource.map(function (data) {
          return data.key;
        }).filter(function (key) {
          return collapseRowKey.indexOf(key) === -1;
        });
      } else if (filterOrganization !== '' && filterOrganization !== 'total') {
        return dataSource.length ? [dataSource[0].key] : [];
      } else {
        return expandRowKey;
      }
    }
  }, {
    key: 'renderTable',
    value: function renderTable(dataSource, isNotRecent) {
      var _this2 = this;

      var HeaderStore = this.props.HeaderStore;

      if (dataSource && dataSource.length) {
        var columns = [{
          title: HeaderStore.language[intlPrefix + '.organization.name'],
          dataIndex: 'name',
          key: 'name',
          render: function render(text, record) {
            return record.into === false ? _react2['default'].createElement(
              'span',
              { className: 'menu-type-disabled' },
              text
            ) : _react2['default'].createElement(
              'a',
              {
                role: 'none',
                onClick: _this2.selectState.bind(_this2, record)
              },
              _react2['default'].createElement(_icon2['default'], { type: record.type === 'project' ? 'project' : 'domain' }),
              text
            );
          }
        }, {
          title: HeaderStore.language[intlPrefix + '.organization.code'],
          dataIndex: 'code',
          key: 'code',
          render: function render(text, record) {
            if (record.into === false) {
              return _react2['default'].createElement(
                'span',
                { className: 'menu-type-disabled' },
                text
              );
            }
            return text;
          }
        }, {
          title: HeaderStore.language[intlPrefix + '.organization.type'],
          dataIndex: 'type',
          key: 'type',
          render: function render(text, record) {
            if (record.into === false) {
              return _react2['default'].createElement(
                'span',
                { className: 'menu-type-disabled' },
                text === 'organization' ? HeaderStore.language[intlPrefix + '.organization'] : ''
              );
            }
            return text === 'organization' ? HeaderStore.language[intlPrefix + '.organization'] : '';
          }
        }];
        var selected = HeaderStore.getSelected;
        var rowSelection = {
          type: 'radio',
          onSelect: function onSelect(record) {
            HeaderStore.setSelected(record);
          },
          selectedRowKeys: selected ? [selected.key] : [],
          hideDefaultSelections: true
        };
        var props = {};
        if (isNotRecent) {
          props = {
            expandedRowKeys: this.renderDefaultExpandAllRows(dataSource),
            onExpand: function onExpand(expanded, record) {
              _this2.handleExpand(record);
            }
          };
        }
        var onTableRow = function onTableRow(record) {
          if (record.into === false) {
            return {};
          }
          return {
            onDoubleClick: function onDoubleClick() {
              _this2.selectState(record);
            },
            onClick: function onClick() {
              HeaderStore.setSelected(record);
              if (isNotRecent) {
                _this2.handleExpand(record);
              }
            }
          };
        };
        return _react2['default'].createElement(_table2['default'], (0, _extends3['default'])({
          columns: columns,
          dataSource: dataSource,
          filterBar: false,
          onRow: onTableRow,
          pagination: false,
          rowSelection: rowSelection
        }, props));
      } else {
        return _react2['default'].createElement(
          'div',
          { className: 'menu-type-empty' },
          isNotRecent ? HeaderStore.language[intlPrefix + '.organization.role.msg'] : HeaderStore.language[intlPrefix + '.organization.null.record']
        );
      }
    }
  }, {
    key: 'hitSearch',
    value: function hitSearch(item, value) {
      var name = item.name,
          code = item.code;

      return name.indexOf(value) !== -1 || code.indexOf(value) !== -1;
    }
  }, {
    key: 'getOptionList',
    value: function getOptionList() {
      var HeaderStore = this.props.HeaderStore;

      var org = (0, _mobx.toJS)(HeaderStore.getOrgData);
      return org && org.length > 0 ? [_react2['default'].createElement(
        Option,
        { key: 'total', value: 'total' },
        HeaderStore.language[intlPrefix + '.organization.all']
      )].concat(org.map(function (orgOption) {
        return _react2['default'].createElement(
          Option,
          { key: orgOption.id, value: orgOption.id },
          orgOption.name
        );
      })) : _react2['default'].createElement(
        Option,
        { value: 'total' },
        HeaderStore.language[intlPrefix + '.organization.null']
      );
    }
  }, {
    key: 'getCurrentData',
    value: function getCurrentData() {
      var _this3 = this;

      var HeaderStore = this.props.HeaderStore;
      var _state2 = this.state,
          filterOrganization = _state2.filterOrganization,
          handlesearch = _state2.handlesearch,
          searchValue = _state2.searchValue;

      var needFilterOrganization = filterOrganization !== '' && filterOrganization !== 'total';
      var orgData = (0, _mobx.toJS)(HeaderStore.getOrgData);
      var proData = (0, _mobx.toJS)(HeaderStore.getProData);
      if (orgData && proData) {
        return orgData.filter(function (item) {
          var id = item.id;

          if (needFilterOrganization && Number(id) !== Number(filterOrganization)) {
            return false;
          }
          item.key = id;
          item.children = [];
          proData.forEach(function (item2) {
            var id2 = item2.id,
                organizationId = item2.organizationId;

            item2.key = id + ',' + id2;
            if (Number(organizationId) === Number(id) && (!handlesearch || _this3.hitSearch(item2, searchValue))) {
              item.children.push(item2);
            }
          });
          if (!item.children.length) {
            delete item.children;
          }
          if (!item.children && (handlesearch && !_this3.hitSearch(item, searchValue) || item.into === false)) {
            return false;
          }
          return true;
        });
      }
      return orgData;
    }
  }, {
    key: 'render',
    value: function render() {
      var _state3 = this.state,
          handlesearch = _state3.handlesearch,
          searchValue = _state3.searchValue,
          activeKey = _state3.activeKey,
          filterOrganization = _state3.filterOrganization;
      var _props = this.props,
          AppState = _props.AppState,
          HeaderStore = _props.HeaderStore;
      var _AppState$currentMenu = AppState.currentMenuType,
          _AppState$currentMenu2 = _AppState$currentMenu.name,
          selectTitle = _AppState$currentMenu2 === undefined ? HeaderStore.language[intlPrefix + '.select.project'] : _AppState$currentMenu2,
          type = _AppState$currentMenu.type;

      var currentData = this.getCurrentData();
      var visible = HeaderStore.menuTypeVisible,
          recentItem = HeaderStore.getRecentItem;

      var tabSelect = activeKey || (filterOrganization || !recentItem || recentItem.length === 0 ? 'total' : 'recent');
      var modalFooter = [_react2['default'].createElement(
        _button2['default'],
        { key: 'back', onClick: this.handleCancel },
        HeaderStore.language.cancel
      ), _react2['default'].createElement(
        _button2['default'],
        { key: 'submit', type: 'primary', disabled: !HeaderStore.getSelected, onClick: this.handleOk },
        HeaderStore.language.open
      )];
      var returnBtn = void 0;
      var searchClass = '';
      var content = void 0;
      var buttonClass = void 0;
      var buttonIcon = void 0;
      if (type === 'organization') {
        buttonClass = 'active';
        buttonIcon = 'domain';
      } else if (type === 'project') {
        buttonClass = 'active';
        buttonIcon = 'project';
      }
      buttonClass = (0, _classnames2['default'])('menu-type-btn', buttonClass);
      if (handlesearch) {
        returnBtn = _react2['default'].createElement(_button2['default'], {
          funcType: 'raised',
          icon: 'return',
          onClick: this.handleReturnButtonClick
        });
        content = _react2['default'].createElement(
          'div',
          { className: 'table-wrapper' },
          this.renderTable(currentData, true)
        );
        searchClass = 'has-search';
      } else {
        content = _react2['default'].createElement(
          _tabs2['default'],
          { activeKey: tabSelect, onChange: this.handleTabChange },
          _react2['default'].createElement(
            TabPane,
            { tab: HeaderStore.language[intlPrefix + '.organization.recent'], key: 'recent' },
            this.renderTable(recentItem)
          ),
          _react2['default'].createElement(
            TabPane,
            { tab: HeaderStore.language.all, key: 'total' },
            this.renderTable(currentData, true)
          )
        );
      }
      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].createElement(
          _button2['default'],
          {
            className: buttonClass,
            funcType: 'flat',
            onClick: this.showModal
          },
          _react2['default'].createElement(_icon2['default'], { type: buttonIcon }),
          selectTitle,
          _react2['default'].createElement(_icon2['default'], { type: 'arrow_drop_down' })
        ),
        _react2['default'].createElement(
          _modal2['default'],
          {
            title: HeaderStore.language.select,
            className: 'menu-type-modal',
            visible: visible,
            onOk: this.handleOk,
            onCancel: this.handleCancel,
            footer: modalFooter,
            width: 708,
            closable: false,
            center: true
          },
          _react2['default'].createElement(
            'section',
            { className: 'select-and-search ' + searchClass },
            returnBtn,
            _react2['default'].createElement(
              _select2['default'],
              { label: HeaderStore.language[intlPrefix + '.organization'], placeholder: 'Please Select', defaultValue: 'total', onChange: this.handleChange },
              this.getOptionList()
            ),
            _react2['default'].createElement(_input2['default'], {
              prefix: _react2['default'].createElement(_icon2['default'], { type: 'search' }),
              placeholder: HeaderStore.language[intlPrefix + '.search.organization'],
              value: searchValue,
              onChange: this.searchInput,
              onBlur: this.searchChange,
              onPressEnter: this.searchChange
            })
          ),
          content
        )
      );
    }
  }]);
  return MenuType;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = MenuType;