'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style3 = require('yqcloud-ui/lib/progress/style');

var _progress = require('yqcloud-ui/lib/progress');

var _progress2 = _interopRequireDefault(_progress);

var _style4 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactRouterDom = require('react-router-dom');

var _reactWebsocket = require('react-websocket');

var _reactWebsocket2 = _interopRequireDefault(_reactWebsocket);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _SanitizeHtml = require('../../../components/SanitizeHtml');

var _SearchBoxStore = require('../../stores/SearchBoxStore');

var _SearchBoxStore2 = _interopRequireDefault(_SearchBoxStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var lastUpdate = Number(new Date());
var tick = 0;
var intlPrefix = 'organization.searchBox';

var queryAnd = function queryAnd(data) {
  var arr = [];
  for (var key in data) {
    arr.push(key + '=' + data[key]);
  }
  return '?' + arr.join('&');
};

var SearchBox = (_dec = (0, _mobxReact.inject)('SearchBoxStore', 'HeaderStore', 'AppState'), (0, _reactRouterDom.withRouter)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(SearchBox, _Component);

  function SearchBox(props) {
    (0, _classCallCheck3['default'])(this, SearchBox);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (SearchBox.__proto__ || Object.getPrototypeOf(SearchBox)).call(this, props));

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.organizationName = _this.props.AppState.currentMenuType.name;
    _this.state = {
      normal: true,
      showResult: true
    };
    return _this;
  }

  (0, _createClass3['default'])(SearchBox, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.fetch(this.props);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      document.addEventListener('click', function () {
        _this2.setState({ showResult: false });
      });
    }
  }, {
    key: 'fetch',
    value: function fetch(props) {
      var AppState = props.AppState;

      _SearchBoxStore2['default'].queryLanguage(this.props.AppState.userInfo.currentOrganizationId, AppState.currentLanguage);
    }
  }, {
    key: 'stopPropagation',
    value: function stopPropagation(e) {
      e.nativeEvent.stopImmediatePropagation();
    }
  }, {
    key: 'onSearch',
    value: function onSearch() {
      var SearchBoxStore = this.props.SearchBoxStore;
      var query = SearchBoxStore.query;

      var _state = this.getParam();
      var menuType = _state.menuType;

      var data = {
        query: query
      };
      if (menuType.type === 'organization') {
        data = (0, _extends3['default'])({}, menuType, { query: query });
      }
      // this.props.history.replace({ pathname: '/search', data })
    }
  }, {
    key: 'getParam',
    value: function getParam() {
      var _props$AppState$menuT = this.props.AppState.menuType,
          organizationId = _props$AppState$menuT.organizationId,
          id = _props$AppState$menuT.id;

      if (organizationId && id) {
        return this.props.AppState;
      } else {
        // 重新取回租户信息
        var data = _queryString2['default'].parse(location.href.split('?')[1]);
        var _state = (0, _extends3['default'])({}, this.props.AppState);
        _state.menuType = {
          type: data.type,
          id: data.id,
          name: data.name,
          organizationId: data.organizationId
        };
        return _state;
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(query) {
      var _this3 = this;

      this.props.SearchBoxStore.setQuery(query);
      var timestamp = Number(new Date());
      // 输入太快 不足x秒 清空定时器
      if (timestamp - lastUpdate < 500) {
        clearInterval(tick);
      }

      lastUpdate = timestamp;
      var t = 0;

      // 每次改变输入 都设定x秒后发起请求
      tick = setInterval(function () {
        t++;
        // x秒内还没有下次输入 则发起请求
        if (t === 5) {
          lastUpdate = Number(new Date());
          var param = _this3.getParam();
          _this3.props.SearchBoxStore.fetchData(param);
          clearInterval(tick);
        }
      }, 100);
    }
  }, {
    key: 'getListTitleDom',
    value: function getListTitleDom(label, btn, url) {
      return _react2['default'].createElement(
        'div',
        { className: 'option-title jflex-wrap' },
        _react2['default'].createElement(
          'b',
          null,
          label
        ),
        _react2['default'].createElement(
          'div',
          { className: 'jflex-with-center' },
          _react2['default'].createElement(
            'a',
            {
              className: 'option-link',
              target: '_blank',
              href: url,
              onClick: function onClick() {
                // alert('jump')
              }
            },
            btn
          ),
          _react2['default'].createElement('i', null)
        )
      );
    }
  }, {
    key: 'getChildOptions',
    value: function getChildOptions(listElements) {
      return listElements.length ? _react2['default'].createElement(
        'div',
        { className: 'ul-div' },
        listElements
      ) : null;
    }
  }, {
    key: 'getOptions',
    value: function getOptions() {
      var _this4 = this;

      var _props$SearchBoxStore = this.props.SearchBoxStore,
          serviceDirResultList = _props$SearchBoxStore.serviceDirResultList,
          serviceOrderResultList = _props$SearchBoxStore.serviceOrderResultList,
          knowledgeResultList = _props$SearchBoxStore.knowledgeResultList,
          questionResultList = _props$SearchBoxStore.questionResultList,
          query = _props$SearchBoxStore.query;
      var _getParam$menuType = this.getParam().menuType,
          id = _getParam$menuType.id,
          name = _getParam$menuType.name,
          organizationId = _getParam$menuType.organizationId,
          type = _getParam$menuType.type;


      var dirElements = [];
      var orderElements = [];
      var kwdElements = [];
      var QAElements = [];

      var _baseHashData = {
        type: type,
        id: organizationId,
        name: name,
        organizationId: organizationId
      };

      // 服务目录
      serviceDirResultList && serviceDirResultList.map(function (item, index) {
        if (index > 2) return;
        var data = (0, _extends3['default'])({}, _baseHashData, {
          isQuick: 'Y',
          projectId: item.projectId,
          catalogId: item.catalogueId,
          ticketType: item.categoryCode,
          structName: encodeURIComponent(encodeURIComponent(item.structName || item.structureName)),
          catalogValue: encodeURIComponent(encodeURIComponent((item.structName || item.structureName) + '    ' + item.catalogueDisplayName))
        });
        var href = '/#/itsm/event/createEvent' + queryAnd(data);
        dirElements.push(_react2['default'].createElement(
          'div',
          { className: 'option-item jflex-wrap' },
          _react2['default'].createElement('a', { target: '_blank', href: href, className: 'ell', style: { color: '#000031', maxWidth: 308 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.catalogueDisplayName) } }),
          _react2['default'].createElement('span', { className: 'ell', style: { color: '#818999', maxWidth: 216, fontSize: 12 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.structName) } })
        ));
      });

      // 知识库
      knowledgeResultList && knowledgeResultList.map(function (item, index) {
        if (index > 2) return;
        var data = (0, _extends3['default'])({}, _baseHashData);
        var href = '/#/knowledge/detail/' + item.knowledgeId + queryAnd(data);
        kwdElements.push(_react2['default'].createElement(
          'div',
          { className: 'option-item jflex' },
          _react2['default'].createElement('a', { className: 'ell', style: { color: '#000031', paddingRight: 10 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.title) }, onClick: function onClick() {
              window.open('#/knowledge/search?type=organization&id=' + _this4.organizationId + '&name=' + _this4.organizationName + '&organizationId=' + _this4.organizationId + '&knowledgeId=' + item.knowledgeId, '_blank');
            } }),
          _react2['default'].createElement('span', { className: 'ell', style: { color: '#000031', maxWidth: 216 }, dangerouslySetInnerHTML: { __html: '' } })
        ));
      });

      // 问答库
      if (questionResultList.length > 0) {
        questionResultList.forEach(function (item, index) {
          if (index > 2) return;
          var data = (0, _extends3['default'])({}, _baseHashData, {
            menu: 'QDB',
            query: item.normalQuestionName
          });
          var href = '/#/search' + queryAnd(data);
          QAElements.push(_react2['default'].createElement(
            'div',
            { className: 'option-item jflex' },
            _react2['default'].createElement('a', { target: '_blank', href: href, className: 'ell', style: { color: '#000031', paddingRight: 10 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.questionName) } }),
            _react2['default'].createElement('span', { className: 'ell', style: { color: '#000031', maxWidth: 216 }, dangerouslySetInnerHTML: { __html: '' } })
          ));
        });
      }
      // 服务单
      serviceOrderResultList && serviceOrderResultList.map(function (item, index) {
        if (index > 2) return;
        var data = (0, _extends3['default'])({}, _baseHashData, { eventId: item.id });
        var href = '/#/itsm/event/eventInfo' + queryAnd(data);
        orderElements.push(_react2['default'].createElement(
          'div',
          { className: 'option-item jflex' },
          _react2['default'].createElement('a', { target: '_blank', href: href, className: 'ell', style: { color: '#000031', paddingRight: 10 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.eventNum) } }),
          _react2['default'].createElement('a', { target: '_blank', href: href, className: 'ell', style: { color: '#000031', maxWidth: 350 }, dangerouslySetInnerHTML: { __html: (0, _SanitizeHtml.getSanitizeHtml)(item.title) } })
        ));
      });

      var options = [];

      var _baseHashSearchData = {
        type: type,
        id: id,
        name: name,
        organizationId: organizationId
      };

      // 知识库
      {
        var data = (0, _extends3['default'])({}, _baseHashSearchData, {
          menu: 'KDB',
          query: this.props.SearchBoxStore.query
        });
        if (!data.query) {
          data.noApi = 1;
        }

        var url = '/#/search' + queryAnd(data);
        var title = this.getListTitleDom(_SearchBoxStore2['default'].language[intlPrefix + '.knowledge'], _SearchBoxStore2['default'].language[intlPrefix + '.knowledgeSearch'], url);
        var list = this.getChildOptions(kwdElements);
        options.push(_react2['default'].createElement(
          'div',
          { className: 'option-div' },
          title,
          list
        ));
      }

      // 问答库
      {
        var _data = (0, _extends3['default'])({}, _baseHashSearchData, {
          menu: 'QDB',
          query: this.props.SearchBoxStore.query
        });
        if (!_data.query) {
          _data.noApi = 1;
        }

        var _url = '/#/search' + queryAnd(_data);
        var _title = this.getListTitleDom(_SearchBoxStore2['default'].language[intlPrefix + '.Questions'], _SearchBoxStore2['default'].language[intlPrefix + '.QuestionsSearch'], _url);
        var _list = this.getChildOptions(QAElements);
        options.push(_react2['default'].createElement(
          'div',
          { className: 'option-div' },
          _title,
          _list
        ));
      }

      // 服务单
      {
        var _data2 = (0, _extends3['default'])({}, _baseHashSearchData, {
          menu: 'ORDER',
          query: this.props.SearchBoxStore.query
        });
        if (!_data2.query) {
          _data2.noApi = 1;
        }
        var _url2 = '/#/search' + queryAnd(_data2);
        var _title2 = this.getListTitleDom(_SearchBoxStore2['default'].language[intlPrefix + '.service'], _SearchBoxStore2['default'].language[intlPrefix + '.serviceSearch'], _url2);
        var _list2 = this.getChildOptions(orderElements);
        options.push(_react2['default'].createElement(
          'div',
          { className: 'option-div' },
          _title2,
          _list2
        ));
      }

      // 服务目录
      {
        var _data3 = (0, _extends3['default'])({}, _baseHashData, {
          isQuick: 'Y'
        });
        var _url3 = '/#/itsm/event/createEvent' + queryAnd(_data3);
        var _title3 = this.getListTitleDom(_SearchBoxStore2['default'].language[intlPrefix + '.serviceCatalog'], _SearchBoxStore2['default'].language[intlPrefix + '.NewlyBuildSearch'], _url3);
        var _list3 = this.getChildOptions(dirElements);
        options.push(_react2['default'].createElement(
          'div',
          { className: 'option-div' },
          _title3,
          _list3
        ));
      }

      return options;
    }
  }, {
    key: 'onkeydown',
    value: function onkeydown(e) {
      this.setState({
        showResult: true
      });
      var keynum = void 0;
      // IE
      if (window.event) {
        keynum = e.keyCode;
      } else if (e.which) {
        // Netscape/Firefox/Opera
        keynum = e.which;
      }
      if (keynum === 13) {
        var _getParam$menuType2 = this.getParam().menuType,
            id = _getParam$menuType2.id,
            name = _getParam$menuType2.name,
            organizationId = _getParam$menuType2.organizationId,
            type = _getParam$menuType2.type;

        var _baseHashSearchData = {
          type: type,
          id: id,
          name: name,
          organizationId: organizationId
        };
        var data = (0, _extends3['default'])({}, _baseHashSearchData, {
          menu: 'ORDER',
          query: this.props.SearchBoxStore.query
        });
        if (!data.query) {
          data.noApi = 1;
        }
        var href = '/#/search' + queryAnd(data);
        window.open(href, '_blank');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var SearchBoxStore = this.props.SearchBoxStore;
      var _state2 = this.state,
          normal = _state2.normal,
          showResult = _state2.showResult;
      var serviceDirResultList = SearchBoxStore.serviceDirResultList,
          serviceOrderResultList = SearchBoxStore.serviceOrderResultList,
          knowledgeResultList = SearchBoxStore.knowledgeResultList,
          questionResultList = SearchBoxStore.questionResultList,
          query = SearchBoxStore.query,
          setQuery = SearchBoxStore.setQuery,
          loading = SearchBoxStore.loading;

      var hasData = serviceDirResultList && serviceDirResultList.length || serviceOrderResultList && serviceOrderResultList.length || knowledgeResultList && knowledgeResultList.length || questionResultList && questionResultList.length || loading;

      if (normal) {
        return _react2['default'].createElement(_icon2['default'], {
          className: 'slideOutLeft pointer',
          type: 'sousuo',
          style: { fontSize: 19, padding: '2px 10px' },
          onClick: function onClick(e) {
            _this5.setState({ normal: false }, function () {
              _this5.refs.input.focus();
            });
            _this5.stopPropagation(e);
          }
        });
      }
      return _react2['default'].createElement(
        'div',
        { id: 'jdropList', className: 'jdrop-list bounceInRight', onClick: function onClick(e) {
            _this5.stopPropagation(e);
          } },
        _react2['default'].createElement(
          'div',
          { className: 'jflex-with-center jdrop-list-box' },
          _react2['default'].createElement(_icon2['default'], { className: 'icon-search', type: 'sousuo', style: { fontSize: 19 } }),
          _react2['default'].createElement('input', {
            type: 'text',
            ref: 'input',
            onChange: function onChange(e) {
              _this5.onChange(e.target.value);
            },
            onKeyDown: function onKeyDown(e) {
              return _this5.onkeydown(e);
            }
          }),
          _react2['default'].createElement(_icon2['default'], {
            className: '',
            type: 'close',
            style: { fontSize: 24, cursor: 'pointer' },
            onClick: function onClick(e) {
              _this5.setState({ normal: true });
              _this5.props.SearchBoxStore.reset();
            }
          })
        ),
        showResult ? _react2['default'].createElement(
          'div',
          { className: 'jdrop-list-options' },
          this.getOptions(),
          loading ? _react2['default'].createElement(
            'div',
            { className: 'jdrop-list-cover' },
            _react2['default'].createElement(
              'div',
              { className: 'jdrop-list-loading' },
              _react2['default'].createElement(_progress2['default'], { type: 'loading' })
            )
          ) : null
        ) : null
      );
    }
  }]);
  return SearchBox;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = SearchBox;