'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style7 = require('yqcloud-ui/lib/badge/style');

var _badge = require('yqcloud-ui/lib/badge');

var _badge2 = _interopRequireDefault(_badge);

var _style8 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style9 = require('yqcloud-ui/lib/table/style');

var _table = require('yqcloud-ui/lib/table');

var _table2 = _interopRequireDefault(_table);

var _style10 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style11 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _style12 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactWebsocket = require('react-websocket');

var _reactWebsocket2 = _interopRequireDefault(_reactWebsocket);

var _accessToken = require('../../common/accessToken');

var _constants = require('../../common/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var intlPrefix = 'organization.header';

var TaskCenter = (_dec = (0, _mobxReact.inject)('HeaderStore', 'AppState'), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(TaskCenter, _Component);

  function TaskCenter(props) {
    (0, _classCallCheck3['default'])(this, TaskCenter);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (TaskCenter.__proto__ || Object.getPrototypeOf(TaskCenter)).call(this, props));

    _this.loadFileMission = function () {
      var _this$props = _this.props,
          AppState = _this$props.AppState,
          HeaderStore = _this$props.HeaderStore;

      _this.setState({ loading: true });
      HeaderStore.loadFileMission(AppState.userInfo.currentOrganizationId).then(function (data) {
        if (!data.failed) {
          _this.setState({
            dataSource: data || [],
            loading: false
          });
        }
      });
    };

    _this.querySuccess = function (values) {
      var HeaderStore = _this.props.HeaderStore;

      var statusLists = HeaderStore.getSuccessList;
      if (statusLists.length > 0) {
        var nameList = statusLists.filter(function (v) {
          return v.lookupValue === values;
        });
        if (nameList.length > 0) {
          return nameList[0].lookupMeaning;
        } else {
          return values;
        }
      }
    };

    _this.queryExport = function (values) {
      var HeaderStore = _this.props.HeaderStore;

      var statusLists = HeaderStore.getExportList;
      if (statusLists.length > 0) {
        var nameList = statusLists.filter(function (v) {
          return v.lookupValue === values;
        });
        if (nameList.length > 0) {
          return nameList[0].lookupMeaning;
        } else {
          return values;
        }
      }
    };

    _this.showTaskModal = function () {
      _this.setState({
        modalVisible: true
      }, function () {
        return _this.loadFileMission();
      });
    };

    _this.handleTaskModalCancel = function () {
      _this.setState({
        modalVisible: false,
        show: false
      });
    };

    _this.sendMessage = function (message) {
      _this.refWebSocketDown.sendMessage(message);
    };

    _this.handleDownloadDelete = function (record) {
      var _this$props2 = _this.props,
          HeaderStore = _this$props2.HeaderStore,
          AppState = _this$props2.AppState;

      HeaderStore.deleteMission(AppState.userInfo.currentOrganizationId, record.missionId).then(function (data1) {
        if (data1 === 1) {
          _this.loadFileMission();
          Choerodon.prompt(HeaderStore.language['delete.success']);
        }
      });
    };

    _this.handleDownloadExcel = function (record) {
      var _this$props3 = _this.props,
          HeaderStore = _this$props3.HeaderStore,
          AppState = _this$props3.AppState;

      HeaderStore.downloadMission(AppState.userInfo.currentOrganizationId, record.fileId, record.missionId).then(function (data) {
        if (!data.failed) {
          _this.loadFileMission();
          window.open(decodeURI(data.fileUrl));
        }
      });
    };

    _this.state = {
      modalVisible: false,
      dataSource: [],
      show: false,
      loading: false
    };
    _this.organizationId = _this.props.AppState.userInfo.currentOrganizationId;
    _this.language = _this.props.AppState.currentLanguage;
    return _this;
  }

  (0, _createClass3['default'])(TaskCenter, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          AppState = _props.AppState,
          HeaderStore = _props.HeaderStore;

      HeaderStore.queryStatusList(AppState.userInfo.currentOrganizationId);
      HeaderStore.querySuccessList(AppState.userInfo.currentOrganizationId);
      HeaderStore.queryExportList(AppState.userInfo.currentOrganizationId);
    }

    // 获取任务中心文件列表


    // 获取成功状态


    // 获取任务类型

  }, {
    key: 'renderPopoverContent',
    value: function renderPopoverContent() {
      var _this2 = this;

      var _state = this.state,
          modalVisible = _state.modalVisible,
          dataSource = _state.dataSource,
          loading = _state.loading;
      var HeaderStore = this.props.HeaderStore;

      var columns = [{
        title: HeaderStore.language[intlPrefix + '.missionName'],
        dataIndex: 'missionName',
        key: 'missionName',
        width: 140,
        render: function render(text, record) {
          if (record.missionName) {
            if (record.missionName.length > 10) {
              return _react2['default'].createElement(
                _tooltip2['default'],
                { title: record.missionName },
                record.missionName.slice(0, 9) + '...'
              );
            } else {
              return record.missionName;
            }
          } else {
            return '';
          }
        }
      }, {
        title: HeaderStore.language[intlPrefix + '.creationDate'],
        dataIndex: 'creationDate',
        key: 'creationDate',
        width: 145
      }, {
        title: HeaderStore.language[intlPrefix + '.missionTypeCode'],
        dataIndex: 'missionTypeCode',
        key: 'missionTypeCode',
        width: 80,
        render: function render(text, record) {
          return _this2.queryExport(record.missionTypeCode);
        }
      }, {
        title: HeaderStore.language[intlPrefix + '.missionStatusCode'],
        dataIndex: 'missionStatusCode',
        key: 'missionStatusCode',
        width: 95,
        render: function render(text, record) {
          return _this2.querySuccess(record.missionStatusCode);
        }
      }, {
        title: HeaderStore.language[intlPrefix + '.downloadTimes'],
        dataIndex: 'downloadTimes',
        key: 'downloadTimes',
        width: 80
      }, {
        title: HeaderStore.language.operation,
        dataIndex: 'action',
        key: 'action',
        width: 100,
        render: function render(text, record) {
          return _react2['default'].createElement(
            'span',
            null,
            record.missionTypeCode !== 'IMPORT' ? record.missionTypeCode === 'WORKFLOWIMPORT' || record.missionStatusCode === 'success' ? _react2['default'].createElement(
              _button2['default'],
              { shape: 'circle', onClick: _this2.handleDownloadExcel.bind(_this2, record) },
              _react2['default'].createElement(_icon2['default'], { style: { cursor: 'pointer', color: '#2196f3', marginBottom: '2px' }, type: 'xiazai' })
            ) : _react2['default'].createElement(
              _button2['default'],
              { shape: 'circle', disabled: true },
              _react2['default'].createElement(
                'a',
                null,
                _react2['default'].createElement(_icon2['default'], { style: { color: 'rgba(0,0,0,.26)', marginBottom: '2px' }, type: 'xiazai' })
              )
            ) : _react2['default'].createElement(
              _button2['default'],
              { shape: 'circle', style: { visibility: 'hidden' } },
              _react2['default'].createElement(
                'a',
                null,
                _react2['default'].createElement(_icon2['default'], { style: { color: 'rgba(0,0,0,.26)', marginBottom: '2px' }, type: 'xiazai' })
              )
            ),
            _react2['default'].createElement(
              _button2['default'],
              { shape: 'circle', onClick: _this2.handleDownloadDelete.bind(_this2, record) },
              _react2['default'].createElement(_icon2['default'], { style: { cursor: 'pointer', color: '#2196f3' }, type: 'shu-shanchu' })
            )
          );
        }
      }];
      return _react2['default'].createElement(
        _modal2['default'],
        {
          title: _react2['default'].createElement(
            'span',
            { style: { color: '#04173F', fontSize: 18 } },
            HeaderStore.language[intlPrefix + '.taskCenter.list'],
            _react2['default'].createElement(
              'span',
              { style: { marginLeft: 20, color: '#3C4D73', fontSize: 8 } },
              _react2['default'].createElement(_icon2['default'], { style: { fontSize: 14, color: '#2196f3' }, type: 'info' }),
              HeaderStore.language[intlPrefix + '.file.delete']
            )
          ),
          className: 'this-is-taskCenter',
          visible: modalVisible,
          style: { top: 100 },
          onCancel: this.handleTaskModalCancel,
          footer: false,
          width: 750
        },
        _react2['default'].createElement(
          'div',
          { style: { marginTop: 30, marginBottom: 30 } },
          _react2['default'].createElement(_table2['default'], {
            size: 'middle',
            loading: loading,
            pagination: false
            // className="this-is-employeeInv"
            , columns: columns,
            filterBar: false,
            bordered: false,
            dataSource: dataSource,
            scroll: { y: 280 }
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'span',
        null,
        _react2['default'].createElement(
          _button2['default'],
          { functype: 'flat', shape: 'circle', className: 'head-example', onClick: this.showTaskModal },
          _react2['default'].createElement(
            _badge2['default'],
            { dot: this.state.show },
            _react2['default'].createElement(_icon2['default'], { type: 'ziyuan1', style: { fontSize: 19, marginTop: '-3px', color: '#FFF' } })
          )
        ),
        this.renderPopoverContent()
      );
    }
  }]);
  return TaskCenter;
}(_react.Component)) || _class) || _class);
exports['default'] = TaskCenter;