'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _mainList = require('./mainList');

var _mainList2 = _interopRequireDefault(_mainList);

var _footerLinks = require('./footerLinks');

var _footerLinks2 = _interopRequireDefault(_footerLinks);

require('./style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Home = (_dec = (0, _mobxReact.inject)('AppState'), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(Home, _Component);

  function Home() {
    (0, _classCallCheck3['default'])(this, Home);
    return (0, _possibleConstructorReturn3['default'])(this, (Home.__proto__ || Object.getPrototypeOf(Home)).apply(this, arguments));
  }

  (0, _createClass3['default'])(Home, [{
    key: 'renderItem',
    value: function renderItem(_ref) {
      var title = _ref.title,
          icon = _ref.icon,
          content = _ref.content,
          link = _ref.link,
          key = _ref.key;

      return _react2['default'].createElement(
        'li',
        { key: key },
        _react2['default'].createElement(
          'a',
          { href: link },
          _react2['default'].createElement(
            'div',
            { className: 'access-list-item' },
            _react2['default'].createElement('div', { className: 'access-list-icon ' + icon }),
            _react2['default'].createElement(
              'h4',
              null,
              title
            ),
            _react2['default'].createElement(
              'p',
              null,
              content
            )
          )
        )
      );
    }
  }, {
    key: 'renderContentLinks',
    value: function renderContentLinks() {
      var _this2 = this;

      return _mainList2['default'].map(function (_ref2) {
        var title = _ref2.title,
            items = _ref2.items,
            key = _ref2.key;
        return _react2['default'].createElement(
          'div',
          { key: key, className: 'access-list-group' },
          _react2['default'].createElement(
            'h3',
            null,
            title
          ),
          _react2['default'].createElement(
            'ul',
            null,
            items.map(function (item) {
              return _this2.renderItem(item);
            })
          )
        );
      });
    }
  }, {
    key: 'renderFooterLinks',
    value: function renderFooterLinks() {
      return _footerLinks2['default'].map(function (_ref3) {
        var title = _ref3.title,
            items = _ref3.items,
            key = _ref3.key;
        return _react2['default'].createElement(
          'ul',
          { key: key },
          _react2['default'].createElement(
            'li',
            null,
            _react2['default'].createElement(
              'h3',
              null,
              title
            )
          ),
          items.map(function (_ref4) {
            var text = _ref4.text,
                link = _ref4.link,
                itemKey = _ref4.key;
            return _react2['default'].createElement(
              'li',
              { key: itemKey },
              _react2['default'].createElement(
                'a',
                { href: link },
                text
              )
            );
          })
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var AppState = this.props.AppState;

      var user = AppState.currentUser;
      return _react2['default'].createElement(
        'div',
        { className: 'choerodon-home' },
        _react2['default'].createElement(
          'header',
          { className: 'choerodon-home-header' },
          _react2['default'].createElement(
            'div',
            { className: 'choerodon-home-header-content' },
            _react2['default'].createElement(
              'h1',
              null,
              (user ? user.realName + '\uFF1A' : '') + ' \u60A8\u597D\uFF01\u6B22\u8FCE\u4F7F\u7528'
            ),
            _react2['default'].createElement(
              'p',
              null,
              'Choerodon\u732A\u9F7F\u9C7C\u662F\u4E00\u4E2A\u5F00\u6E90\u4F01\u4E1A\u670D\u52A1\u5E73\u53F0\uFF0C\u662F\u57FA\u4E8EKubernetes\u7684\u5BB9\u5668\u7F16\u6392\u548C\u7BA1\u7406\u80FD\u529B\uFF0C \u6574\u5408DevOps\u5DE5\u5177\u94FE\u3001\u5FAE\u670D\u52A1\u548C\u79FB\u52A8\u5E94\u7528\u6846\u67B6\uFF0C\u6765\u5E2E\u52A9\u4F01\u4E1A\u5B9E\u73B0\u654F\u6377\u5316\u7684\u5E94\u7528\u4EA4\u4ED8\u548C\u81EA\u52A8\u5316\u7684\u8FD0\u8425\u7BA1\u7406\uFF0C \u5E76\u63D0\u4F9BIoT\u3001\u652F\u4ED8\u3001\u6570\u636E\u3001\u667A\u80FD\u6D1E\u5BDF\u3001\u4F01\u4E1A\u5E94\u7528\u5E02\u573A\u7B49\u4E1A\u52A1\u7EC4\u4EF6\uFF0C\u6765\u5E2E\u52A9\u4F01\u4E1A\u805A\u7126\u4E8E\u4E1A\u52A1\uFF0C\u52A0\u901F\u6570\u5B57\u5316\u8F6C\u578B'
            )
          )
        ),
        _react2['default'].createElement(
          'div',
          { className: 'choerodon-home-content' },
          _react2['default'].createElement(
            'div',
            { className: 'access-list' },
            this.renderContentLinks()
          )
        ),
        _react2['default'].createElement(
          'footer',
          { className: 'choerodon-home-footer' },
          _react2['default'].createElement(
            'div',
            { className: 'link-list' },
            this.renderFooterLinks()
          )
        )
      );
    }
  }]);
  return Home;
}(_react.Component)) || _class) || _class);
exports['default'] = Home;