'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style2 = require('yqcloud-ui/lib/spin/style');

var _spin = require('yqcloud-ui/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _mobxReact = require('mobx-react');

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _menu = require('../menu');

var _menu2 = _interopRequireDefault(_menu);

var _header = require('../header');

var _header2 = _interopRequireDefault(_header);

var _common = require('../../common');

var _findFirstLeafMenu2 = require('../util/findFirstLeafMenu');

var _findFirstLeafMenu3 = _interopRequireDefault(_findFirstLeafMenu2);

require('./style');

require('babel-polyfill');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var intlPrefix = 'organization.header';
var spinStyle = {
  textAlign: 'center',
  paddingTop: 300
};

function parseQueryToMenuType(search) {
  var menuType = {};
  if (search) {
    var _queryString$parse = _queryString2['default'].parse(search),
        type = _queryString$parse.type,
        name = _queryString$parse.name,
        id = _queryString$parse.id,
        organizationId = _queryString$parse.organizationId;

    if (type) {
      menuType.type = type;
    }
    if (name) {
      menuType.name = name;
    }
    if (id) {
      menuType.id = id;
      if (type === 'project') {
        menuType.projectId = id;
      } else if (type === 'organization') {
        menuType.organizationId = id;
      }
    }
    if (type === 'project' && organizationId) {
      menuType.organizationId = organizationId;
    }
  }

  return menuType;
}

var Masters = (_dec = (0, _mobxReact.inject)('AppState', 'MenuStore', 'HeaderStore', 'PreviewStore'), (0, _reactRouterDom.withRouter)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(Masters, _Component);

  function Masters(props) {
    (0, _classCallCheck3['default'])(this, Masters);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (Masters.__proto__ || Object.getPrototypeOf(Masters)).call(this, props));

    _this.state = {};
    return _this;
  }

  (0, _createClass3['default'])(Masters, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      // this.loadLanguage();
      this.initMenuType(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.initMenuType(nextProps);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {}
    // this.initFavicon();


    // // 获取语言
    // loadLanguage = () => {
    //   const { AppState, HeaderStore } = this.props;
    //   HeaderStore.queryLanguage(AppState.userInfo.currentOrganizationId, AppState.currentLanguage);
    // };

    // initFavicon() {
    //   const { AppState } = this.props;
    //   AppState.loadSiteInfo().then((data) => {
    //     const link = document.createElement('link');
    //     const linkDom = document.getElementsByTagName('link');
    //     if (linkDom) {
    //       for (let i = 0; i < linkDom.length; i += 1) {
    //         if (linkDom[i].getAttribute('rel') === 'shortcut icon') document.head.removeChild(linkDom[i]);
    //       }
    //     }
    //     link.id = 'dynamic-favicon';
    //     link.rel = 'shortcut icon';
    //     link.href = data.favicon || 'favicon.ico';
    //     document.head.appendChild(link);
    //     data.defaultTitle = document.getElementsByTagName('title')[0].innerText;
    //     if (data.systemTitle) {
    //       document.getElementsByTagName('title')[0].innerText = data.systemTitle;
    //     }
    //     AppState.setSiteInfo(data);
    //   });
    // }


  }, {
    key: 'initMenuType',
    value: function initMenuType(props) {
      var location = props.location,
          MenuStore = props.MenuStore,
          HeaderStore = props.HeaderStore,
          history = props.history,
          AppState = props.AppState;
      var pathname = location.pathname,
          search = location.search;

      var isUser = false;
      var needLoad = false;
      var hideMenu = false;
      var menuType = parseQueryToMenuType(search);
      if (pathname === '/') {
        if (!_common.dashboard) {
          var recent = HeaderStore.getRecentItem;
          if (recent.length && !sessionStorage.home_first_redirect) {
            var _recent$ = recent[0],
                id = _recent$.id,
                name = _recent$.name,
                type = _recent$.type,
                organizationId = _recent$.organizationId;

            menuType = { id: id, name: name, type: type, organizationId: organizationId };
            needLoad = true;
          } else {
            menuType = {};
          }
          sessionStorage.home_first_redirect = 'yes';
        }
      } else if (pathname === '/search') {
        var data = _queryString2['default'].parse(location.search);
        if (data) {
          var _id = data.id,
              _name = data.name,
              _type = data.type,
              _organizationId = data.organizationId;

          menuType = { id: _id, name: _name, type: _type, organizationId: _organizationId };
        } else {
          menuType = {};
        }
        hideMenu = true;
      } else if (menuType.type === 'site') {
        isUser = true;
      } else if (!menuType.type) {
        menuType.type = 'site';
      }
      AppState.setTypeUser(isUser);
      AppState.changeMenuType(menuType);
      AppState.setHideMenu(hideMenu);
      if (needLoad) {
        MenuStore.loadMenuData().then(function (menus) {
          if (menus.length) {
            var _findFirstLeafMenu = (0, _findFirstLeafMenu3['default'])(menus[0]),
                route = _findFirstLeafMenu.route,
                domain = _findFirstLeafMenu.domain;

            var _AppState$currentMenu = AppState.currentMenuType,
                _type2 = _AppState$currentMenu.type,
                _name2 = _AppState$currentMenu.name,
                _id2 = _AppState$currentMenu.id,
                _organizationId2 = _AppState$currentMenu.organizationId;

            var path = route + '?type=' + _type2 + '&id=' + _id2 + '&name=' + _name2;
            if (_organizationId2) {
              path += '&organizationId=' + _organizationId2;
            }
            (0, _common.historyReplaceMenu)(history, path, domain);
          }
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          AppState = _props.AppState,
          AutoRouter = _props.AutoRouter,
          PreviewStore = _props.PreviewStore,
          HeaderStore = _props.HeaderStore;

      return AppState.isAuth && AppState.currentMenuType ? _react2['default'].createElement(
        'div',
        { className: 'page-wrapper' },
        _react2['default'].createElement(
          'div',
          { className: 'page-header', style: PreviewStore.isHeaderVisable ? {} : { display: 'none' } },
          _react2['default'].createElement(_header2['default'], null)
        ),
        _react2['default'].createElement(
          'div',
          { className: 'page-body' },
          _react2['default'].createElement(
            'div',
            { className: 'content-wrapper' },
            _react2['default'].createElement(
              'div',
              { id: 'menu', className: 'c7n-menu' },
              AppState.hideMenu ? null : _react2['default'].createElement(_menu2['default'], null)
            ),
            _react2['default'].createElement(
              'div',
              { id: 'autoRouter', className: 'content' },
              _react2['default'].createElement(AutoRouter, null)
            )
          )
        )
      ) : _react2['default'].createElement(
        'div',
        { style: spinStyle },
        _react2['default'].createElement(_spin2['default'], null)
      );
    }
  }]);
  return Masters;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = Masters;