'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style4 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _style5 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style6 = require('yqcloud-ui/lib/menu/style');

var _menu = require('yqcloud-ui/lib/menu');

var _menu2 = _interopRequireDefault(_menu);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _mobxReact = require('mobx-react');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _findFirstLeafMenu3 = require('../util/findFirstLeafMenu');

var _findFirstLeafMenu4 = _interopRequireDefault(_findFirstLeafMenu3);

var _common = require('../../common');

require('./style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SubMenu = _menu2['default'].SubMenu,
    Item = _menu2['default'].Item;
var CommonMenu = (_dec = (0, _mobxReact.inject)('AppState', 'MenuStore'), (0, _reactRouterDom.withRouter)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(CommonMenu, _Component);

  function CommonMenu(props) {
    (0, _classCallCheck3['default'])(this, CommonMenu);

    var _this2 = (0, _possibleConstructorReturn3['default'])(this, (CommonMenu.__proto__ || Object.getPrototypeOf(CommonMenu)).call(this, props));

    _this2.savedOpenKeys = [];

    _this2.handleClick = function (e) {
      var MenuStore = _this2.props.MenuStore;

      var child = MenuStore.getMenuData;
      var selected = _this2.findSelectedMenuByCode(child, e.key);
      var paths = e.keyPath && e.keyPath.reverse()[0]; // 去掉boot的
      var selectedRoot = paths ? child.find(function (_ref) {
        var code = _ref.code;
        return code === paths;
      }) : selected;
      if (selected) {
        var history = _this2.props.history;

        MenuStore.treeReduce(selectedRoot, function (menu, parents, index) {
          if (index === 0 && !menu.subMenus) {
            MenuStore.setActiveMenu(selected);
            MenuStore.setSelected(selectedRoot);
            MenuStore.setOpenKeys([selected].concat((0, _toConsumableArray3['default'])(parents)).map(function (_ref2) {
              var code = _ref2.code;
              return code;
            }));
            return true;
          }
          return false;
        });

        var _findFirstLeafMenu = (0, _findFirstLeafMenu4['default'])(selected),
            route = _findFirstLeafMenu.route,
            domian = _findFirstLeafMenu.domian;

        var link = _this2.getMenuLink(route);
        (0, _common.historyReplaceMenu)(history, link, domian);
      }
      _this2.collapseMenu();
    };

    _this2.handleOpenChange = function (openKeys) {
      _this2.props.MenuStore.setOpenKeys(openKeys);
    };

    _this2.handleLeftOpenChange = function (leftOpenKeys) {
      _this2.props.MenuStore.setLeftOpenKeys(leftOpenKeys);
    };

    _this2.collapseMenu = function () {
      var _this2$props = _this2.props,
          AppState = _this2$props.AppState,
          MenuStore = _this2$props.MenuStore;

      MenuStore.setLeftOpenKeys([]);
      AppState.setMenuExpanded(false);
    };

    _this2.toggleRightMenu = function () {
      var MenuStore = _this2.props.MenuStore;
      var collapsed = MenuStore.collapsed,
          openKeys = MenuStore.openKeys;

      if (collapsed) {
        MenuStore.setCollapsed(false);
        MenuStore.setOpenKeys(_this2.savedOpenKeys);
      } else {
        _this2.savedOpenKeys = openKeys;
        MenuStore.setCollapsed(true);
        MenuStore.setOpenKeys([]);
      }
    };

    _this2.LinkOnMouseover = function () {
      var _this = _this2;
      clearTimeout(_this2.overtime);
      _this2.overtime = setTimeout(function () {
        _this.setState({
          zInedxMenu: 1200
        });
        clearTimeout(_this.settime);
        var MenuStore = _this.props.MenuStore;
        var collapsed = MenuStore.collapsed;

        if (collapsed) {
          MenuStore.setCollapsed(false);
          MenuStore.setOpenKeys(_this.savedOpenKeys);
        }
      }, 500);
    };

    _this2.LinkOnMouseOut = function () {
      var _this = _this2;
      clearTimeout(_this2.overtime);
      clearTimeout(_this2.settime);
      _this2.settime = setTimeout(function () {
        _this.setState({
          zInedxMenu: 0
        });
      }, 500);

      var MenuStore = _this2.props.MenuStore;
      var collapsed = MenuStore.collapsed,
          openKeys = MenuStore.openKeys;

      if (!collapsed) {
        _this2.savedOpenKeys = openKeys;
        MenuStore.setCollapsed(true);
        MenuStore.setOpenKeys([]);
      }
    };

    _this2.organizationId = _this2.props.AppState.currentMenuType.id;
    _this2.organizationName = _this2.props.AppState.currentMenuType.name;
    _this2.state = {
      zInedxMenu: 0
    };
    return _this2;
  }

  (0, _createClass3['default'])(CommonMenu, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.loadMenu(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.loadMenu(nextProps);
    }
  }, {
    key: 'loadMenu',
    value: function loadMenu(props) {
      var _this3 = this;

      var location = props.location,
          AppState = props.AppState,
          MenuStore = props.MenuStore;
      var currentType = MenuStore.type,
          currentIsUser = MenuStore.isUser,
          currentId = MenuStore.id,
          selected = MenuStore.selected,
          collapsed = MenuStore.collapsed,
          currentLanguage = MenuStore.currentLanguage;
      var pathname = location.pathname;
      var _AppState$currentMenu = AppState.currentMenuType,
          type = _AppState$currentMenu.type,
          id = _AppState$currentMenu.id;

      if (id) {
        MenuStore.queryLanguage(id, currentLanguage);
      }
      if (type) {
        MenuStore.loadMenuData().then(function (menus) {
          var isUser = AppState.isTypeUser;
          if (pathname === '/') {
            MenuStore.setActiveMenu(null);
            MenuStore.setSelected(selected ? menus.find(function (_ref3) {
              var code = _ref3.code;
              return code === selected.code;
            }) || menus[0] : menus[0]);
            MenuStore.setType(type);
            MenuStore.setId(id);
            MenuStore.setIsUser(isUser);
            MenuStore.setOpenKeys([]);
          } else {
            MenuStore.treeReduce({ subMenus: menus }, function (menu, parents) {
              if (menu.route === pathname || pathname.indexOf(menu.route + '/') === 0) {
                var nCode = parents.length && parents[parents.length - 1].code;
                var oCode = selected && selected.code;
                if (oCode !== nCode || currentType !== type || isUser !== currentIsUser || currentId !== id) {
                  MenuStore.setOpenKeys(collapsed ? [] : [menu].concat((0, _toConsumableArray3['default'])(parents)).map(function (_ref4) {
                    var code = _ref4.code;
                    return code;
                  }));
                  _this3.savedOpenKeys = [menu].concat((0, _toConsumableArray3['default'])(parents)).map(function (_ref5) {
                    var code = _ref5.code;
                    return code;
                  });
                }
                MenuStore.setActiveMenu(menu);
                MenuStore.setSelected(parents[0]);
                MenuStore.setType(type);
                MenuStore.setId(id);
                MenuStore.setIsUser(isUser);
                return true;
              }
              return false;
            });
          }
        });
      }
    }
  }, {
    key: 'getMenuSingle',
    value: function getMenuSingle(data, num) {
      var _this4 = this;

      var collapsed = this.props.MenuStore.collapsed;

      if (!data.subMenus) {
        var _findFirstLeafMenu2 = (0, _findFirstLeafMenu4['default'])(data),
            route = _findFirstLeafMenu2.route;

        var link = _react2['default'].createElement(
          _reactRouterDom.Link
          // onMouseOver={this.LinkOnMouseover}
          // onClick={this.LinkOnMouseOut}
          ,
          { to: this.getMenuLink(route),
            style: {
              marginLeft: parseInt(num, 10) * 20
            }
          },
          _react2['default'].createElement(_icon2['default'], { type: data.icon }),
          _react2['default'].createElement(
            'span',
            null,
            data.name
          )
        );
        return _react2['default'].createElement(
          Item,
          {
            key: data.code
          },
          this.TooltipMenu(link, data.code)
        );
      } else {
        return _react2['default'].createElement(
          SubMenu,
          {
            key: data.code
            // onMouseOver={this.LinkOnMouseover}
            // onClick={this.LinkOnMouseOut}
            , className: 'common-menu-right-popup',
            title: _react2['default'].createElement(
              'span',
              {
                style: {
                  marginLeft: parseInt(num, 10) * 20
                }
              },
              _react2['default'].createElement(_icon2['default'], { type: data.icon }),
              _react2['default'].createElement(
                'span',
                null,
                data.name
              ),
              _react2['default'].createElement(_icon2['default'], { className: 'common-menu-down', style: { display: '' + (collapsed ? 'none' : 'inline-block') } })
            )
          },
          data.subMenus.map(function (two) {
            return _this4.getMenuSingle(two, parseInt(num, 10) + 1);
          })
        );
      }
    }
  }, {
    key: 'TooltipMenu',
    value: function TooltipMenu(reactNode, code) {
      var AppState = this.props.AppState;

      if (AppState.getDebugger) {
        return _react2['default'].createElement(
          _tooltip2['default'],
          { defaultVisible: 'true', trigger: 'hover', placement: 'right' },
          reactNode
        );
      } else {
        return reactNode;
      }
    }
  }, {
    key: 'getMenuLink',
    value: function getMenuLink(route) {
      var AppState = this.props.AppState;
      var _AppState$currentMenu2 = AppState.currentMenuType,
          id = _AppState$currentMenu2.id,
          name = _AppState$currentMenu2.name,
          type = _AppState$currentMenu2.type,
          organizationId = _AppState$currentMenu2.organizationId;

      var search = '';
      switch (type) {
        case 'site':
          if (AppState.isTypeUser) {
            search = '?type=site';
          }
          break;
        case 'organization':
        case 'project':
          search = '?type=' + type + '&id=' + id + '&name=' + encodeURIComponent(name);
          if (organizationId) {
            search += '&organizationId=' + organizationId;
          }
          break;
        default:
      }
      return '' + route + search;
    }
  }, {
    key: 'findSelectedMenuByCode',
    value: function findSelectedMenuByCode(child, code) {
      var _this5 = this;

      var selected = false;
      child.forEach(function (item) {
        if (selected) {
          return;
        }
        if (item.code === code) {
          selected = item;
        } else if (item.subMenus) {
          selected = _this5.findSelectedMenuByCode(item.subMenus, code);
        }
      });
      return selected;
    }
  }, {
    key: 'renderLeftMenu',
    value: function renderLeftMenu(child, selected, expanded) {
      var _this6 = this;

      if (child.length > 0) {
        var _props = this.props,
            AppState = _props.AppState,
            MenuStore = _props.MenuStore;

        var homePath = '/';
        if (_common.dashboard) {
          var _AppState$currentMenu3 = AppState.currentMenuType,
              type = _AppState$currentMenu3.type,
              id = _AppState$currentMenu3.id,
              name = _AppState$currentMenu3.name,
              organizationId = _AppState$currentMenu3.organizationId;

          if (type && type !== 'site') {
            homePath = homePath + '?type=' + type + '&id=' + id + '&name=' + name;
            if (organizationId) {
              homePath += '&organizationId=' + organizationId;
            }
          }
        }
        return _react2['default'].createElement(
          'div',
          { className: 'common-menu-left ' + (expanded ? 'expanded' : '') },
          _react2['default'].createElement(
            'div',
            {
              className: 'common-menu-left-header',
              role: 'none'
            },
            _react2['default'].createElement(
              _reactRouterDom.Link,
              { to: homePath, onClick: this.collapseMenu },
              _react2['default'].createElement(_icon2['default'], { type: 'zhuye' }),
              _react2['default'].createElement(
                'span',
                { style: { color: '#3C4D73' } },
                MenuStore.language.homepage
              )
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'common-menu-right-content' },
            _react2['default'].createElement(
              _menu2['default'],
              {
                onClick: this.handleClick,
                openKeys: MenuStore.leftOpenKeys,
                onOpenChange: this.handleLeftOpenChange,
                selectedKeys: [selected.code],
                mode: 'vertical'
              },
              child.map(function (item) {
                return _this6.renderLeftMenuItem(item, expanded);
              })
            )
          )
        );
      }
    }
  }, {
    key: 'renderNewMenu',
    value: function renderNewMenu(child, selected, expanded) {
      var _this7 = this;

      var _props$MenuStore = this.props.MenuStore,
          collapsed = _props$MenuStore.collapsed,
          openKeys = _props$MenuStore.openKeys,
          activeMenu = _props$MenuStore.activeMenu;

      if (child.length > 0) {
        var _props2 = this.props,
            AppState = _props2.AppState,
            MenuStore = _props2.MenuStore;

        var homePath = '/';
        if (_common.dashboard) {
          var _AppState$currentMenu4 = AppState.currentMenuType,
              type = _AppState$currentMenu4.type,
              id = _AppState$currentMenu4.id,
              name = _AppState$currentMenu4.name,
              organizationId = _AppState$currentMenu4.organizationId;

          if (type && type !== 'site') {
            homePath = homePath + '?type=' + type + '&id=' + id + '&name=' + name;
            if (organizationId) {
              homePath += '&organizationId=' + organizationId;
            }
          }
        }
        return _react2['default'].createElement(
          'div',
          { className: 'common-menu-new expanded' },
          _react2['default'].createElement(
            'div',
            { className: 'common-menu-right-content' },
            _react2['default'].createElement(
              _menu2['default'],
              {
                onClick: this.handleClick,
                openKeys: MenuStore.leftOpenKeys,
                onOpenChange: this.handleLeftOpenChange,
                selectedKeys: [selected.code],
                mode: 'vertical'
              },
              child.map(function (item) {
                return _this7.renderNewMenuItem(item, expanded);
              })
            )
          )
        );
      }
    }
  }, {
    key: 'renderLeftMenuItem',
    value: function renderLeftMenuItem(item, expanded) {
      var icon = _react2['default'].createElement(_icon2['default'], { type: item.icon });
      var text = void 0;
      if (expanded) {
        text = _react2['default'].createElement(
          'span',
          null,
          item.name
        );
      } else {
        icon = _react2['default'].createElement(
          _tooltip2['default'],
          { placement: 'right', title: item.name },
          icon
        );
      }
      if (!item.subMenus) {
        return _react2['default'].createElement(
          Item,
          { key: item.code },
          icon,
          text
        );
      } else {
        return _react2['default'].createElement(
          SubMenu,
          {
            onTitleClick: this.handleClick,
            key: item.code,
            className: 'common-menu-right-popup',
            title: _react2['default'].createElement(
              'span',
              null,
              icon,
              text
            )
          },
          item.subMenus.map(function (two) {
            return _react2['default'].createElement(
              Item,
              { key: two.code },
              _react2['default'].createElement(_icon2['default'], { type: two.icon, style: { marginLeft: 20 } }),
              _react2['default'].createElement(
                'span',
                null,
                two.name
              )
            );
          })
        );
      }
    }
  }, {
    key: 'renderNewMenuItem',
    value: function renderNewMenuItem(item, expanded) {
      var icon = _react2['default'].createElement(_icon2['default'], { type: item.icon });
      var text = void 0;
      if (expanded) {
        text = _react2['default'].createElement(
          'span',
          null,
          item.name
        );
      } else {
        icon = _react2['default'].createElement(
          _tooltip2['default'],
          { placement: 'right', title: item.name },
          icon
        );
      }
      return _react2['default'].createElement(
        Item,
        { key: item.code },
        icon
      );
    }
  }, {
    key: 'renderRightMenu',
    value: function renderRightMenu(menu) {
      var _this8 = this;

      var _props$MenuStore2 = this.props.MenuStore,
          collapsed = _props$MenuStore2.collapsed,
          openKeys = _props$MenuStore2.openKeys,
          activeMenu = _props$MenuStore2.activeMenu;

      return _react2['default'].createElement(
        'div',
        {
          style: {
            position: 'relative',
            width: '50px',
            marginLeft: '50px'
          }
        },
        _react2['default'].createElement(
          'div',
          {
            className: (0, _classnames2['default'])('common-menu-right', { collapsed: collapsed }),
            style: {
              position: 'absolute',
              left: '0',
              zIndex: this.state.zInedxMenu
            }
          },
          _react2['default'].createElement(
            _tooltip2['default'],
            { placement: 'right', title: collapsed ? menu.name : '' },
            _react2['default'].createElement(
              'div',
              { className: 'common-menu-right-header' },
              _react2['default'].createElement(_icon2['default'], { type: menu.icon }),
              _react2['default'].createElement(
                'span',
                { className: 'common-menu-reght-header-span' },
                menu.name
              )
            )
          ),
          _react2['default'].createElement(
            'div',
            {
              className: 'common-menu-right-content',
              style: { height: 'calc(100vh - 156px)' },
              onMouseLeave: this.LinkOnMouseOut,
              onMouseEnter: this.LinkOnMouseover
            },
            _react2['default'].createElement(
              _menu2['default'],
              {
                mode: 'inline',
                inlineCollapsed: collapsed,
                selectedKeys: [activeMenu && activeMenu.code],
                openKeys: openKeys,
                onOpenChange: this.handleOpenChange
              },
              menu.subMenus.map(function (two) {
                return _this8.getMenuSingle(two, 0);
              })
            )
          ),
          _react2['default'].createElement('div', { className: 'common-menu-right-footer' })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      // 服务的菜单
      var _props3 = this.props,
          MenuStore = _props3.MenuStore,
          AppState = _props3.AppState,
          location = _props3.location;

      var child = MenuStore.getMenuData;
      if (child && child.length > 0) {
        var selected = MenuStore.selected;

        var expanded = AppState.getMenuExpanded;
        var mask = expanded && _react2['default'].createElement('div', {
          role: 'none',
          onClick: this.collapseMenu,
          className: 'common-menu-mask'
        });
        return _react2['default'].createElement(
          'div',
          {
            style: {
              height: '100%'
            }
          },
          _react2['default'].createElement(
            'div',
            {
              className: 'common-menu'
            },
            this.renderLeftMenu(child, selected || child[0], expanded),
            location.pathname !== '/' && this.renderNewMenu(child, selected || child[0]),
            location.pathname !== '/' && this.renderRightMenu(selected || child[0])
          ),
          mask
        );
      } else {
        return null;
      }
    }
  }]);
  return CommonMenu;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = CommonMenu;