'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style3 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style4 = require('yqcloud-ui/lib/message/style');

var _message = require('yqcloud-ui/lib/message');

var _message2 = _interopRequireDefault(_message);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _axios = require('../axios');

var _axios2 = _interopRequireDefault(_axios);

var _Permission = require('../permission/Permission');

var _Permission2 = _interopRequireDefault(_Permission);

var _UtilStore = require('../../stores/UtilStore');

var _UtilStore2 = _interopRequireDefault(_UtilStore);

var _constants = require('../../common/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

window.$ = _jquery2['default'];
// 制作头像
function getFirst(str) {
  if (!str) {
    return '';
  }
  var re = /[\u4E00-\u9FA5]/g;
  for (var i = 0, len = str.length; i < len; i += 1) {
    if (re.test(str[i])) {
      return str[i];
    }
  }
  return str[0];
}

// 将\r\n或 \n转换为<br />
function transferString(content) {
  var string = content;
  try {
    string = string.replace(/\r\n/g, '<br />');
    string = string.replace(/\n/g, '<br />');
  } catch (e) {
    _message2['default'].info(e.message);
  }
  return string;
}

var Robots = (_dec = (0, _mobxReact.inject)('AppState'), (0, _reactIntl.injectIntl)(_class = _dec(_class = function (_Component) {
  (0, _inherits3['default'])(Robots, _Component);

  function Robots(props) {
    (0, _classCallCheck3['default'])(this, Robots);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (Robots.__proto__ || Object.getPrototypeOf(Robots)).call(this, props));

    _this.loadRobot = function () {
      _axios2['default'].get(process.env.API_HOST + '/chatrobot/v1/' + _this.props.AppState.currentMenuType.id + '/chatrobot/basicInfo').then(function (data) {
        if (!data.failed) {
          _this.setState({
            robot: (0, _extends3['default'])({}, data, {
              associateMessage: JSON.parse(data.associateMessage),
              unknownMessage: JSON.parse(data.unknownMessage),
              greetingMessage: JSON.parse(data.greetingMessage),
              timeoutMessage: JSON.parse(data.timeoutMessage)
            })
          });
        }
      });
    };

    _this.windowHeight = function () {
      var height = document.documentElement.clientHeight;

      var contentHeight = document.getElementById('robot-nano');
      if (contentHeight) {
        contentHeight.style.height = height - 228 + 'px';
      }
    };

    _this.getSettingConfig = function (iamOrganizationId) {
      _axios2['default'].get('/chatrobot/v1/' + iamOrganizationId + '/config').then(function (json) {
        _this.setState({
          enableRobot: json.userShow
        });
      });
    };

    _this.setRobotHidden = function () {
      var robotSlide = document.getElementById('robot_slide');
      var robotAttr = document.getElementById('robot');

      if (robotAttr.style.right === '0px') {
        robotAttr.style.right = '-400px';
        robotSlide.style.display = 'block';
        window.document.getElementById('iframe').style.display = 'block';
      } else {
        robotAttr.style.right = '0px';
        robotSlide.style.display = 'none';
        _this.setState({
          url: _this.getSrc()
        });
      }
    };

    _this.onLoad = function () {
      // 向子窗口发送消息接口
      var iframeWindow = document.getElementById('iframe').contentWindow;
      _this.sendMsgToFrame = function (msg) {
        // iframeWindow.postMessage(msg, this.state.url);
      };
    };

    _this.createOrder = function (e) {
      e.preventDefault();
      var href = window.location.href.split('#')[0];
      var link = href + '#/itsm/event/createEvent?type=organization&id=' + _this.props.AppState.currentMenuType.id + '&name=' + _this.props.AppState.currentMenuType.name + '&organizationId=' + _this.props.AppState.currentMenuType.id + '&isQuick=Y';
      window.open(link, '_blank');
    };

    _this.state = {
      enableRobot: false, // 机器人是否开启 后端返回
      translateY: 0,
      moving: false,
      lastY: null,
      enterpriseEable: false,
      url: ''
    };
    window.onmouseup = function (e) {
      return _this.onMouseUp(e);
    };
    window.onmousemove = function (e) {
      return _this.onMouseMove(e);
    };
    return _this;
  }

  (0, _createClass3['default'])(Robots, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var currentMenuType = this.props.AppState.currentMenuType;
      var iamOrganizationId = currentMenuType.id;

      _UtilStore2['default'].queryLanguage(iamOrganizationId, this.props.AppState.currentLanguage);
      this.getSettingConfig(iamOrganizationId);
      this.queryEnterprise();
      window.addEventListener('message', this.onFrameMsg.bind(this), false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('click', this.hello);
    }

    // render初始渲染之后

  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      setInterval(this.windowHeight, 500);

      // 运行iframe获取媒体权限
      var iframe = window.document.getElementById("iframe");
      iframe.allow = "microphone;camera;midi;encrypted-media;";
    }
  }, {
    key: 'closeRobot',
    value: function closeRobot() {
      var robotSlide = document.getElementById('robot_slide');
      var robotAttr = document.getElementById('robot');
      if (robotAttr.style.right === '0px') {
        robotAttr.style.right = '-400px';
        robotSlide.style.display = 'block';
        window.document.getElementById('iframe').style.display = 'block';
      } else {
        robotAttr.style.right = '-400px';
        robotSlide.style.display = 'block';
      }
    }
  }, {
    key: 'onFrameMsg',
    value: function onFrameMsg(e) {
      // 2020.4.24不上线 jyjin
      if (e && e.data) {
        // 只关闭不重新加载
        if (e.data.type === 'MIN_CHAT') {
          this.closeRobot();
        }
        // 关闭并刷新frame
        else if (e.data.type === 'END_CHAT') {
            this.setState({
              url: ''
            }, this.closeRobot);
          }
      }
    }
  }, {
    key: 'queryEnterprise',
    value: function queryEnterprise() {
      var _this2 = this;

      _axios2['default'].get('iam/v1/' + this.props.AppState.currentMenuType.id + '/type').then(function (data) {
        if (data) {
          _this2.setState({
            enterpriseEable: data
          });
        }
      });
    }

    /* 加载机器人配置 */


    // 自动根据伸缩计算机器人高度


    // 显示隐藏机器人

  }, {
    key: 'getSrc',
    value: function getSrc() {
      var _state = this.state,
          enableRobot = _state.enableRobot,
          enterpriseEable = _state.enterpriseEable;
      var currentMenuType = this.props.AppState.currentMenuType;
      var iamOrganizationId = currentMenuType.id,
          name = currentMenuType.name;

      var token = document.cookie.split(';').find(function (item) {
        return ~item.indexOf('access_token=');
      }).split('=')[1];
      var clientId = 'public';
      var clientType = 'default';
      // 如果是公版本
      if (enterpriseEable !== 'PUBLIC') {
        clientId = _constants.CLIENT_ID;
        clientType = _constants.CLIENT_TYPE;
      }
      var url = process.env.CHAT_CUSTOMER_ONLINE + '/#/' + clientId + '__' + clientType + '/' + token + '/' + iamOrganizationId + '/' + name;
      if (_constants.CLIENT_ID !== 'yqcloud') {
        url = process.env.CHAT_CUSTOMER_ONLINE + '/#/' + clientId + '__' + clientType + '/' + token + '/' + iamOrganizationId + '/' + name;
      }
      console.log('frame src == ', url);
      return url;
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e) {
      e.stopPropagation();
      this.setState({ moving: false });
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      this.setState({ moving: false, lastY: null });
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(e) {
      var moving = this.state.moving;

      if (moving) {
        this.onMove(e);
      }
    }
  }, {
    key: 'onMove',
    value: function onMove(e) {
      var _state2 = this.state,
          translateY = _state2.translateY,
          lastY = _state2.lastY;

      if (lastY) {
        // let dx = e.clientX - this.lastX;
        var dy = e.clientY - this.lastY;
        this.setState({ translateY: translateY + dy });
      }
      // this.lastX = e.clientX;
      this.setState({ lastY: e.clientY });
    }

    // frame loaded

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state3 = this.state,
          enableRobot = _state3.enableRobot,
          enterpriseEable = _state3.enterpriseEable,
          url = _state3.url;

      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].createElement(
          'div',
          { id: 'robot', className: 'smartnlp-robot  smartnlp-robot-mini', style: { position: 'fixed', zIndex: 999, opacity: 1, right: '-400px' } },
          _react2['default'].createElement('iframe', { id: 'iframe', name: 'iframe', frameBorder: 'none', width: '100%', height: '100%', style: { border: 'none' }, src: url, onLoad: this.onLoad }),
          _react2['default'].createElement(
            'div',
            { className: 'smartnlp-robot-content', id: 'smartnlp-robot-content' },
            _react2['default'].createElement(
              'ul',
              { className: 'smartnlp-robot-slide', id: 'robot_slide' },
              _react2['default'].createElement(
                _Permission2['default'],
                { service: ['yqcloud-chatrobot-service.cr-config.selectConfig'] },
                _react2['default'].createElement(
                  'li',
                  { className: 'smartnlp-robot-slide-btn', value: 1, onMouseDown: function onMouseDown(e) {
                      return _this3.onMouseDown(e);
                    }, onClick: function onClick() {
                      return _this3.setRobotHidden();
                    } },
                  _react2['default'].createElement(
                    _tooltip2['default'],
                    {
                      placement: 'left',
                      title: _UtilStore2['default'].language.robot
                    },
                    _react2['default'].createElement('span', { className: 'icon-jiqiren1 icon' })
                  )
                )
              ),
              _react2['default'].createElement(
                _Permission2['default'],
                { service: ['yqcloud-itsm-service.event-order.save'] },
                _react2['default'].createElement(
                  'li',
                  { className: 'smartnlp-robot-slide-btn', style: { borderTop: '1px solid rgba(255,255,255,0.4)' }, value: 2, onMouseDown: function onMouseDown(e) {
                      return _this3.onMouseDown(e);
                    }, onClick: this.createOrder },
                  _react2['default'].createElement(
                    _tooltip2['default'],
                    {
                      placement: 'left',
                      title: _UtilStore2['default'].language['new.order']
                    },
                    _react2['default'].createElement('span', { className: 'icon-gongzuotaixinjianfuwudanx icon' })
                  )
                )
              )
            )
          )
        )
      );
    }
  }]);
  return Robots;
}(_react.Component)) || _class) || _class);
exports['default'] = Robots;