'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _object = require('object.omit');

var _object2 = _interopRequireDefault(_object);

var _AppState = require('../../stores/AppState');

var _AppState2 = _interopRequireDefault(_AppState);

var _PermissionStore = require('../../stores/PermissionStore');

var _PermissionStore2 = _interopRequireDefault(_PermissionStore);

var _PermissionWrapper = require('./PermissionWrapper');

var _PermissionWrapper2 = _interopRequireDefault(_PermissionWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Permission = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3['default'])(Permission, _Component);

  function Permission() {
    (0, _classCallCheck3['default'])(this, Permission);
    return (0, _possibleConstructorReturn3['default'])(this, (Permission.__proto__ || Object.getPrototypeOf(Permission)).apply(this, arguments));
  }

  (0, _createClass3['default'])(Permission, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.check(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.check(nextProps);
    }
  }, {
    key: 'check',
    value: function check(props) {
      _PermissionStore2['default'].check(this.getPermissionProps(props));
    }
  }, {
    key: 'getPermissionProps',
    value: function getPermissionProps(props) {
      var _AppState$currentMenu = _AppState2['default'].currentMenuType,
          typeState = _AppState$currentMenu.type,
          id = _AppState$currentMenu.id,
          projectIdState = _AppState$currentMenu.projectId,
          organizationIdState = _AppState$currentMenu.organizationId;
      var service = props.service,
          _props$type = props.type,
          type = _props$type === undefined ? typeState : _props$type,
          _props$organizationId = props.organizationId,
          organizationId = _props$organizationId === undefined ? organizationIdState || id : _props$organizationId,
          _props$projectId = props.projectId,
          projectId = _props$projectId === undefined ? projectIdState || id : _props$projectId;

      return {
        service: service,
        type: type,
        organizationId: organizationId,
        projectId: projectId
      };
    }
  }, {
    key: 'extendProps',
    value: function extendProps(children, props) {
      if ((0, _react.isValidElement)(children)) {
        return _react.Children.map(children, function (child) {
          if ((0, _react.isValidElement)(child)) {
            return (0, _react.cloneElement)(child, props);
          } else {
            return child;
          }
        });
      } else {
        return children;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          defaultChildren = _props.defaultChildren,
          children = _props.children,
          noAccessChildren = _props.noAccessChildren,
          onAccess = _props.onAccess;

      var otherProps = (0, _object2['default'])(this.props, ['service', 'type', 'organizationId', 'projectId', 'defaultChildren', 'noAccessChildren', 'children', 'onAccess']);
      var status = _PermissionStore2['default'].access(this.getPermissionProps(this.props));
      if (status === 'success') {
        return _react2['default'].createElement(
          _PermissionWrapper2['default'],
          { onAccess: onAccess },
          this.extendProps(children, otherProps)
        );
      } else if (status === 'failure' && (noAccessChildren || defaultChildren)) {
        return this.extendProps(noAccessChildren || defaultChildren, otherProps);
      } else if (status === 'pending' && defaultChildren) {
        return this.extendProps(defaultChildren, otherProps);
      } else {
        return null;
      }
    }
  }]);
  return Permission;
}(_react.Component), _class2.propTypes = {
  service: _propTypes2['default'].arrayOf(_propTypes2['default'].string).isRequired,
  type: _propTypes2['default'].string,
  projectId: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]),
  organizationId: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]),
  defaultChildren: _propTypes2['default'].node,
  noAccessChildren: _propTypes2['default'].node,
  onAccess: _propTypes2['default'].func
}, _temp)) || _class;

exports['default'] = Permission;