'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style7 = require('yqcloud-ui/lib/col/style');

var _col = require('yqcloud-ui/lib/col');

var _col2 = _interopRequireDefault(_col);

var _style8 = require('yqcloud-ui/lib/row/style');

var _row = require('yqcloud-ui/lib/row');

var _row2 = _interopRequireDefault(_row);

var _style9 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _style10 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style11 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style12 = require('yqcloud-ui/lib/tabs/style');

var _tabs = require('yqcloud-ui/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

var _index = require('../index');

var _MyCalendar = require('./myCalendar/MyCalendar');

var _MyCalendar2 = _interopRequireDefault(_MyCalendar);

var _index2 = require('./announcement/index');

var _index3 = _interopRequireDefault(_index2);

require('./PortalHome.scss');

var _MyTasks = require('./myTasks/MyTasks');

var _MyTasks2 = _interopRequireDefault(_MyTasks);

var _KnowledgeBase = require('./knowledgeBase/KnowledgeBase');

var _KnowledgeBase2 = _interopRequireDefault(_KnowledgeBase);

var _portal = require('../../../assets/images/portal.svg');

var _portal2 = _interopRequireDefault(_portal);

var _ProjectService = require('./projectServiceLists/ProjectService');

var _ProjectService2 = _interopRequireDefault(_ProjectService);

var _ProjectServiceStore = require('../../stores/ProjectServiceStore');

var _ProjectServiceStore2 = _interopRequireDefault(_ProjectServiceStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabPane = _tabs2['default'].TabPane;


var intlPrefix = 'organization.header';
var PortalHome = (_dec = (0, _mobxReact.inject)('AppState', 'PortalStore', 'HeaderStore'), (0, _reactIntl.injectIntl)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(PortalHome, _Component);
  (0, _createClass3['default'])(PortalHome, [{
    key: 'getInitState',
    value: function getInitState() {
      return {
        selectData: '',
        moduleData: [],
        organizationId: this.props.AppState.currentMenuType.id,
        data: [],
        updateUserModelLayoutData: [],
        portalId: '',
        welcomeSloganList: [],
        tipsDisplay: 'none'
      };
    }
  }]);

  function PortalHome(props) {
    (0, _classCallCheck3['default'])(this, PortalHome);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (PortalHome.__proto__ || Object.getPrototypeOf(PortalHome)).call(this, props));

    _this.getCookie = function (objName) {
      var arrStr = document.cookie.split("; ");
      for (var i = 0; i < arrStr.length; i++) {
        var temp = arrStr[i].split("=");
        if (temp[0] === objName) return temp[1];
      }
    };

    _this.fetch = function () {
      var _this$props = _this.props,
          AppState = _this$props.AppState,
          HeaderStore = _this$props.HeaderStore,
          history = _this$props.history;

      var path = void 0;
      var code = 'SYS_WELCOME';
      if (AppState.currentMenuType.id) {
        var _AppState$currentMenu = AppState.currentMenuType,
            id = _AppState$currentMenu.id,
            name = _AppState$currentMenu.name,
            type = _AppState$currentMenu.type;

        path = '/?type=' + type + '&id=' + id + '&name=' + name + '&organizationId=' + id;
        _this.loadWelcome(id, code);
      } else {
        HeaderStore.axiosGetOrgMsg(AppState.userInfo.currentOrganizationId, AppState.userInfo.id).then(function (value) {
          if (value) {
            value.type = 'organization';
            var _id = value.id,
                _name = value.name,
                _type = value.type;

            path = '?type=' + _type + '&id=' + _id + '&name=' + _name;
            if (_id) {
              path += '&organizationId=' + _id;
            }
            _this.loadWelcome(_id, code);
            history.push(path);
          }
        });
      }
    };

    _this.loadWelcome = function (id, code) {
      _index.axios.get('/fnd/v1/' + id + '/lookup/value/dto/proTic?lookupTypeCode=' + code).then(function (data) {
        if (data.failed) {
          //
        } else {
          _this.setState({
            welcomeSloganList: data
          });
        }
      });
    };

    _this.handleChange = function (key) {
      if (key === '1') {} else {}
    };

    _this.state = _this.getInitState();
    return _this;
  }

  (0, _createClass3['default'])(PortalHome, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var explorer = window.navigator.userAgent;
      var tipsDisplayCookie = this.getCookie('tipsDisplay');
      if (explorer.indexOf('MSIE') >= 0 || "ActiveXObject" in window) {
        this.setState({
          tipsDisplay: tipsDisplayCookie ? tipsDisplayCookie : 'block'
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.fetch();
    }

    /**
    * 切换tab
    * @param
    */

  }, {
    key: 'render',


    // onLinkWorkflow = (item) => {
    //   const { history } = this.props;
    //   const link = item.link.split('#')[1];
    //   console.log(link);
    //   history.push(link);
    // }
    //
    // onLinkITSM = () => {
    //   const { history } = this.props;
    //   const organizationId = this.props.AppState.currentMenuType.id;
    //   const organizationName = this.props.AppState.currentMenuType.name;
    //   history.push(`/itsm/event?type=organization&id=${organizationId}&name=${organizationName}&organizationId=${organizationId}`);
    // }

    value: function render() {
      var _this2 = this;

      var welcomeSloganList = this.state.welcomeSloganList;
      var HeaderStore = this.props.HeaderStore;

      var welcometype = [];
      var welcomeSolganDes = [];

      if (welcomeSloganList) {
        welcomeSloganList.forEach(function (value) {
          if (value.lookupValue === 'TITLE') {
            welcometype.push(_react2['default'].createElement(
              'h4',
              null,
              value.lookupMeaning
            ));
          }
          if (value.lookupValue === 'DESP') {
            welcomeSolganDes.push(_react2['default'].createElement(
              'span',
              { className: 'welcome-Desc' },
              value.lookupMeaning
            ));
          }
        });
      }

      return _react2['default'].createElement(
        _index.Page,
        {
          service: ['yqcloud-portal-service.announcement.selectDetail', 'yqcloud-portal-service.user-portal-configuration.selectUserBacklog', 'yqcloud-portal-service.announcement.selectListByUserId', 'yqcloud-portal-service.announcement.view', 'yqcloud-portal-service.announcement.selectDetail', 'yqcloud-portal-service.announcement.viewCount', 'yqcloud-knowledge-service.knowledge-basic-info.selectFocusBasicInfo', 'yqcloud-portal-service.portal-stroke.createStroke', 'yqcloud-portal-service.portal-stroke.updateStroke', 'yqcloud-portal-service.portal-stroke.selectStrokesByYM', 'yqcloud-portal-service.portal-stroke.selectStrokes', 'yqcloud-portal-service.portal-stroke.selectStrokesById', 'yqcloud-fnd-service.lookup-type.queryByCode', 'iam-service.organization-user.acceptInvitation', 'iam-service.organization-user.refuseInvitation']
        },
        _react2['default'].createElement(
          _index.Content,
          { className: 'wb-content', style: { padding: 0 }, robot: true },
          _react2['default'].createElement(
            'div',
            { style: { display: this.state.tipsDisplay }, className: 'page-tips' },
            _react2['default'].createElement(_icon2['default'], { type: 'jingshitixing', style: { fontSize: 16, color: '#FF9500', marginBottom: '3px', marginRight: '5px' } }),
            _react2['default'].createElement(
              'span',
              null,
              HeaderStore.language[intlPrefix + '.tipsTop']
            ),
            _react2['default'].createElement(
              _button2['default'],
              {
                onClick: function onClick() {
                  document.cookie = "tipsDisplay=none";
                  _this2.setState({
                    tipsDisplay: 'none'
                  });
                },
                className: 'tips_button'
              },
              _react2['default'].createElement(_icon2['default'], { type: 'wenjianshanchu', style: { fontSize: 16, color: 'ddd', margin: '0' } })
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'wb-header', style: { backgroundImage: 'url(' + _portal2['default'] + ')' } },
            _react2['default'].createElement(
              'div',
              { className: 'wb-title' },
              welcometype,
              _react2['default'].createElement(
                _tooltip2['default'],
                {
                  overlayClassName: 'portal-welcome-title'
                  // mouseLeaveDelay={1000}
                  , title: welcomeSolganDes
                },
                _react2['default'].createElement(
                  'div',
                  null,
                  welcomeSolganDes
                )
              )
            )
          ),
          _react2['default'].createElement(
            _row2['default'],
            { gutter: 10, style: { height: '87%', padding: '0 28px 28px 28px' } },
            _react2['default'].createElement(
              _col2['default'],
              { xl: 18, lg: 18, md: 18, sm: 24, xs: 24, style: { height: '100%' } },
              _react2['default'].createElement(
                _row2['default'],
                { style: { height: '53%' } },
                _react2['default'].createElement(_MyTasks2['default'], null)
              ),
              _react2['default'].createElement(
                _row2['default'],
                { gutter: 10, style: { marginTop: 10, height: '45.5%' } },
                _react2['default'].createElement(
                  _col2['default'],
                  { xl: 12, lg: 12, md: 12, sm: 12, xs: 12, style: { height: '100%' } },
                  _react2['default'].createElement(_index3['default'], {
                    onRef: function onRef(node) {
                      _this2.announcement = node;
                    }
                  })
                ),
                _react2['default'].createElement(
                  _col2['default'],
                  { xl: 12, lg: 12, md: 12, sm: 12, xs: 12, style: { height: '100%' } },
                  _react2['default'].createElement(_KnowledgeBase2['default'], null)
                )
              )
            ),
            _react2['default'].createElement(
              _col2['default'],
              { xl: 6, style: { height: '100%' } },
              _react2['default'].createElement(
                _tabs2['default'],
                {
                  id: 'rightTab',
                  className: 'fix-tab-wrap',
                  defaultActiveKey: '1',
                  size: 'small',
                  onChange: this.handleChange.bind(this)
                },
                _react2['default'].createElement(
                  TabPane,
                  {
                    className: 'fix-tab-1',
                    tab: _react2['default'].createElement(
                      'span',
                      { style: { fontSize: 16 } },
                      _ProjectServiceStore2['default'].language['portal.projectList.title'] || ''
                    ),
                    key: '1'
                  },
                  _react2['default'].createElement(_ProjectService2['default'], null)
                ),
                _react2['default'].createElement(
                  TabPane,
                  { className: 'fix-tab-2', tab: _react2['default'].createElement(
                      'span',
                      { style: { fontSize: 16 } },
                      _ProjectServiceStore2['default'].language['portal.projectList.calender'] || ''
                    ), key: '2' },
                  _react2['default'].createElement(_MyCalendar2['default'], null)
                )
              )
            )
          )
        )
      );
    }
  }]);
  return PortalHome;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = PortalHome;