'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style3 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style4 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

var _quillDeltaToHtml = require('quill-delta-to-html');

var _equal = require('../../../../components/equal');

var _equal2 = _interopRequireDefault(_equal);

var _ChartCard = require('../../../../components/chartCard/ChartCard');

var _ChartCard2 = _interopRequireDefault(_ChartCard);

var _AnnouncementStore = require('../../../stores/AnnouncementStore');

var _AnnouncementStore2 = _interopRequireDefault(_AnnouncementStore);

require('./Announcement.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 *  公告
 */

var Announcement = (_dec = (0, _mobxReact.inject)('AppState'), (0, _reactIntl.injectIntl)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(Announcement, _Component);

  function Announcement(props) {
    (0, _classCallCheck3['default'])(this, Announcement);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (Announcement.__proto__ || Object.getPrototypeOf(Announcement)).call(this, props));

    _this.reloadAnnouncement = function () {
      _this.setState(_this.getInitState(), function () {
        _this.loadAnnouncementNoView();
        _this.loadAnnouncementList();
      });
    };

    _this.loadAnnouncementList = function (paginationIn) {
      var AppState = _this.props.AppState;
      var paginationState = _this.state.pagination;
      var organizationId = AppState.currentMenuType.id;

      var pagination = paginationIn || paginationState;
      _AnnouncementStore2['default'].loadAnnouncementList(organizationId, pagination).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _AnnouncementStore2['default'].setIsLoading(false);
          _AnnouncementStore2['default'].setAnnouncements(data.content.slice());
          _this.setState({
            data: data.content,
            pagination: {
              current: data.number + 1,
              pageSize: data.size,
              total: data.totalElements,
              pageSizeOptions: [25, 50, 100, 200]
            }
          });
        }
      });
    };

    _this.loadAnnouncementNoView = function () {
      var AppState = _this.props.AppState;
      var organizationId = AppState.currentMenuType.id;

      _AnnouncementStore2['default'].getAnnouncementNoView(organizationId).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ announcementNoView: data });
        }
      });
    };

    _this.announcementPreview = function (announcementId) {
      var AppState = _this.props.AppState;
      var organizationId = AppState.currentMenuType.id;

      _AnnouncementStore2['default'].getAnnouncementById(organizationId, announcementId).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ announcementData: data, preview: true });
        }
      });
      _AnnouncementStore2['default'].viewAnnouncement(organizationId, announcementId).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        }
      });
    };

    _this.handleDownload = function (item) {
      var AppState = _this.props.AppState;
      var organizationId = AppState.currentMenuType.id;

      _AnnouncementStore2['default'].downloadFile(organizationId, item.attachmentId).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          var fileUrl1 = data.fileUrl;
          window.open(fileUrl1);
        }
      });
    };

    _this.renderPreviewContent = function (data) {
      var fileOptions = [];
      var content = new _quillDeltaToHtml.QuillDeltaToHtmlConverter(JSON.parse(data.content), {}).convert();
      if (data.attachments) {
        data.attachments.forEach(function (item) {
          fileOptions.push(_react2['default'].createElement(
            'p',
            null,
            _react2['default'].createElement(_icon2['default'], { style: { marginRight: 10, cursor: 'pointer', width: 14, color: '#2196F3' }, onClick: _this.handleDownload.bind(_this, item), type: 'zhishixiangqingxiazaix' }),
            _react2['default'].createElement(
              'span',
              { style: { marginRight: 10, cursor: 'pointer' }, className: 'file-title', onClick: _this.handleDownload.bind(_this, item) },
              item.attachmentName,
              item.fileType
            ),
            _react2['default'].createElement(
              'span',
              null,
              _react2['default'].createElement(
                'span',
                { style: { color: '#818999', cursor: 'pointer' } },
                '(',
                item.attachmentSize / (1024 * 1024) > 1 ? Math.round(item.attachmentSize / (1024 * 1024) * 100) / 100 + ' M' : Math.round(item.attachmentSize / 1024 * 100) / 100 + ' kb',
                ')'
              )
            )
          ));
        });
      }
      var contentStyle = {
        paddingTop: 10,
        color: '#3C4D73',
        wordWrap: 'break-word',
        wordBreak: 'break-all',
        overflow: 'scroll',
        maxHeight: '45vh',
        minHeight: '40vh'
      };
      return _react2['default'].createElement(
        'div',
        { style: { padding: '20px 28px', borderRadius: 2 } },
        _react2['default'].createElement(
          'p',
          {
            style: {
              fontSize: 14,
              color: '#04173F',
              lineHeight: '20px',
              fontWeight: 400,
              marginBottom: 5
            }
          },
          data.title || ''
        ),
        _react2['default'].createElement(
          'p',
          { style: { color: '#818899' } },
          _react2['default'].createElement(
            'span',
            { style: { marginRight: 23 } },
            '\u53D1\u5E03\u65F6\u95F4\uFF1A',
            data.startTime.split(' ')[0] || ''
          ),
          '\u521B\u5EFA\u4EBA:',
          data.createByName || ''
        ),
        _react2['default'].createElement('div', { className: 'ann-content', style: contentStyle, dangerouslySetInnerHTML: { __html: '' + (content || '') } }),
        data.attachments && data.attachments.length > 0 ? _react2['default'].createElement(
          'div',
          { style: { paddingTop: 10, borderTop: '1px solid #EBF1F5' } },
          fileOptions
        ) : ''
      );
    };

    _this.renderElement = function (item) {
      return _react2['default'].createElement(
        'div',
        { className: 'ann-item', key: 'anno_' + item.announcementId },
        item.isViewed === 'N' ? _react2['default'].createElement('div', { className: 'point' }) : '',
        _react2['default'].createElement(
          'div',
          { className: 'ann-title wb-link' },
          _react2['default'].createElement(
            'span',
            { className: 'wk-link', onClick: _this.announcementPreview.bind(_this, item.announcementId) },
            item.title
          ),
          _react2['default'].createElement(
            'div',
            { className: 'ann-element-list' },
            _react2['default'].createElement(
              'div',
              { className: 'ann-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-ren' }),
              _react2['default'].createElement(
                'span',
                null,
                item.createByName
              )
            ),
            _react2['default'].createElement(
              'div',
              { className: 'ann-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-shijian' }),
              _react2['default'].createElement(
                'span',
                null,
                item.startTime.split(' ')[0]
              )
            )
          )
        )
      );
    };

    _this.state = _this.getInitState();
    _this.organizationId = _this.props.AppState.currentMenuType.id;
    return _this;
  }

  (0, _createClass3['default'])(Announcement, [{
    key: 'getInitState',
    value: function getInitState() {
      return {
        announcementNoView: '',
        data: [],
        pagination: {
          current: 1,
          pageSize: 20,
          total: 0,
          pageSizeOptions: [25, 50, 100, 200]
        }
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      _AnnouncementStore2['default'].queryLanguage(this.organizationId, this.props.AppState.currentLanguage);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.props.onRef(this);
      this.loadAnnouncementList();
      this.loadAnnouncementNoView();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _equal2['default'])(this.props, nextProps)) {
        this.reloadAnnouncement();
      }
    }

    /* 刷新数据 */


    /* 加载用户公告信息列表 */


    /**
     * 点击查看公告详情
     * @param announcementId 公告Id
     */


    /**
     *  渲染公告内容
     * @param data
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          announcementNoView = _state.announcementNoView,
          data = _state.data,
          announcementData = _state.announcementData;


      return _react2['default'].createElement(
        _ChartCard2['default'],
        {
          title: _AnnouncementStore2['default'].language.announcement,
          total: announcementNoView,
          loading: _AnnouncementStore2['default'].getIsLoading,
          style: { padding: '6px 0 10px 0', marginTop: 1, overflowY: 'scroll', borderBottom: '1px solid #CCD3D9' }
        },
        _react2['default'].createElement(
          'div',
          { className: 'ann-list' },
          data && data.map(this.renderElement)
        ),
        this.state.preview ? _react2['default'].createElement(
          _modal2['default'],
          {
            title: _AnnouncementStore2['default'].language.announcement,
            visible: this.state.preview,
            footer: null,
            width: '50%',
            className: 'ann-modal',
            onCancel: function onCancel() {
              _this2.setState({ preview: false });
              _this2.reloadAnnouncement();
            },
            style: { top: 100 }
          },
          this.renderPreviewContent(announcementData)
        ) : ''
      );
    }
  }]);
  return Announcement;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = Announcement;