'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _style9 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style10 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _style11 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style12 = require('yqcloud-ui/lib/select/style');

var _select = require('yqcloud-ui/lib/select');

var _select2 = _interopRequireDefault(_select);

var _style13 = require('yqcloud-ui/lib/input/style');

var _input = require('yqcloud-ui/lib/input');

var _input2 = _interopRequireDefault(_input);

var _style14 = require('yqcloud-ui/lib/form/style');

var _form = require('yqcloud-ui/lib/form');

var _form2 = _interopRequireDefault(_form);

var _style15 = require('yqcloud-ui/lib/date-picker/style');

var _datePicker = require('yqcloud-ui/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

var _style16 = require('yqcloud-ui/lib/radio/style');

var _radio = require('yqcloud-ui/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _dec, _dec2, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _mobxReact = require('mobx-react');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _FullEditor = require('../../../../components/FullEditor');

var _FullEditor2 = _interopRequireDefault(_FullEditor);

var _CalendarStore = require('../../../stores/CalendarStore');

var _CalendarStore2 = _interopRequireDefault(_CalendarStore);

require('./EditStroke.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioGroup = _radio2['default'].Group;
var RangePicker = _datePicker2['default'].RangePicker;

var FormItem = _form2['default'].Item;
var TextArea = _input2['default'].TextArea;
var Option = _select2['default'].Option;

var intlPrefix = 'organization.setting.calendar';

var dateFormat = 'YYYY-MM-DD HH:mm:ss';

var inputStyle = {
  width: '100%',
  fontSize: '14px'
};

function noop() {}

var EditStroke = (_dec = _form2['default'].create({}), _dec2 = (0, _mobxReact.inject)('AppState'), _dec(_class = (0, _reactIntl.injectIntl)(_class = _dec2(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(EditStroke, _Component);

  function EditStroke(props) {
    (0, _classCallCheck3['default'])(this, EditStroke);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (EditStroke.__proto__ || Object.getPrototypeOf(EditStroke)).call(this, props));

    _this.state = _this.getInitState();

    _this.getTypeCode = function () {
      var AppState = _this.props.AppState;

      var code = 'PORTAL_SCHEDULE_TYPE';
      _CalendarStore2['default'].getTypeCode(AppState.userInfo.organizationId, code).then(function (data) {
        _this.setState({
          tenantType: data
        });
      })['catch'](function (error) {
        Choerodon.handleResponseError(error);
      });
    };

    _this.handleEffective = function (e) {
      var _this$props = _this.props,
          _this$props$onSubmit = _this$props.onSubmit,
          onSubmit = _this$props$onSubmit === undefined ? noop : _this$props$onSubmit,
          _this$props$onSuccess = _this$props.onSuccess,
          onSuccess = _this$props$onSuccess === undefined ? noop : _this$props$onSuccess,
          _this$props$onError = _this$props.onError,
          onError = _this$props$onError === undefined ? noop : _this$props$onError,
          intl = _this$props.intl;

      var iamOrganizationId = _this.props.AppState.currentMenuType.id;
      var userId = _this.props.AppState.userInfo.id;
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, data) {
        var date = data.rangeTime[0];
        var strokeInfo = (0, _extends3['default'])({}, _this.state.strokeInfo, {
          iamOrganizationId: iamOrganizationId,
          userId: userId,
          isEnabled: 'Y'
        });
        _CalendarStore2['default'].updateStroke(_this.organizationId, strokeInfo).then(function (_ref) {
          var failed = _ref.failed,
              message = _ref.message;

          if (failed) {
            onError();
          } else {
            Choerodon.prompt(_CalendarStore2['default'].language['modify.success']);
            onSuccess(date);
          }
        })['catch'](function (error) {
          Choerodon.handleResponseError(error);
        });
      });
    };

    _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, data, modify) {
        if (!err) {
          var _this$props2 = _this.props,
              edit = _this$props2.edit,
              _this$props2$onSubmit = _this$props2.onSubmit,
              onSubmit = _this$props2$onSubmit === undefined ? noop : _this$props2$onSubmit,
              _this$props2$onSucces = _this$props2.onSuccess,
              onSuccess = _this$props2$onSucces === undefined ? noop : _this$props2$onSucces,
              _this$props2$onError = _this$props2.onError,
              onError = _this$props2$onError === undefined ? noop : _this$props2$onError,
              _this$props2$OnUnchan = _this$props2.OnUnchangedSuccess,
              OnUnchangedSuccess = _this$props2$OnUnchan === undefined ? noop : _this$props2$OnUnchan,
              intl = _this$props2.intl;

          var iamOrganizationId = _this.props.AppState.currentMenuType.id;
          var userId = _this.props.AppState.userInfo.id;
          var date = data.rangeTime[0];
          data.startTime = data.rangeTime[0].format(dateFormat);
          data.endTime = data.rangeTime[1].format(dateFormat);
          delete data.rangeTime;
          onSubmit();
          if (edit) {
            var strokeInfo = (0, _extends3['default'])({}, _this.state.strokeInfo, data, {
              iamOrganizationId: iamOrganizationId,
              userId: userId
            });
            _CalendarStore2['default'].updateStroke(_this.organizationId, strokeInfo).then(function (_ref2) {
              var failed = _ref2.failed,
                  message = _ref2.message;

              if (failed) {
                onError();
              } else {
                Choerodon.prompt(_CalendarStore2['default'].language['modify.success']);
                onSuccess(date);
              }
            })['catch'](function (error) {
              Choerodon.handleResponseError(error);
            });
          } else {
            var _strokeInfo = (0, _extends3['default'])({}, data, {
              iamOrganizationId: iamOrganizationId,
              userId: userId
            });
            _CalendarStore2['default'].createStroke(_this.organizationId, _strokeInfo).then(function (_ref3) {
              var failed = _ref3.failed,
                  message = _ref3.message;

              if (failed) {
                onError();
              } else {
                Choerodon.prompt(_CalendarStore2['default'].language['create.success']);
                onSuccess(date);
              }
            })['catch'](function (error) {
              onError();
              Choerodon.handleResponseError(error);
            });
          }
        }
      });
    };

    _this.handleCancel = function (e) {
      var _this$props3 = _this.props,
          _this$props3$OnUnchan = _this$props3.OnUnchangedSuccess,
          OnUnchangedSuccess = _this$props3$OnUnchan === undefined ? noop : _this$props3$OnUnchan,
          intl = _this$props3.intl;

      _this.props.form.validateFieldsAndScroll(function (err, data, modify) {
        if (!modify) {
          OnUnchangedSuccess();
        } else {
          _modal2['default'].confirm({
            title: _CalendarStore2['default'].language['form.cancel.title'],
            content: _CalendarStore2['default'].language['form.cancel.content'],
            className: 'myCalendar-Cancel',
            onOk: function onOk() {
              return OnUnchangedSuccess();
            }
          });
        }
      });
    };

    _this.handleRemindChange = function (e) {
      var _this$props4 = _this.props,
          intl = _this$props4.intl,
          AppState = _this$props4.AppState;

      _this.setState({ remindType: e.target.value });
      if (e.target.value === 'email' && AppState.userInfo.email === 'undefined') {
        Choerodon.prompt(_CalendarStore2['default'].language[intlPrefix + '.emailCheck']);
      }
    };

    _this.handleSelectChange = function (e) {
      _this.props.form.setFieldsValue({
        remindTime: e.target.value
      });
    };

    _this.handleClick = function () {
      var delta = _this.props.form.getFieldValue('content');
      _this.setState({ full: true, form: false, delta: delta });
    };

    _this.callback = function (value) {
      _this.setState({
        delta: value,
        full: false,
        form: true
      });
    };

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    return _this;
  }

  (0, _createClass3['default'])(EditStroke, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.fetch(this.props);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.props.onRef(this);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!nextProps.visible) {
        nextProps.form.resetFields();
        this.setState(this.getInitState());
      } else if (!this.props.visible) {
        this.fetch(nextProps);
      }
    }
  }, {
    key: 'getInitState',
    value: function getInitState() {
      var AppState = this.props.AppState;

      var data = new Date();
      return {
        remindType: 'none',
        strokeInfo: {
          startTime: (0, _moment2['default'])(new Date()).format('YYYY-MM-DD HH:mm:ss'),
          endTime: (0, _moment2['default'])(new Date(data.getFullYear(), data.getMonth(), data.getDate(), 23, 59, 59)).format('YYYY-MM-DD HH:mm:ss'),
          isEnabled: 'Y',
          label: '',
          remindType: 'none',
          content: '',
          location: '',
          iamOrganizationId: this.organizationId,
          userId: AppState.userInfo.id
        },
        delta: '',
        form: false,
        calendarDate: (0, _moment2['default'])(new Date()),
        optionType: []
      };
    }

    /**
     * 通过id获取行程信息
     * @param tenantId 租户Id
     * @param strokeId 模块id
     */

  }, {
    key: 'getStrokeById',
    value: function getStrokeById(tenantId, strokeId) {
      var _this2 = this;

      _CalendarStore2['default'].getStrokeById(tenantId, strokeId).then(function (data) {
        _this2.setState({
          strokeInfo: data,
          remindType: data.remindType,
          delta: data.content,
          form: true
        });
      })['catch'](function (error) {
        Choerodon.handleResponseError(error);
      });
    }
  }, {
    key: 'fetch',
    value: function fetch(props) {
      var edit = props.edit,
          id = props.id,
          AppState = props.AppState;

      if (edit) {
        this.getStrokeById(this.organizationId, id);
      }
      _CalendarStore2['default'].queryLanguage(this.organizationId, AppState.currentLanguage);
      this.getTypeCode();
    }

    // 类型快码


    /**
     * 提交表单
     * @param e 表
     */


    /**
     * 返回提示
     * @param e 表单
     */


    /**
     * 提醒方式变化
     * @param
     */


    // 全屏编辑按钮


    // form控制显示是因为用setFieldsValue导致一个bug，delta又不会页面更新

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          edit = _props.edit,
          intl = _props.intl,
          invalid = _props.invalid;
      var _props$form = this.props.form,
          getFieldDecorator = _props$form.getFieldDecorator,
          setFieldsValue = _props$form.setFieldsValue;
      var _state = this.state,
          strokeInfo = _state.strokeInfo,
          delta = _state.delta,
          tenantType = _state.tenantType;


      var optionType = [];
      if (tenantType) {
        tenantType.forEach(function (item) {
          optionType.push(_react2['default'].createElement(
            Option,
            { value: item.lookupValue },
            item.lookupMeaning
          ));
        });
      }

      return _react2['default'].createElement(
        'div',
        { className: 'stroke-content' },

        // this.state.form ? (
        _react2['default'].createElement(
          _form2['default'],
          { onSubmit: this.handleSubmit.bind(this), layout: 'vertical' },
          _react2['default'].createElement(
            'div',
            { className: 'form-item' },
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', width: '56px' } },
              _react2['default'].createElement(
                'span',
                { style: { fontSize: '14px', color: '#3C4D73' } },
                _CalendarStore2['default'].language[intlPrefix + '.theme']
              ),
              _react2['default'].createElement(
                'span',
                { style: { color: '#e61e24' } },
                '*'
              )
            ),
            _react2['default'].createElement(
              FormItem,
              { className: 'Input_label', style: { width: '435px', display: 'inline-block', marginLeft: '14px' } },
              getFieldDecorator('label', {
                rules: [{
                  required: true,
                  message: _CalendarStore2['default'].language[intlPrefix + '.theme.require.msg']
                }],
                initialValue: strokeInfo.label || '',
                validateTrigger: 'onBlur',
                validateFirst: true
              })(_react2['default'].createElement(_input2['default'], {
                style: inputStyle,
                disabled: invalid,
                maxLength: 20
              }))
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'form-item', style: { marginTop: 25 } },
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', width: '56px' } },
              _react2['default'].createElement(
                'span',
                { style: { fontSize: '14px', color: '#3C4D73' } },
                _CalendarStore2['default'].language[intlPrefix + '.type']
              ),
              _react2['default'].createElement(
                'span',
                { style: { color: '#e61e24' } },
                '*'
              )
            ),
            _react2['default'].createElement(
              FormItem,
              { style: { width: '435px', display: 'inline-block', marginLeft: '14px' } },
              getFieldDecorator('typeCode', {
                rules: [{
                  required: true,
                  message: _CalendarStore2['default'].language[intlPrefix + '.typeTips']
                }],
                initialValue: strokeInfo.typeCode || ''
              })(_react2['default'].createElement(
                _select2['default'],
                { className: 'Select_right_one', style: inputStyle, disabled: invalid, placeholder: _CalendarStore2['default'].language[intlPrefix + '.type'] },
                optionType
              ))
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'form-item', style: { marginTop: 25 } },
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', width: '56px' } },
              _react2['default'].createElement(
                'span',
                { style: { fontSize: '14px', color: '#3C4D73' } },
                _CalendarStore2['default'].language[intlPrefix + '.time']
              ),
              _react2['default'].createElement(
                'span',
                { style: { color: '#e61e24' } },
                '*'
              )
            ),
            _react2['default'].createElement(
              FormItem,
              { style: { width: '435px', display: 'inline-block', marginLeft: '14px' } },
              getFieldDecorator('rangeTime', {
                rules: [{
                  required: true,
                  message: _CalendarStore2['default'].language[intlPrefix + '.time.require.msg']
                }],
                initialValue: [strokeInfo.startTime ? (0, _moment2['default'])(strokeInfo.startTime) : null, strokeInfo.endTime ? (0, _moment2['default'])(strokeInfo.endTime) : null]
              })(_react2['default'].createElement(RangePicker, {
                className: 'Select_right_two',
                showTime: { format: 'HH:mm:ss' },
                value: 'small',
                format: 'YYYY-MM-DD HH:mm:ss',
                style: inputStyle,
                disabled: invalid,
                allowClear: false,
                getPopupContainer: function getPopupContainer() {
                  return document.getElementsByClassName('form-item')[0].parentNode;
                },
                placeholder: [_CalendarStore2['default'].language[intlPrefix + '.startTime'], _CalendarStore2['default'].language[intlPrefix + '.endTime']],
                onOk: function onOk(value) {
                  _this3.props.form.setFieldsValue({ rangeTime: value });
                }
              }))
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'form-item', style: { marginBottom: 5, marginTop: 20 } },
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', width: '56px' } },
              _react2['default'].createElement(
                'span',
                { style: { fontSize: '14px', color: '#3C4D73' } },
                _CalendarStore2['default'].language[intlPrefix + '.address']
              )
            ),
            _react2['default'].createElement(
              FormItem,
              { style: { width: '435px', display: 'inline-block', marginLeft: '14px' } },
              getFieldDecorator('location', {
                initialValue: strokeInfo.location || '',
                validateFirst: true
              })(_react2['default'].createElement(_input2['default'], {
                autoComplete: 'off',
                disabled: invalid,
                style: (0, _extends3['default'])({}, inputStyle)
              }))
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'form-item', style: { marginBottom: 5, marginTop: 35, position: 'relative' } },
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', width: '56px' } },
              _react2['default'].createElement(
                'span',
                { style: { fontSize: '14px', color: '#3C4D73' } },
                _CalendarStore2['default'].language[intlPrefix + '.content']
              )
            ),
            _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block', position: 'absolute', right: '-15px', top: '-30px' } },
              _react2['default'].createElement(
                _button2['default'],
                { style: { height: '26px', lineHeight: '26px', marginRight: '16px', marginTop: '0' }, className: 'leftBtn', disabled: invalid, funcType: 'flat', onClick: this.handleClick },
                _react2['default'].createElement(_icon2['default'], { type: 'zoom_out_map' }),
                _react2['default'].createElement(
                  'span',
                  null,
                  _CalendarStore2['default'].language[intlPrefix + '.full.edit']
                )
              )
            ),
            _react2['default'].createElement(
              FormItem,
              { style: { width: '435px', display: 'inline-block', marginLeft: '14px' } },
              getFieldDecorator('content', {
                rules: [
                  // {
                  //   required: true,
                  //   message: CalendarStore.language[`${intlPrefix}.content.require.msg`],
                  // },
                ],
                validateTrigger: 'onBlur',
                initialValue: delta,
                validateFirst: true
              })(_react2['default'].createElement(TextArea, {
                autoComplete: 'off',
                maxLength: 200,
                disabled: invalid,
                style: (0, _extends3['default'])({}, inputStyle, { height: 85, border: '1px solid #CCD3D9', padding: '10px 12px', maxHeight: 85 })
              }))
            )
          ),
          _react2['default'].createElement(
            'div',
            { className: 'form-item', style: { marginBottom: 5 } },
            _react2['default'].createElement(
              'div',
              { className: 'item-title', style: { display: 'inline-block', width: '60px', marginRight: 10, fontSize: '14px', color: '#3C4D73' } },
              _CalendarStore2['default'].language[intlPrefix + '.reminder']
            ),
            _react2['default'].createElement(
              FormItem,
              { className: 'radio-item' },
              getFieldDecorator('remindType', {
                initialValue: strokeInfo.remindType || ''
              })(_react2['default'].createElement(
                RadioGroup,
                { disabled: invalid, onChange: this.handleRemindChange.bind(this) },
                _react2['default'].createElement(
                  _radio2['default'],
                  { value: 'none' },
                  _CalendarStore2['default'].language.none
                ),
                _react2['default'].createElement(
                  _radio2['default'],
                  { value: 'email' },
                  _CalendarStore2['default'].language.email
                )
              ))
            ),
            this.state.remindType === 'email' ? _react2['default'].createElement(
              'div',
              { style: { display: 'inline-block' } },
              _CalendarStore2['default'].language.before,
              _react2['default'].createElement(
                FormItem,
                { className: 'select-time' },
                getFieldDecorator('remindTime', {
                  rules: [{
                    required: true,
                    message: _CalendarStore2['default'].language[intlPrefix + '.remindTime.require.msg']
                  }],
                  validateTrigger: 'onBlur',
                  validateFirst: true,
                  initialValue: (strokeInfo.remindTime ? strokeInfo.remindTime : '5') + ',' + (strokeInfo.remindTimeType ? strokeInfo.remindTimeType : 'M') || ''
                })(_react2['default'].createElement(
                  _select2['default'],
                  { disabled: invalid, onchange: this.handleSelectChange.bind(this), style: { marginLeft: 10, width: 100 } },
                  _react2['default'].createElement(
                    Option,
                    { value: '5,M' },
                    _CalendarStore2['default'].language['5.min']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '15,M' },
                    _CalendarStore2['default'].language['15.min']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '30,M' },
                    _CalendarStore2['default'].language['30.min']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '1,H' },
                    _CalendarStore2['default'].language['1.hour']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '2,H' },
                    _CalendarStore2['default'].language['2.hour']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '1,D' },
                    _CalendarStore2['default'].language['1.day']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '2,D' },
                    _CalendarStore2['default'].language['2.day']
                  ),
                  _react2['default'].createElement(
                    Option,
                    { value: '1,W' },
                    _CalendarStore2['default'].language['1.week']
                  )
                ))
              )
            ) : ''
          )
        )
        // ) : null
        ,
        this.state.full ? _react2['default'].createElement(_FullEditor2['default'], {
          className: 'stork-full-modal',
          title: _CalendarStore2['default'].language[intlPrefix + '.editTodo'],
          initValue: this.state.delta,
          visible: this.state.full,
          onCancel: function onCancel() {
            return _this3.setState({ full: false, form: true });
          },
          onOk: this.callback,
          okText: _CalendarStore2['default'].language.ok,
          cancelText: _CalendarStore2['default'].language.cancel
        }) : null
      );
    }
  }]);
  return EditStroke;
}(_react.Component)) || _class) || _class) || _class) || _class);
exports['default'] = EditStroke;