'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style5 = require('yqcloud-ui/lib/spin/style');

var _spin = require('yqcloud-ui/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _style6 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _style7 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style8 = require('yqcloud-ui/lib/tabs/style');

var _tabs = require('yqcloud-ui/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

require('./KnowledgeBase.scss');

var _KnowledgeBaseStore = require('../../../stores/KnowledgeBaseStore');

var _KnowledgeBaseStore2 = _interopRequireDefault(_KnowledgeBaseStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *  知识库
 */
var TabPane = _tabs2['default'].TabPane;
var KnowledgeBase = (_dec = (0, _mobxReact.inject)('AppState'), (0, _reactIntl.injectIntl)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(KnowledgeBase, _Component);

  function KnowledgeBase(props) {
    (0, _classCallCheck3['default'])(this, KnowledgeBase);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (KnowledgeBase.__proto__ || Object.getPrototypeOf(KnowledgeBase)).call(this, props));

    _this.loadKnowledgeNew = function () {
      _KnowledgeBaseStore2['default'].setIsLoading(true);
      _KnowledgeBaseStore2['default'].loadKnowledge(_this.organizationId, 'new').then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ knowledgeNew: data });
          _KnowledgeBaseStore2['default'].setIsLoading(false);
        }
      });
    };

    _this.loadKnowledgeHot = function () {
      _KnowledgeBaseStore2['default'].setIsLoading(true);
      _KnowledgeBaseStore2['default'].loadKnowledge(_this.organizationId, 'hot').then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ knowledgeHot: data });
          _KnowledgeBaseStore2['default'].setIsLoading(false);
        }
      });
    };

    _this.handleClick = function (item) {
      _KnowledgeBaseStore2['default'].updateReadCount(_this.organizationId, item.knowledgeId);
      var href = window.location.href.split('#')[0];
      var link = href + '#/knowledge/search?type=organization&id=' + _this.organizationId + '&name=' + _this.organizationName + '&organizationId=' + _this.organizationId + '&knowledgeId=' + item.knowledgeId;
      window.open(link, '_blank');
    };

    _this.handleChange = function (key) {
      if (key === '1') {
        _this.loadKnowledgeNew();
      } else {
        _this.loadKnowledgeHot();
      }
    };

    _this.renderElement = function (item) {
      var time = item.creationDate.split(' ')[0];
      var category = '';
      if (item.path) {
        if (item.path.length >= 20 && item.path.split('/').length > 4) {
          category = item.path.split('/')[0] + '/' + item.path.split('/')[2] + '.../' + item.path.split('/')[-1];
        }
      }
      return _react2['default'].createElement(
        'div',
        { className: 'know-item', key: item.knowledgeId },
        _react2['default'].createElement(
          'div',
          { className: 'know-title', style: { cursor: 'pointer' }, onClick: _this.handleClick.bind(_this, item) },
          _react2['default'].createElement(
            'span',
            { className: 'wk-link' },
            item.title
          )
        ),
        _react2['default'].createElement(
          'div',
          { style: { paddingTop: 6, display: 'flex' } },
          _react2['default'].createElement(
            'div',
            { style: { display: 'flex', marginRight: 10 } },
            _react2['default'].createElement(
              'div',
              { className: 'know-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-ren' }),
              _react2['default'].createElement(
                'span',
                null,
                item.author
              )
            ),
            _react2['default'].createElement(
              'div',
              { className: 'know-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-shijian' }),
              _react2['default'].createElement(
                'span',
                null,
                time
              )
            )
          ),
          _react2['default'].createElement(
            'span',
            { className: 'know-category' },
            _react2['default'].createElement(
              _tooltip2['default'],
              { title: item.path },
              _react2['default'].createElement(
                'span',
                null,
                item.categoryName
              )
            )
          )
        )
      );
    };

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.organizationName = _this.props.AppState.currentMenuType.name;
    _this.state = {
      knowledgeNew: [],
      knowledgeHot: []
    };
    return _this;
  }

  (0, _createClass3['default'])(KnowledgeBase, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var AppState = this.props.AppState;

      _KnowledgeBaseStore2['default'].queryLanguage(this.organizationId, AppState.currentLanguage);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.loadKnowledgeNew();
    }

    /**
     * 加载最新知识
     * @param
     */


    /**
     * 加载最热知识
     * @param
     */


    /**
     * 切换tab
     * @param
     */

  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          knowledgeNew = _state.knowledgeNew,
          knowledgeHot = _state.knowledgeHot;


      return _react2['default'].createElement(
        'div',
        { className: 'wb-know wb-card' },
        _react2['default'].createElement(
          _tabs2['default'],
          { defaultActiveKey: '1', size: 'small', onChange: this.handleChange.bind(this) },
          _react2['default'].createElement(
            TabPane,
            { tab: _react2['default'].createElement(
                'span',
                null,
                _KnowledgeBaseStore2['default'].language.latestKnowledge
              ), key: '1' },
            _react2['default'].createElement(
              _spin2['default'],
              { spinning: _KnowledgeBaseStore2['default'].getIsLoading, style: { minHeight: 150 } },
              _react2['default'].createElement(
                'div',
                { className: 'know-list' },
                knowledgeNew ? knowledgeNew.map(this.renderElement) : ''
              )
            )
          ),
          _react2['default'].createElement(
            TabPane,
            { tab: _react2['default'].createElement(
                'span',
                null,
                _KnowledgeBaseStore2['default'].language.popularKnowledge
              ), key: '2' },
            _react2['default'].createElement(
              _spin2['default'],
              { spinning: _KnowledgeBaseStore2['default'].getIsLoading, style: { minHeight: 150 } },
              _react2['default'].createElement(
                'div',
                { className: 'know-list' },
                knowledgeHot && knowledgeHot.map(this.renderElement)
              )
            )
          )
        )
      );
    }
  }]);
  return KnowledgeBase;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = KnowledgeBase;