'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style9 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style10 = require('yqcloud-ui/lib/calendar/style');

var _calendar = require('yqcloud-ui/lib/calendar');

var _calendar2 = _interopRequireDefault(_calendar);

var _style11 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _style12 = require('yqcloud-ui/lib/checkbox/style');

var _checkbox = require('yqcloud-ui/lib/checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _style13 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style14 = require('yqcloud-ui/lib/badge/style');

var _badge = require('yqcloud-ui/lib/badge');

var _badge2 = _interopRequireDefault(_badge);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style15 = require('yqcloud-ui/lib/form/style');

var _form = require('yqcloud-ui/lib/form');

var _form2 = _interopRequireDefault(_form);

var _style16 = require('yqcloud-ui/lib/tabs/style');

var _tabs = require('yqcloud-ui/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _dec, _dec2, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _mobxReact = require('mobx-react');

var _rcQueueAnim = require('rc-queue-anim');

var _rcQueueAnim2 = _interopRequireDefault(_rcQueueAnim);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('moment/locale/zh-cn');

require('./MyCalendar.scss');

var _EditStroke = require('../editStroke/EditStroke');

var _EditStroke2 = _interopRequireDefault(_EditStroke);

var _CalendarStore = require('../../../stores/CalendarStore');

var _CalendarStore2 = _interopRequireDefault(_CalendarStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var intlPrefix = 'organization.setting.calendar';
var TabPane = _tabs2['default'].TabPane;

/**
 *  日历
 */

var MyCalender = (_dec = _form2['default'].create({}), _dec2 = (0, _mobxReact.inject)('AppState'), _dec(_class = (0, _reactIntl.injectIntl)(_class = _dec2(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(MyCalender, _Component);

  function MyCalender(props) {
    (0, _classCallCheck3['default'])(this, MyCalender);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (MyCalender.__proto__ || Object.getPrototypeOf(MyCalender)).call(this, props));

    _this.getTypeCode = function () {
      var AppState = _this.props.AppState;

      var code = 'PORTAL_SCHEDULE_TYPE';
      _CalendarStore2['default'].getTypeCode(AppState.userInfo.organizationId, code).then(function (data) {
        var lookupValueTODO = void 0;
        var lookupValueOFFDUTY = void 0;
        data.forEach(function (item, i) {
          if (item.lookupValue === 'TODO') {
            lookupValueTODO = item;
          }
          if (item.lookupValue === 'OFFDUTY') {
            lookupValueOFFDUTY = item;
          }

          if (i + 1 >= data.length) {
            _this.setState({
              TODO: lookupValueTODO,
              OFFDUTY: lookupValueOFFDUTY
            });
          }
        });
      })['catch'](function (error) {
        Choerodon.handleResponseError(error);
      });
    };

    _this.loadLanguage = function () {
      var AppState = _this.props.AppState;

      _moment2['default'].locale(AppState.currentLanguage);
      _CalendarStore2['default'].queryLanguage(_this.organizationId, AppState.currentLanguage);
    };

    _this.loadWorkCalendar = function () {
      _CalendarStore2['default'].loadWorkCalendar(_this.organizationId).then(function (data) {
        if (!data.failed) {
          if (data.calendarsDateList && data.calendarsDateList.length) {
            _this.setAllCalendarData(data.calendarsDateList); // 设置工作日数据
          }
          _this.setState({
            holidaySaturday: data.holidaySaturday,
            holidaySunday: data.holidaySunday,
            work: true
          });
        } else {
          _this.setState({
            holidaySaturday: data.holidaySaturday,
            holidaySunday: data.holidaySunday,
            work: false
          });
        }
      });
    };

    _this.setAllCalendarData = function (calendarsDateList) {
      var allCalendarData = _this.state.allCalendarData;

      calendarsDateList.forEach(function (v) {
        var currentDate = (0, _moment2['default'])(v.date);
        var month = currentDate.month();
        var day = currentDate.day();
        var arryStr = '';
        if (day === 0) {
          arryStr = 'sundayWorkDay';
        } else if (day === 6) {
          arryStr = 'saturdayWorkDay';
        } else {
          arryStr = 'noWorkDay';
        }
        if (arryStr) {
          allCalendarData[month][arryStr].push((0, _extends3['default'])({}, v, {
            dateNumber: currentDate
          }));
        }
      });
      _this.setState({
        allCalendarData: allCalendarData
      });
    };

    _this.loadStrokeList = function (dateIn) {
      var stateDate = _this.state.date;

      var date = dateIn || stateDate;
      // 未完成行程
      _CalendarStore2['default'].loadDoneStrokeList(_this.organizationId, date.format('YYYY-MM-DD')).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ strokeDone: data.strokeList });
        }
      });
      // 已完成行程
      _CalendarStore2['default'].loadUndoneStrokeList(_this.organizationId, date.format('YYYY-MM-DD')).then(function (data) {
        if (data.failed) {
          // Choerodon.prompt(data.message);
        } else {
          _this.setState({ strokeUndone: data.strokeList, undoneCount: data.count });
        }
      });
    };

    _this.renderDateCell = function (value) {
      // 得到当前组件的月份
      var _this$state = _this.state,
          holidaySaturday = _this$state.holidaySaturday,
          holidaySunday = _this$state.holidaySunday,
          allCalendarData = _this$state.allCalendarData,
          work = _this$state.work,
          stateDate = _this$state.date,
          strokeUndone = _this$state.strokeUndone,
          strokeDone = _this$state.strokeDone,
          colors = _this$state.colors;

      var currentMonth = (0, _moment2['default'])(stateDate).month() + 1;
      var dates = value.date();
      var month = value.month();
      var day = value.day();
      var today = (0, _moment2['default'])();
      var year = value.year();
      var style = {};
      var classType = 'error';
      var show = false;
      var doneColors = '';
      if (month + 1 === currentMonth) {
        if (_this.state.strokeDay.length > 0) {
          _this.state.strokeDay.forEach(function (data) {
            if (Object.is(data.outdate, dates.toString())) {
              show = true;
              if (data.flag === 1) {
                doneColors = 'error';
              } else if (data.flag === 0) {
                doneColors = 'success';
              }
            }
          });
        }
      }

      // 两种状态 工作日 1，非工作日 2
      var status = 1;
      allCalendarData.forEach(function (item) {
        if (item.month === currentMonth) {
          if (day === 0) {
            if (holidaySunday) {
              status = 1;
              if (item.sundayWorkDay.filter(function (v) {
                return v.dateNumber.date() === dates && v.dateNumber.year() === year && v.holiday;
              }).length > 0) {
                status = 2;
              }
              if (!work) {
                status = 1;
              }
            } else {
              status = 2;
              if (item.sundayWorkDay.filter(function (v) {
                return v.dateNumber.date() === dates && v.dateNumber.year() === year && !v.holiday;
              }).length > 0) {
                status = 1;
              }
              if (!work) {
                status = 1;
              }
            }
          } else if (day === 6) {
            if (holidaySaturday) {
              status = 1;
              if (item.saturdayWorkDay.filter(function (v) {
                return v.dateNumber.date() === dates && v.dateNumber.year() === year && v.holiday;
              }).length > 0) {
                status = 2;
              }
              if (!work) {
                status = 1;
              }
            } else {
              status = 2;
              if (item.saturdayWorkDay.filter(function (v) {
                return v.dateNumber.date() === dates && v.dateNumber.year() === year && !v.holiday;
              }).length > 0) {
                status = 1;
              }
              if (!work) {
                status = 1;
              }
            }
          } else {
            status = 1;
            // 日历中周一至周五存在的值
            if (item.noWorkDay.filter(function (v) {
              return v.dateNumber.date() === dates && v.dateNumber.year() === year && v.holiday;
            }).length > 0) {
              status = 2;
            }
            if (!work) {
              status = 1;
            }
          }
        }
      });

      if (today.isSame(value, 'day')) {
        style.boxShadow = '0 0 0 1px #2196F3 inset';
      }
      if (status === 1) {
        classType = 'cell-working-day';
      } else if (status === 2) {
        classType = 'cell-no-working-day';
      }
      return _react2['default'].createElement(
        _badge2['default'],
        { dot: show, status: doneColors, offset: [0, 15] },
        _react2['default'].createElement(
          'div',
          { style: style, className: 'ant-fullcalendar-value ' + classType },
          dates
        )
      );
    };

    _this.handleClick = function () {
      if (_moment2['default'].duration(_this.state.date - (0, _moment2['default'])(new Date()), 'd') >= 40) {
        Choerodon.prompt(_CalendarStore2['default'].language[intlPrefix + '.create.tip']);
        return;
      }
      _this.setState({ visible: true, edit: false });
    };

    _this.handleSelect = function (date, mode) {
      _this.loadStrokeList(date);
      _this.setState({ calendarDate: date });
      if (date.month() !== _this.state.date.month()) {
        _this.setState({ date: date, strokeDay: [] });
      }
      _this.getStrokeDate(date);
    };

    _this.handleChange = function (date, mode) {
      _this.loadStrokeList(date);
      _this.setState({ calendarDate: date, strokeDate: date });
      if (date.month() !== _this.state.date.month()) {
        _this.setState({ date: date, strokeDay: [] });
      }
      _this.getStrokeDate(date);
    };

    _this.handleEdit = function (item) {
      var invalid = '';
      if (item.isEnabled === 'Y') {
        invalid = false;
      } else {
        invalid = true;
      }
      _this.setState({ visible: true, edit: true, invalid: invalid, selectData: item.strokeId });
    };

    _this.renderSidebarTitle = function () {
      var edit = _this.state.edit;

      if (edit) {
        return _CalendarStore2['default'].language[intlPrefix + '.modify'];
      } else {
        return _CalendarStore2['default'].language[intlPrefix + '.create'];
      }
    };

    _this.renderSidebarFooter = function () {
      var _this$state2 = _this.state,
          edit = _this$state2.edit,
          invalid = _this$state2.invalid,
          submitting = _this$state2.submitting;

      var footer = [];
      if (invalid && edit) {
        footer = [_react2['default'].createElement(
          _button2['default'],
          { key: 'back', onClick: function onClick(e) {
              return _this.editStroke.handleCancel(e);
            } },
          _CalendarStore2['default'].language.cancel
        ), _react2['default'].createElement(
          _button2['default'],
          { key: 'submit', type: 'primary', loading: submitting, onClick: function onClick(e) {
              return _this.editStroke.handleEffective(e);
            } },
          _CalendarStore2['default'].language.effective
        )];
      } else {
        footer = [_react2['default'].createElement(
          _button2['default'],
          { key: 'back', onClick: function onClick(e) {
              return _this.editStroke.handleCancel(e);
            } },
          _CalendarStore2['default'].language.cancel
        ), _react2['default'].createElement(
          _button2['default'],
          { key: 'submit', type: 'primary', loading: submitting, onClick: function onClick(e) {
              return _this.editStroke.handleSubmit(e);
            } },
          _CalendarStore2['default'].language.save
        )];
      }
      return footer;
    };

    _this.renderSidebarContent = function () {
      var _this$state3 = _this.state,
          visible = _this$state3.visible,
          selectData = _this$state3.selectData,
          edit = _this$state3.edit,
          invalid = _this$state3.invalid;

      return _react2['default'].createElement(_EditStroke2['default'], {
        visible: visible,
        id: selectData,
        invalid: invalid,
        edit: edit,
        onRef: function onRef(node) {
          _this.editStroke = node;
        },
        OnUnchangedSuccess: function OnUnchangedSuccess() {
          _this.setState({
            visible: false,
            submitting: false
          });
        },
        onSubmit: function onSubmit() {
          _this.setState({
            submitting: true
          });
        },
        onSuccess: function onSuccess(date) {
          _this.setState({
            visible: false,
            submitting: false,
            calendarDate: date,
            invalid: false
          });
          _this.loadStrokeList(date);
          _this.getStrokeDate(date);
        },
        onError: function onError() {
          _this.setState({
            submitting: false
          });
        }
      });
    };

    _this.onChange = function (item) {
      var intl = _this.props.intl;
      var iamOrganizationId = _this.props.AppState.currentMenuType.id;
      var userId = _this.props.AppState.userInfo.id.id;

      if (item.isEnabled === 'Y') {
        var strokeInfo = (0, _extends3['default'])({}, item, {
          iamOrganizationId: iamOrganizationId,
          userId: userId,
          isEnabled: 'N'
        });
        _CalendarStore2['default'].updateStroke(_this.organizationId, strokeInfo).then(function (_ref) {
          var failed = _ref.failed,
              message = _ref.message;

          if (!failed) {
            _CalendarStore2['default'].getCode('complete.todo');
            _this.setState({ strokeDone: [], strokeUndone: [] });
            _this.loadStrokeList(_this.state.calendarDate);
            _this.getStrokeDate(_this.state.calendarDate);
          }
        })['catch'](function (error) {
          Choerodon.handleResponseError(error);
        });
      } else {
        var _strokeInfo = (0, _extends3['default'])({}, item, {
          iamOrganizationId: iamOrganizationId,
          userId: userId,
          isEnabled: 'Y'
        });
        _CalendarStore2['default'].updateStroke(_this.organizationId, _strokeInfo).then(function (_ref2) {
          var failed = _ref2.failed,
              message = _ref2.message;

          if (!failed) {
            Choerodon.prompt(_CalendarStore2['default'].language['effective.success']);
            _this.setState({ strokeDone: [], strokeUndone: [] });
            _this.loadStrokeList(_this.state.calendarDate);
            _this.getStrokeDate(_this.state.calendarDate);
          }
        })['catch'](function (error) {
          Choerodon.handleResponseError(error);
        });
      }
    };

    _this.handleTabChange = function (dateIn, key) {
      var stateDate = _this.state.date;

      var date = dateIn || stateDate;
      if (key === '1') {
        // 未完成行程
        _CalendarStore2['default'].loadUndoneStrokeList(_this.organizationId, date.format('YYYY-MM-DD')).then(function (data) {
          if (data.failed) {
            // Choerodon.prompt(data.message);
          } else {
            _this.setState({ strokeUndone: data.strokeList, undoneCount: data.count });
          }
        });
      } else {
        // 已完成行程
        _CalendarStore2['default'].loadDoneStrokeList(_this.organizationId, date.format('YYYY-MM-DD')).then(function (data) {
          if (data.failed) {
            // Choerodon.prompt(data.message);
          } else {
            _this.setState({ strokeDone: data.strokeList });
          }
        });
      }
    };

    _this.handleCreate = function (dateIn) {
      var _this$props = _this.props,
          intl = _this$props.intl,
          AppState = _this$props.AppState;
      var calendarDate = _this.state.calendarDate;

      var userId = AppState.userInfo.id;
      var startTime = calendarDate.format('YYYY-MM-DD HH:mm:ss');
      var endTime = calendarDate.add(1, 'h').format('YYYY-MM-DD HH:mm:ss');
      if (dateIn) {
        startTime = (0, _moment2['default'])(dateIn).format('YYYY-MM-DD HH:mm:ss');
        endTime = (0, _moment2['default'])(dateIn).add(1, 'h').format('YYYY-MM-DD HH:mm:ss');
      }
      var strokeInfo = {
        startTime: startTime,
        endTime: endTime,
        isEnabled: 'Y',
        label: '',
        remindType: 'none',
        content: '',
        location: '',
        iamOrganizationId: _this.organizationId,
        userId: userId
      };

      // CalendarStore.createStroke(this.organizationId, strokeInfo).then(({ failed, message }) => {
      //   if (failed) {
      //     //
      //   } else {
      //     this.setState({ input: '' });
      //     this.getStrokeDate(moment(startTime));
      //     this.loadStrokeList(calendarDate);
      //     Choerodon.prompt(CalendarStore.language['create.success']);
      //   }
      // }).catch((error) => {
      //   Choerodon.handleResponseError(error);
      // });
    };

    _this.handleDelete = function (item) {
      var _this$props2 = _this.props,
          intl = _this$props2.intl,
          AppState = _this$props2.AppState;

      _CalendarStore2['default'].deleteStroke(_this.organizationId, item.strokeId, item.objectVersionNumber).then(function (data) {
        if (data.failed) {
          //
        } else {
          Choerodon.prompt(_CalendarStore2['default'].language['delete.success']);
          _this.loadStrokeList((0, _moment2['default'])(item.startTime));
          _this.getStrokeDate((0, _moment2['default'])(item.startTime));
        }
      });
    };

    _this.getStrokeDate = function (dateIn) {
      if (typeof dateIn === 'string') {
        _CalendarStore2['default'].getStrokeDate(_this.organizationId, (0, _moment2['default'])(dateIn).format('YYYY-MM')).then(function (data) {
          if (data.failed) {
            // Choerodon.prompt(data.message);
          } else {
            _this.setState({ strokeDay: data });
          }
        });
      } else {
        _CalendarStore2['default'].getStrokeDate(_this.organizationId, dateIn.format('YYYY-MM')).then(function (data) {
          if (data.failed) {
            // Choerodon.prompt(data.message);
          } else {
            _this.setState({ strokeDay: data });
          }
        });
      }
    };

    _this.onPressEnter = function () {
      _this.setState({ visible: true, edit: false, invalid: false });
      // const { strokeDate, calendarDate, input } = this.state;
      // // if (input) {
      // //     //   this.handleCreate(input, calendarDate);
      // //     // }
      // this.handleCreate(calendarDate);
    };

    _this.handDateChange = function (date) {
      _this.setState({ strokeDate: date, datePicker: false });
    };

    _this.showDatePicker = function () {
      var datePicker = _this.state.datePicker;

      _this.setState({ datePicker: !datePicker });
    };

    _this.renderStroke = function (item) {
      var time1 = (0, _moment2['default'])(item.startTime);
      var startTime = time1.format('YYYY-MM-DD HH:mm');
      var time2 = (0, _moment2['default'])(item.endTime);
      var endTime = time2.format('YYYY-MM-DD HH:mm');
      if (item.isEnabled === 'Y') {
        return _react2['default'].createElement(
          _rcQueueAnim2['default'],
          { type: ['right', 'right'] },
          _react2['default'].createElement(
            'div',
            { className: 'stroke-item', key: item.strokeId },
            _react2['default'].createElement(
              'div',
              { className: 'stroke-title', style: { color: '#04173F' } },
              _react2['default'].createElement(
                'div',
                null,
                _react2['default'].createElement(_checkbox2['default'], { onChange: _this.onChange.bind(_this, item) }),
                item.typeCode === 'TODO' ? _react2['default'].createElement(
                  'div',
                  { style: { margin: '8px', textAlign: 'center', padding: '0 5px', fontSize: '12px', color: '#FF9500', display: 'inline-block', height: '22px', border: '1px solid #FFE4C3', borderRadius: '4px' } },
                  _this.state.TODO ? _this.state.TODO.lookupMeaning : ''
                ) : _react2['default'].createElement(
                  'div',
                  { style: { margin: '8px', textAlign: 'center', padding: '0 5px', fontSize: '12px', color: '#2196F3', display: 'inline-block', height: '22px', border: '1px solid #BFE2FF', borderRadius: '4px' } },
                  _this.state.OFFDUTY ? _this.state.OFFDUTY.lookupMeaning : ''
                ),
                _react2['default'].createElement(
                  'span',
                  { className: 'stroke-title-edit', onClick: _this.handleEdit.bind(_this, item) },
                  item.label
                )
              ),
              _react2['default'].createElement(
                'a',
                null,
                _react2['default'].createElement(_icon2['default'], { type: 'shanchu2', onClick: _this.handleDelete.bind(_this, item) })
              )
            ),
            _react2['default'].createElement(
              'div',
              { className: 'stroke-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-riqi' }),
              _react2['default'].createElement(
                'span',
                null,
                startTime,
                '~',
                endTime
              )
            )
          )
        );
      } else {
        return _react2['default'].createElement(
          _rcQueueAnim2['default'],
          { type: ['left', 'left'] },
          _react2['default'].createElement(
            'div',
            { className: 'stroke-item', key: item.strokeId },
            _react2['default'].createElement(
              'div',
              { className: 'stroke-title', style: { color: '#ACB3BF' } },
              _react2['default'].createElement(
                'div',
                null,
                _react2['default'].createElement(_checkbox2['default'], { checked: true, onChange: _this.onChange.bind(_this, item) }),
                item.typeCode === 'TODO' ? _react2['default'].createElement(
                  'div',
                  { style: { opacity: '0.5', margin: '8px', textAlign: 'center', padding: '0 5px', fontSize: '12px', color: '#FF9500', display: 'inline-block', height: '22px', border: '1px solid #FFE4C3', borderRadius: '4px' } },
                  _this.state.TODO ? _this.state.TODO.lookupMeaning : ''
                ) : _react2['default'].createElement(
                  'div',
                  { style: { opacity: '0.5', margin: '8px', textAlign: 'center', padding: '0 5px', fontSize: '12px', color: '#2196F3', display: 'inline-block', height: '22px', border: '1px solid #BFE2FF', borderRadius: '4px' } },
                  _this.state.OFFDUTY ? _this.state.OFFDUTY.lookupMeaning : ''
                ),
                _react2['default'].createElement(
                  'span',
                  { className: 'stroke-title-edit', onClick: _this.handleEdit.bind(_this, item) },
                  item.label
                )
              ),
              _react2['default'].createElement(
                'a',
                null,
                _react2['default'].createElement(_icon2['default'], { type: 'shanchu2', onClick: _this.handleDelete.bind(_this, item) })
              )
            ),
            _react2['default'].createElement(
              'div',
              { className: 'stroke-element' },
              _react2['default'].createElement(_icon2['default'], { type: 'gongzuotai-riqi' }),
              _react2['default'].createElement(
                'span',
                null,
                startTime,
                '~',
                endTime
              )
            )
          )
        );
      }
    };

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.state = _this.getInitState();
    return _this;
  }

  (0, _createClass3['default'])(MyCalender, [{
    key: 'getInitState',
    value: function getInitState() {
      var allCalendarData = [];
      for (var i = 1; i <= 12; i += 1) {
        allCalendarData.push({
          month: i, // 当前月份
          noWorkDay: [], // 已点击的工作日
          saturdayWorkDay: [], // 已点击的周六
          sundayWorkDay: [] // 已点击的周日
        });
      }
      return {
        visible: false,
        submitting: false,
        edit: false,
        allCalendarData: allCalendarData,
        done: false,
        strokeDay: [],
        date: (0, _moment2['default'])(new Date()),
        calendarDate: (0, _moment2['default'])(new Date()),
        work: false,
        invalid: false,
        datePicker: false,
        input: '',
        colors: '',
        strokeDate: (0, _moment2['default'])(new Date())
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.loadLanguage();
      this.getTypeCode();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.loadStrokeList();
      this.loadWorkCalendar();
      this.getStrokeDate((0, _moment2['default'])(new Date()));
    }

    // 类型快码


    // 获取语言


    /**
     * 加载工作日历
     * @param
     */


    /**
     * 设置工作日数据
     * @param calendarsDateList
     */


    // 渲染日历表


    /* 弹出框标题 */


    /* 弹出框标题 */


    /* 弹出框内容 */


    /**
     * tabs切换
     * @param
     */


    /**
     * 创建知识
     * @param
     */


    /**
     * 删除行程
     * @param
     */


    // 输入框回车

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          visible = _state.visible,
          submitting = _state.submitting,
          strokeDate = _state.strokeDate,
          calendarDate = _state.calendarDate,
          undoneCount = _state.undoneCount;

      var suffix = strokeDate.isSame(calendarDate) ? _react2['default'].createElement(_icon2['default'], { type: 'shijianriqi', style: { padding: '0 5px 0 10px', borderLeft: '1px solid #DCDFE6' }, onClick: this.showDatePicker }) : _react2['default'].createElement(
        'span',
        { style: { padding: '0 5px 0 10px', borderLeft: '1px solid #DCDFE6' }, onClick: this.showDatePicker },
        strokeDate.date()
      );
      var inputStyle = {
        padding: '4px 10px 2px 10px',
        border: '1px solid #DCDFE6',
        borderRadius: '4px',
        width: '100%'
      };

      return _react2['default'].createElement(
        'div',
        { className: 'flex-box scroll-box-fix' },
        _react2['default'].createElement(
          'div',
          { id: 'strokePicker', className: 'workBenchCard calendar' },
          _react2['default'].createElement(_calendar2['default'], {
            fullscreen: false,
            value: calendarDate,
            dateFullCellRender: this.renderDateCell.bind(this),
            onSelect: this.handleSelect.bind(this),
            onPanelChange: this.handleChange.bind(this)
          })
        ),
        _react2['default'].createElement(
          'div',
          { className: 'main_top_mycalendar' },
          _react2['default'].createElement(
            _tabs2['default'],
            { defaultActiveKey: '1', onChange: this.handleTabChange.bind(this, calendarDate) },
            _react2['default'].createElement(
              TabPane,
              { tab: _react2['default'].createElement(
                  'span',
                  null,
                  _CalendarStore2['default'].language[intlPrefix + '.todo'],
                  _react2['default'].createElement(
                    'span',
                    { style: { marginLeft: 3 } },
                    undoneCount > 0 ? '(' + undoneCount + ')' : ''
                  )
                ), key: '1' },
              _react2['default'].createElement(
                'div',
                { style: { marginTop: '16px' } },
                _react2['default'].createElement(
                  'div',
                  {
                    className: 'formXinjian',
                    onClick: this.onPressEnter
                  },
                  _react2['default'].createElement(_icon2['default'], { style: { height: '24px', lineHeight: '24px', fontSize: '12px', color: '#A3ACBF' }, type: 'tianjia2' })
                )
              ),
              _react2['default'].createElement(
                'div',
                { className: 'stroke-list undone' },
                this.state.strokeUndone ? this.state.strokeUndone.map(this.renderStroke) : ''
              )
            ),
            _react2['default'].createElement(
              TabPane,
              { tab: _CalendarStore2['default'].language[intlPrefix + '.done'], key: '2' },
              _react2['default'].createElement(
                'div',
                { className: 'stroke-list done' },
                this.state.strokeDone ? this.state.strokeDone.map(this.renderStroke) : ''
              )
            )
          )
        ),
        _react2['default'].createElement(
          _modal2['default'],
          {
            className: 'edit-stroke',
            width: 596,
            title: this.renderSidebarTitle(),
            visible: visible,
            onOk: function onOk(e) {
              return _this2.editStroke.handleSubmit(e);
            },
            onCancel: function onCancel(e) {
              return _this2.editStroke.handleCancel(e);
            },
            confirmLoading: submitting,
            footer: this.renderSidebarFooter()
          },
          this.renderSidebarContent()
        )
      );
    }
  }]);
  return MyCalender;
}(_react.Component)) || _class) || _class) || _class) || _class);
exports['default'] = MyCalender;