'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style6 = require('yqcloud-ui/lib/modal/style');

var _modal = require('yqcloud-ui/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style7 = require('yqcloud-ui/lib/table/style');

var _table = require('yqcloud-ui/lib/table');

var _table2 = _interopRequireDefault(_table);

var _style8 = require('yqcloud-ui/lib/button/style');

var _button = require('yqcloud-ui/lib/button');

var _button2 = _interopRequireDefault(_button);

var _style9 = require('yqcloud-ui/lib/icon/style');

var _icon = require('yqcloud-ui/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style10 = require('yqcloud-ui/lib/tabs/style');

var _tabs = require('yqcloud-ui/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactIntl = require('react-intl');

var _Ellipsis = require('../../../../components/Ellipsis');

var _Ellipsis2 = _interopRequireDefault(_Ellipsis);

var _MyTasksStore = require('../../../stores/MyTasksStore');

var _MyTasksStore2 = _interopRequireDefault(_MyTasksStore);

var _HeaderStore = require('../../../stores/HeaderStore');

var _HeaderStore2 = _interopRequireDefault(_HeaderStore);

require('./MyTasks.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *  我的事项
 */
var TabPane = _tabs2['default'].TabPane;

var intlPrefix = 'organization.setting.todoList';
var MyTasks = (_dec = (0, _mobxReact.inject)('AppState'), (0, _reactIntl.injectIntl)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(MyTasks, _Component);
  (0, _createClass3['default'])(MyTasks, [{
    key: 'getInitState',
    value: function getInitState() {
      return {
        count: 0,
        itsmCount: 0,
        data: '',
        pagination: {
          current: 0,
          pageSize: 20,
          total: 0,
          pageSizeOptions: [25, 50, 100, 200],
          totalPages: null
        },
        toDoListData: [],
        currentTabKey: '1'
      };
    }
  }]);

  function MyTasks(props) {
    (0, _classCallCheck3['default'])(this, MyTasks);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (MyTasks.__proto__ || Object.getPrototypeOf(MyTasks)).call(this, props));

    _this.updateSize = function () {
      var height = document.getElementsByClassName('ant-row')[0].clientHeight / 2 - 100;
      _this.setState({ height: height });
    };

    _this.getTodoCount = function (organizationId) {
      _MyTasksStore2['default'].getTodoCount(organizationId).then(function (data) {
        if (data.failed) {
          //
        } else {
          _this.setState({ count: data });
        }
      });
    };

    _this.getUserBacklog = function () {
      _MyTasksStore2['default'].setIsLoading(true);
      _MyTasksStore2['default'].loadUserBacklog(_this.organizationId).then(function (data) {
        _MyTasksStore2['default'].setIsLoading(false);
        if (!data.failed) {
          _MyTasksStore2['default'].setUserBacklog(_MyTasksStore2['default'].loopList(data));
        } else {
          _MyTasksStore2['default'].setUserBacklog([]);
        }
      });
    };

    _this.getItsmBacklog = function (pagination, flag) {
      _MyTasksStore2['default'].setIsLoading(true);
      _MyTasksStore2['default'].loadItsmBacklog(_this.organizationId, pagination.current, pagination.pageSize).then(function (data) {
        _MyTasksStore2['default'].setIsLoading(false);
        if (!data.failed) {
          var newToDoListData = _MyTasksStore2['default'].loopList(data.result ? data.result : [], 'itsm');
          _MyTasksStore2['default'].setItsmBacklog(newToDoListData);
          _this.setState({
            itsmCount: data.totalElements,
            pagination: {
              current: data.number + 1,
              pageSize: data.size,
              total: data.totalElements,
              pageSizeOptions: [25, 50, 100, 200]
            },
            toDoListData: flag === 'reload' ? newToDoListData : [].concat((0, _toConsumableArray3['default'])(_this.state.toDoListData), (0, _toConsumableArray3['default'])(newToDoListData))
          });
        } else {
          _MyTasksStore2['default'].setItsmBacklog([]);
        }
      });
    };

    _this.handleBigRefush = function () {
      _this.setState(_this.getInitState(), function () {
        _this.getItsmBacklog(_this.state.pagination);
        _this.getTodoCount(_this.organizationId);
        document.location.reload();
      });
    };

    _this.handleOk = function () {
      var _this$props = _this.props,
          AppState = _this$props.AppState,
          intl = _this$props.intl;
      var organizationId = AppState.currentMenuType.organizationId;
      var _this$state = _this.state,
          mail = _this$state.mail,
          iamOrganizationIdBeInvitee = _this$state.iamOrganizationIdBeInvitee;
      var userId = AppState.userInfo.id;

      _this.setState({ submitting: true });
      _MyTasksStore2['default'].inviteOk(organizationId, mail, iamOrganizationIdBeInvitee).then(function (_ref) {
        var failed = _ref.failed,
            message = _ref.message;

        if (failed) {
          _this.setState({ submitting: false });
          setTimeout(function () {
            return _this.handleBigRefush();
          }, 1000);
        } else {
          _MyTasksStore2['default'].getCode('invite.ok');
          _this.setState({ submitting: false, preview: false, employ: '', organization: '', mail: '' });
          _HeaderStore2['default'].axiosGetOrgAndPro(userId);
          setTimeout(function () {
            return _this.handleBigRefush();
          }, 1000);
        }
      });
    };

    _this.handleCancel = function () {
      var _this$props2 = _this.props,
          AppState = _this$props2.AppState,
          intl = _this$props2.intl;
      var organizationId = AppState.currentMenuType.organizationId;
      var _this$state2 = _this.state,
          mail = _this$state2.mail,
          iamOrganizationIdBeInvitee = _this$state2.iamOrganizationIdBeInvitee;
      var userId = AppState.userInfo.id;

      _this.setState({ submitting: true });
      _MyTasksStore2['default'].inviteReject(organizationId, mail, iamOrganizationIdBeInvitee).then(function (_ref2) {
        var failed = _ref2.failed,
            message = _ref2.message;

        if (failed) {
          _this.setState({ submitting: false });
          setTimeout(function () {
            return _this.handleBigRefush();
          }, 1000);
        } else {
          _MyTasksStore2['default'].getCode('invite.reject');
          _this.setState({ submitting: false, employ: '', organization: '', mail: '', preview: false });
          _HeaderStore2['default'].axiosGetOrgAndPro(userId);
          setTimeout(function () {
            return _this.handleBigRefush();
          }, 1000);
        }
      });
    };

    _this.handleClick = function (record) {
      var _window$location = window.location,
          host = _window$location.host,
          pathname = _window$location.pathname,
          origin = _window$location.origin;

      if (record.source === 'SYSTEM') {
        _this.setState({
          employ: record.invitationEmployee,
          organization: record.invitationOrganizationName,
          mail: record.invitationMail,
          creationDate: record.creationDate,
          preview: true,
          iamOrganizationIdBeInvitee: record.invitationOrganization

        });
      } else if (record.source === 'ITSM') {
        localStorage.setItem('isMyTast', 'Y');
        // window.open(record.link, '_blank');
        window.open('' + origin + pathname + record.link, '_blank');
      } else {
        // window.open(record.link, '_blank');
        window.open('' + origin + pathname + record.link, '_blank');
      }
    };

    _this.handleChange = function (key) {
      if (key === '1') {
        _this.setState({
          pagination: {
            current: 1,
            pageSize: 500,
            total: 0,
            pageSizeOptions: [25, 50, 100, 200]
          },
          currentTabKey: key
        }, function () {
          _this.getItsmBacklog(_this.state.pagination);
        });
      } else {
        _this.setState({
          currentTabKey: key
        });
        _this.getUserBacklog();
        _this.getTodoCount(_this.organizationId);
      }
    };

    _this.renderPreviewContent = function () {
      var _this$state3 = _this.state,
          employ = _this$state3.employ,
          organization = _this$state3.organization,
          mail = _this$state3.mail,
          creationDate = _this$state3.creationDate;

      return _react2['default'].createElement(
        'div',
        { style: { padding: '14px 40px 20px 40px' } },
        _react2['default'].createElement(
          'p',
          null,
          organization,
          _MyTasksStore2['default'].language['invite.content1']
        ),
        _react2['default'].createElement(
          'p',
          null,
          _MyTasksStore2['default'].language['invite.content2'],
          mail,
          _MyTasksStore2['default'].language['invite.content3']
        ),
        _react2['default'].createElement(
          'div',
          { style: { marginTop: 14 } },
          _react2['default'].createElement(_icon2['default'], { type: 'shijian1', style: { fontSize: 14 } }),
          _react2['default'].createElement(
            'span',
            null,
            creationDate
          ),
          _MyTasksStore2['default'].language['invite.time.msg']
        )
      );
    };

    _this.renderTitle = function () {
      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].createElement(_icon2['default'], { type: 'zhuangtaitixing', style: { color: '#70C040' } }),
        _MyTasksStore2['default'].language['invite.title']
      );
    };

    _this.handlePageChange = function (pagination, filters, _ref3, params) {
      var field = _ref3.field,
          order = _ref3.order;

      _this.getItsmBacklog(pagination);
    };

    _this.handleScrollPageChange = function (pagination, filters, _ref4, params) {
      var field = _ref4.field,
          order = _ref4.order;

      _this.getItsmBacklog(pagination);
    };

    _this.renderTaskRightButton = function () {
      return _react2['default'].createElement(
        _button2['default'],
        {
          className: 'workbranch-task-tab-button',
          type: 'primary',
          onClick: function onClick() {
            return _this.reloadMyTaskData();
          }
        },
        _react2['default'].createElement(_icon2['default'], { type: 'refresh', style: { fontSize: 14 } }),
        _MyTasksStore2['default'].language['boot.refresh']
      );
    };

    _this.reloadMyTaskData = function () {
      var currentTabKey = _this.state.currentTabKey;

      if (currentTabKey === '1') {
        _this.setState({
          pagination: {
            current: 0,
            pageSize: 20,
            total: 0,
            pageSizeOptions: [25, 50, 100, 200]
          }
        }, function () {
          _this.getItsmBacklog(_this.state.pagination, 'reload');
        });
      } else {
        _this.getUserBacklog();
        _this.getTodoCount(_this.organizationId);
      }
    };

    _this.getUserBacklog = _this.getUserBacklog.bind(_this);
    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.language = _this.props.AppState.currentLanguage;
    _this.state = _this.getInitState();
    _this.onScrollEvent = _this.onScrollEvent.bind(_this);
    return _this;
  }

  (0, _createClass3['default'])(MyTasks, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      _MyTasksStore2['default'].queryLanguage(this.organizationId, this.language);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.updateSize();
      window.addEventListener('resize', this.updateSizeFunc = function () {
        return _this2.updateSize();
      });
      this.getTodoCount(this.organizationId);
      this.getItsmBacklog(this.state.pagination);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.updateSizeFunc);
    }

    /* 加载用户待办事项数据 */


    // 强制刷新


    /**
     * 接受邀请
     * @param
     */


    /**
     * 拒绝邀请
     * @param
     */


    /**
     * 切换tab
     * @param
     */

  }, {
    key: 'onScrollEvent',
    value: function onScrollEvent() {
      var _this3 = this;

      var pagination = this.state.pagination;

      if (this.scrollRef.scrollTop + this.scrollRef.clientHeight === this.scrollRef.scrollHeight) {
        _MyTasksStore2['default'].setIsLoading(true);
        if (!pagination.totalPages || pagination.current + 1 < pagination.totalPages) {
          _MyTasksStore2['default'].loadItsmBacklog(this.organizationId, pagination.current, pagination.pageSize).then(function (data) {
            _MyTasksStore2['default'].setIsLoading(false);
            if (!data.failed) {
              var newToDoListData = _MyTasksStore2['default'].loopList(data.result ? data.result : [], 'itsm');
              _MyTasksStore2['default'].setItsmBacklog(newToDoListData);
              _this3.setState({
                itsmCount: data.totalElements,
                pagination: {
                  current: data.number + 1,
                  pageSize: 20,
                  total: data.totalElements,
                  pageSizeOptions: [25, 50, 100, 200],
                  totalPages: data.totalPages
                },
                toDoListData: [].concat((0, _toConsumableArray3['default'])(_this3.state.toDoListData), (0, _toConsumableArray3['default'])(newToDoListData))
              });
            } else {
              _MyTasksStore2['default'].setItsmBacklog([]);
            }
          });
        }
      }
    }

    /* 渲染代办工作右边的刷新按钮 */


    /* 重新加载数据 */

  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _state = this.state,
          count = _state.count,
          itsmCount = _state.itsmCount,
          pagination = _state.pagination,
          toDoListData = _state.toDoListData;


      var approvalColumns = [{
        title: _MyTasksStore2['default'].language[intlPrefix + '.key'],
        dataIndex: 'eventNum',
        key: 'eventNum',
        width: 130,
        render: function render(text, record) {
          return _react2['default'].createElement(
            'div',
            {
              className: 'task-number',
              onClick: _this4.handleClick.bind(_this4, record)
            },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              {
                length: 14,
                tooltip: true
              },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.theme'],
        dataIndex: 'title',
        key: 'title',
        width: 180,
        render: function render(text, record) {
          return _react2['default'].createElement(
            'div',
            {
              className: 'task-title',
              onClick: _this4.handleClick.bind(_this4, record)
            },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              {
                length: 15,
                tooltip: true,
                style: { cursor: 'pointer' }
              },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.status'],
        dataIndex: 'ticketStatusMeaning',
        key: 'ticketStatusMeaning',
        width: 140,
        align: 'left',
        render: function render(text, record) {
          var backgroundColor = '';
          if (record.source === 'ITSM' || record.source === 'SYSTEM') {
            if (record.statusColor) {
              backgroundColor = record.statusColor;
            } else {
              backgroundColor = 'rgba(33,150,243,1)';
            }
          } else {
            backgroundColor = 'rgba(33,150,243,1)';
          }
          return _react2['default'].createElement(
            'span',
            { className: 'task-status', style: { backgroundColor: backgroundColor } },
            text
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.priority'],
        dataIndex: 'priorityMeaning',
        key: 'priorityMeaning',
        width: 130,
        align: 'left',
        render: function render(text, record) {
          var backgroundColor = '';
          var priorityBorderColor = '';
          if (record.source === 'ITSM') {
            if (record.priorityColor) {
              var reg = /[^()]+(?=\))/g;
              var colorArr = record.priorityColor.match(reg)[0].split(',');
              priorityBorderColor = 'rgba(' + colorArr[0] + ',' + colorArr[1] + ',' + colorArr[2] + ',' + (colorArr[3] > 0.6 ? colorArr[3] - 0.6 : 0.05) + ')';
              backgroundColor = record.priorityColor;
            } else if (text) {
              backgroundColor = 'rgba(33,150,243, 1)';
              priorityBorderColor = 'rgba(33,150,243, 0.4)';
            } else {
              backgroundColor = 'rgba(255, 255, 255, 0)';
              priorityBorderColor = 'rgba(255, 255, 255, 0)';
            }
          } else if (text) {
            backgroundColor = 'rgba(33,150,243, 1)';
            priorityBorderColor = 'rgba(33,150,243, 0.4)';
          } else {
            backgroundColor = 'rgba(255, 255, 255, 0)';
            priorityBorderColor = 'rgba(255, 255, 255, 0)';
          }
          return _react2['default'].createElement(
            'div',
            { style: { maxWidth: 80 } },
            text ? _react2['default'].createElement('span', {
              className: 'event-information-priorityMeaning',
              style: { backgroundColor: backgroundColor, borderColor: priorityBorderColor }
            }) : '',
            _react2['default'].createElement(
              'span',
              { style: { color: '#04173F' } },
              _react2['default'].createElement(
                _Ellipsis2['default'],
                { style: { display: 'inline' }, length: 5, tooltip: true },
                text
              )
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.applicant'],
        dataIndex: 'createEmployeeName',
        key: 'createEmployeeName',
        width: 120,
        align: 'left',
        render: function render(text) {
          return _react2['default'].createElement(
            'div',
            { style: { maxWidth: 50, marginLeft: 10 } },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              { length: 10, tooltip: true },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.creationDate'],
        dataIndex: 'creationDate',
        key: 'creationDate',
        width: 155,
        align: 'left',
        // render: text => <div style={{ maxWidth: 50 }}><Ellipsis length={14} tooltip>{text}</Ellipsis></div>,
        render: function render(text) {
          return _react2['default'].createElement(
            'span',
            { style: { marginLeft: 15 } },
            text
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.lastUpdateDate'],
        dataIndex: 'lastUpdateDate',
        key: 'lastUpdateDate',
        align: 'left',
        width: 155,
        render: function render(text) {
          return _react2['default'].createElement(
            'span',
            { style: { marginLeft: 10 } },
            text
          );
        }
      }];

      var taskColumns = [{
        title: _MyTasksStore2['default'].language[intlPrefix + '.sourceFrom'],
        dataIndex: 'sourceFrom',
        key: 'sourceFrom',
        width: 120,
        align: 'left',
        render: function render(text) {
          return _react2['default'].createElement(
            'div',
            { style: { maxWidth: 70 } },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              {
                length: 14,
                tooltip: true
              },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.key'],
        dataIndex: 'uniqueNumber',
        key: 'uniqueNumber',
        align: 'left',
        width: 120,
        render: function render(text, record) {
          return _react2['default'].createElement(
            'div',
            {
              className: 'task-number',
              onClick: _this4.handleClick.bind(_this4, record)
            },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              {
                length: 14,
                tooltip: true
              },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.theme'],
        dataIndex: 'theme',
        key: 'theme',
        align: 'left',
        width: 180,
        render: function render(text, record) {
          return _react2['default'].createElement(
            'div',
            {
              className: 'task-title',
              onClick: _this4.handleClick.bind(_this4, record)
            },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              {
                length: 15,
                tooltip: true,
                style: { cursor: 'pointer' }
              },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.status'],
        dataIndex: 'status',
        key: 'status',
        align: 'left',
        width: 130,
        render: function render(text, record) {
          var backgroundColor = '';
          if (record.source === 'ITSM' || record.source === 'SYSTEM') {
            if (record.statusColor) {
              backgroundColor = record.statusColor;
            } else {
              backgroundColor = 'rgba(33,150,243,1)';
            }
          } else {
            backgroundColor = 'rgba(33,150,243,1)';
          }
          return _react2['default'].createElement(
            'span',
            { className: 'task-status', style: { backgroundColor: backgroundColor } },
            text
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.submitter'],
        dataIndex: 'loginName',
        key: 'loginName',
        width: 120,
        render: function render(text) {
          return _react2['default'].createElement(
            'div',
            { style: { maxWidth: 50 } },
            _react2['default'].createElement(
              _Ellipsis2['default'],
              { length: 10, tooltip: true },
              text
            )
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.creationDate'],
        dataIndex: 'creationTime',
        key: 'creationTime',
        render: function render(text) {
          return _react2['default'].createElement(
            'div',
            null,
            text
          );
        }
      }, {
        title: _MyTasksStore2['default'].language[intlPrefix + '.lastUpdateDate'],
        dataIndex: 'lastUpdateDate',
        key: 'lastUpdateDate',
        render: function render(text) {
          return _react2['default'].createElement(
            'div',
            null,
            text
          );
        }
      }];

      return _react2['default'].createElement(
        'div',
        { id: 'task', className: 'wb-know wb-card' },
        _react2['default'].createElement(
          _tabs2['default'],
          { className: 'task-tab-wrap', defaultActiveKey: '1', size: 'small', onChange: this.handleChange.bind(this), tabBarExtraContent: this.renderTaskRightButton() },
          _react2['default'].createElement(
            TabPane,
            { style: { overflow: 'unset' }, tab: _react2['default'].createElement(
                'span',
                null,
                _MyTasksStore2['default'].language.approval,
                _react2['default'].createElement(
                  'span',
                  { style: { color: '#C53536', marginLeft: 3 } },
                  itsmCount > 0 ? '(' + itsmCount + ')' : ''
                )
              ), key: '1' },
            _react2['default'].createElement(
              'div',
              {
                onScrollCapture: function onScrollCapture() {
                  return _this4.onScrollEvent();
                },
                style: { height: '100%', overflowY: 'scroll' },
                ref: function ref(c) {
                  _this4.scrollRef = c;
                }
              },
              _react2['default'].createElement(_table2['default'], {
                className: 'MyTaskTable task-tab-1',
                dataSource: toDoListData,
                columns: approvalColumns,
                filterBar: false,
                onChange: this.handlePageChange.bind(this)
                // loading={MyTasksStore.getIsLoading}
                , pagination: false
                // scroll={{ y: `${this.state.height}px` }}
                // scroll={{ y: `calc(100% - 37px)` }}
                , empty: _MyTasksStore2['default'].language['organization.globalsearch.noData']
              })
            )
          ),
          _react2['default'].createElement(
            TabPane,
            { tab: _react2['default'].createElement(
                'span',
                null,
                _MyTasksStore2['default'].language.process,
                _react2['default'].createElement(
                  'span',
                  { style: { color: '#C53536', marginLeft: 3 } },
                  count > 0 ? '(' + count + ')' : ''
                )
              ), key: '2' },
            _react2['default'].createElement(_table2['default'], {
              className: 'MyTaskTable task-tab-2',
              dataSource: _MyTasksStore2['default'].getUserBacklog,
              columns: taskColumns,
              filterBar: false,
              loading: _MyTasksStore2['default'].getIsLoading,
              pagination: false,
              scroll: { y: this.state.height + 'px' },
              empty: _MyTasksStore2['default'].language['organization.globalsearch.noData']
            })
          )
        ),
        this.state.preview ? _react2['default'].createElement(
          _modal2['default'],
          {
            title: this.renderTitle(),
            visible: this.state.preview,
            footer: [_react2['default'].createElement(
              _button2['default'],
              { key: 'submit', type: 'primary', loading: this.state.submitting, onClick: this.handleOk },
              _MyTasksStore2['default'].language.agree
            ), _react2['default'].createElement(
              _button2['default'],
              { key: 'back', onClick: this.handleCancel },
              _MyTasksStore2['default'].language.reject
            )],
            width: '30%',
            style: { top: 100 },
            className: 'invite-modal',
            onCancel: function onCancel() {
              _this4.setState({ preview: false });
              _this4.getUserBacklog();
            }
          },
          this.renderPreviewContent()
        ) : ''
      );
    }
  }]);
  return MyTasks;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = MyTasks;