'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style3 = require('yqcloud-ui/lib/table/style');

var _table = require('yqcloud-ui/lib/table');

var _table2 = _interopRequireDefault(_table);

var _style4 = require('yqcloud-ui/lib/tooltip/style');

var _tooltip = require('yqcloud-ui/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _mobxReact = require('mobx-react');

require('./ProjectService.scss');

var _ProjectServiceStore = require('../../../stores/ProjectServiceStore');

var _ProjectServiceStore2 = _interopRequireDefault(_ProjectServiceStore);

var _change3x = require('../../../../assets/images/projectServiceList/change@3x.svg');

var _change3x2 = _interopRequireDefault(_change3x);

var _incident3x = require('../../../../assets/images/projectServiceList/incident@3x.svg');

var _incident3x2 = _interopRequireDefault(_incident3x);

var _problem3x = require('../../../../assets/images/projectServiceList/problem@3x.svg');

var _problem3x2 = _interopRequireDefault(_problem3x);

var _other3x = require('../../../../assets/images/projectServiceList/other@3x.svg');

var _other3x2 = _interopRequireDefault(_other3x);

var _service3x = require('../../../../assets/images/projectServiceList/service@3x.svg');

var _service3x2 = _interopRequireDefault(_service3x);

var _task3x = require('../../../../assets/images/projectServiceList/task@3x.svg');

var _task3x2 = _interopRequireDefault(_task3x);

var _nodata = require('../../../../assets/images/projectServiceList/nodata.svg');

var _nodata2 = _interopRequireDefault(_nodata);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var intlPrefix = 'portal.projectList';

/**
 *  单据数量
 */
var ProjectService = (_dec = (0, _mobxReact.inject)('AppState'), (0, _reactIntl.injectIntl)(_class = _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3['default'])(ProjectService, _Component);

  function ProjectService(props) {
    (0, _classCallCheck3['default'])(this, ProjectService);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (ProjectService.__proto__ || Object.getPrototypeOf(ProjectService)).call(this, props));

    _this.loadLanguage = function () {
      var AppState = _this.props.AppState;

      _ProjectServiceStore2['default'].queryLanguage(_this.organizationId, AppState.currentLanguage);
    };

    _this.getSourceCode = function () {
      _ProjectServiceStore2['default'].getSourceCode(_this.organizationId, 'ITSMTICKETTYPE').then(function (data) {
        if (data.failed) {
          //
        } else {
          _this.setState({
            ticketCode: data
          });
        }
      })['catch'](function (error) {
        Choerodon.handleResponseError(error);
      });
    };

    _this.getProjectList = function () {
      _ProjectServiceStore2['default'].loadProjectData(_this.organizationId).then(function (data) {
        if (data.failed) {
          //
        } else {
          _this.setState({
            projectListData: data
          });
        }
      })['catch'](function (error) {
        Choerodon.handleResponseError(error);
      });
    };

    _this.organizationId = _this.props.AppState.currentMenuType.id;
    _this.state = _this.getInitState();
    return _this;
  }

  (0, _createClass3['default'])(ProjectService, [{
    key: 'getInitState',
    value: function getInitState() {
      return {
        // ticketCode: [],
        projectListData: []
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.loadLanguage();
      // this.getSourceCode();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.getProjectList();
    }

    // 获取语言


    // 获取状态的快码


    // 获取项目集合数据

  }, {
    key: 'render',
    value: function render() {
      var projectListData = this.state.projectListData;


      var columns = [{
        dataIndex: 'name',
        key: 'name',
        // align: 'center',
        render: function render(text, record) {
          // let vidwText = '';
          // ticketCode.forEach(item => {
          //   if (item.lookupValue === text) {
          //     vidwText = item.lookupMeaning;
          //   }
          // });
          if (record.children !== undefined) {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else if (record.ticketType === 'CHANGE') {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _change3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else if (record.ticketType === 'INCIDENT') {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _incident3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else if (record.ticketType === 'PROBLEM') {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _problem3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else if (record.ticketType === 'SERVICE_REQUEST') {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _service3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else if (record.ticketType === 'TASK') {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _task3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          } else {
            return _react2['default'].createElement(
              'span',
              { className: 'table-row-text' },
              _react2['default'].createElement('img', { className: 'table-img', src: _other3x2['default'] }),
              _react2['default'].createElement(
                _tooltip2['default'],
                { placement: 'topLeft', title: text },
                text
              )
            );
          }
        }
      }, {
        title: _ProjectServiceStore2['default'].language[intlPrefix + '.table.my'],
        dataIndex: 'submitCount',
        key: 'submitCount'
      }, {
        title: _ProjectServiceStore2['default'].language[intlPrefix + '.table.pending'],
        dataIndex: 'resolveCount',
        key: 'resolveCount'
      }, {
        title: _ProjectServiceStore2['default'].language[intlPrefix + '.table.shelters'],
        dataIndex: 'claimCount',
        key: 'claimCount'
      }];

      var mainContent = _react2['default'].createElement(_table2['default'], {
        columns: columns,
        pagination: false,
        filterBar: false,
        defaultExpandAllRows: true,
        dataSource: projectListData
      });

      var nodataContent = _react2['default'].createElement(
        'div',
        { className: 'nodata-div' },
        _react2['default'].createElement('img', { className: 'nodata-img', src: _nodata2['default'] }),
        _react2['default'].createElement(
          'div',
          { className: 'nodata-description' },
          _ProjectServiceStore2['default'].language['organization.globalsearch.noData']
        )
      );

      return _react2['default'].createElement(
        'div',
        { className: 'flex-box-portal-project' },
        _react2['default'].createElement(
          'div',
          { className: 'project-content' },
          projectListData && projectListData.length > 0 ? mainContent : nodataContent
        )
      );
    }
  }]);
  return ProjectService;
}(_react.Component)) || _class) || _class) || _class);
exports['default'] = ProjectService;