'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var WSHandler = (_temp2 = _class = function (_Component) {
  (0, _inherits3['default'])(WSHandler, _Component);

  function WSHandler() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3['default'])(this, WSHandler);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3['default'])(this, (_ref = WSHandler.__proto__ || Object.getPrototypeOf(WSHandler)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      data: null
    }, _this.handleMessage = function (data) {
      var onMessage = _this.props.onMessage;

      if (typeof onMessage === 'function') {
        onMessage(JSON.parse(data).data);
      }
      _this.setState({
        data: JSON.parse(data).data
      });
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this, _ret);
  }

  (0, _createClass3['default'])(WSHandler, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.register(this.props, this.context);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextContext) {
      if (nextProps.messageKey !== this.props.messageKey) {
        this.unregister(this.props, this.context);
        this.register(nextProps, nextContext);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unregister(this.props, this.context);
    }
  }, {
    key: 'register',
    value: function register(props, context) {
      var messageKey = props.messageKey,
          path = props.path;
      var ws = context.ws;

      if (ws) {
        ws.register(messageKey, { type: 'sub', data: messageKey }, this.handleMessage, path);
      }
    }
  }, {
    key: 'unregister',
    value: function unregister(props, context) {
      var messageKey = props.messageKey,
          path = props.path;
      var ws = context.ws;

      if (ws) {
        ws.unregister(messageKey, this.handleMessage, path);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.state.data;
      var children = this.props.children;

      if (typeof children === 'function') {
        return children(data);
      } else {
        return children;
      }
    }
  }]);
  return WSHandler;
}(_react.Component), _class.defaultProps = {
  path: 'choerodon:msg'
}, _class.propTypes = {
  messageKey: _propTypes2['default'].string.isRequired,
  path: _propTypes2['default'].string, // 能从Provider获得指定path的连接
  autoReconnect: _propTypes2['default'].bool, // 在WebSocket连接断开后要能自动重连
  onMessage: _propTypes2['default'].func,
  onCreate: _propTypes2['default'].func,
  onClose: _propTypes2['default'].func,
  onError: _propTypes2['default'].func,
  onRetry: _propTypes2['default'].func
}, _class.contextTypes = {
  ws: _propTypes2['default'].object
}, _temp2);
exports['default'] = WSHandler;