'use strict';

/**
 * 前端字典列表定义
 * create by Steven King at 2019.05.22
 */
var dictJson = {
  // 服务单筛选字典
  serviceKeyData: ['匹配度/_score/matchScore', '创建时间/submitDate/createAt'],
  // 知识库筛选字典
  knowledgeKeyData: ['综合/dateAndScore/comprehensive', '评分/averageScore/score', '匹配度/score/matchScore', '阅读量/readCount/readCount', '创建时间/creationDate/createAt'],

  // 问答库筛选字典
  questionKeyData: ['匹配度/_score/matchScore', '创建时间/creationDate/createAt'],
  // 搜索域
  searchFieldKeyData: ['不限/ALL0/all', '标题/title/title', '关键字/label/keyword', '创建人/createBy/creator', '正文/content/content', '分类/category/category', '知识编码/serialNumber/knowledgeCode'],
  // 搜索范围
  searchRangeKeyData: ['不限/ALL1/all', '所属租户/organization/organizationBelong', '所属部门/dept/department', '项目/project/project', '个人/user/user'],
  // 知识来源
  sourceKeyData: ['不限/ALL2/all', '知识库/KNOWLEDGEBASE/knowledgeBase', 'IT服务管理/ITSM/itsm'],
  searchTypeKeyData: ['模糊/fuzzy/fuzzy', '精确/precise/precise'],
  knowSearchTypeKeyData: ['搜索域/sfield/searchField', '知识范围/sRange/searchRange', '知识来源/sSource/searchSource', '查询方式/sType/searchType', '发布时间/publishAt/publishDate']
};

var id = Number(new Date());
var getId = function getId() {
  return 'createDataAutoId_' + id++;
};

// 模拟数据 自动生成id
var createDataAutoId = function createDataAutoId(sampleArr) {
  var dataArr = [];
  sampleArr.map(function (name) {
    return dataArr.push({ id: getId(), name: name });
  });
  return dataArr;
};

// 模拟数据 写死id
var createData = function createData(sampleArr) {
  var dataArr = [];
  sampleArr.map(function (val) {
    return dataArr.push({ id: val.split('/')[1], name: val.split('/')[0] });
  });
  return dataArr;
};

// 枚举数据 加入语言包  格式： 中文解释/id/语言包的key值（可能省去了语言包的前缀，具体使用而定）
var createLanguageData = function createLanguageData(sampleArr) {
  var dataArr = [];
  sampleArr.map(function (val) {
    return dataArr.push({ id: val.split('/')[1], name: val.split('/')[2] });
  });
  return dataArr;
};

exports.serviceFilterList = createLanguageData(dictJson.serviceKeyData);
exports.knowledgeFilterList = createLanguageData(dictJson.knowledgeKeyData);
exports.questionFilterList = createLanguageData(dictJson.questionKeyData);
exports.searchRangeList = createLanguageData(dictJson.searchRangeKeyData);
exports.searchFieldList = createLanguageData(dictJson.searchFieldKeyData);
exports.searchRangeList = createLanguageData(dictJson.searchRangeKeyData);
exports.sourceList = createLanguageData(dictJson.sourceKeyData);
exports.searchTypeList = createLanguageData(dictJson.searchTypeKeyData);
exports.knowSearchTypeList = createLanguageData(dictJson.knowSearchTypeKeyData);