'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2; /**
                                                                      * Created by kaicheng.liu on 2018/9/26.
                                                                      */

var _mobx = require('mobx');

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _store = require('../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var AnnouncementStore = (_dec = (0, _store2['default'])('AnnouncementStore'), _dec(_class = (_class2 = function (_LanguageStore) {
  (0, _inherits3['default'])(AnnouncementStore, _LanguageStore);

  function AnnouncementStore() {
    (0, _classCallCheck3['default'])(this, AnnouncementStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (AnnouncementStore.__proto__ || Object.getPrototypeOf(AnnouncementStore)).call(this, 'announcement'));

    _initDefineProp(_this, 'isLoading', _descriptor, _this);

    _initDefineProp(_this, 'announcements', _descriptor2, _this);

    _this.loadAnnouncementList = function (iamOrganizationId, _ref) {
      var current = _ref.current,
          pageSize = _ref.pageSize;

      _this.setIsLoading(true);
      var queryObj = {
        page: current - 1,
        size: pageSize
      };
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/announcement/self?' + _queryString2['default'].stringify(queryObj));
    };

    _this.getAnnouncementById = function (iamOrganizationId, announcementId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/announcement/detail/' + announcementId);
    };

    _this.getAnnouncementNoView = function (iamOrganizationId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/announcement/noviewd/count');
    };

    _this.viewAnnouncement = function (iamOrganizationId, announcementId) {
      return _axios2['default'].put('/portal/v1/' + iamOrganizationId + '/announcement/view/' + announcementId);
    };

    _this.downloadFile = function (iamOrganizationId, fileId) {
      return _axios2['default'].get('/fileService/v1/' + iamOrganizationId + '/file/' + fileId);
    };

    return _this;
  }

  (0, _createClass3['default'])(AnnouncementStore, [{
    key: 'setIsLoading',
    value: function setIsLoading(flag) {
      this.isLoading = flag;
    }
  }, {
    key: 'setAnnouncements',
    value: function setAnnouncements(data) {
      this.announcements = data;
    }
  }, {
    key: 'getIsLoading',
    get: function get() {
      return this.isLoading;
    }
  }, {
    key: 'getAnnouncements',
    get: function get() {
      return this.announcements.slice();
    }

    /* 用户的公告信息列表 */


    /* 查询公告具体信息 */


    /* 当前用户未查看公告的数量 */


    /* 表示已查看公告 */


    /* 下载文件 */

  }]);
  return AnnouncementStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'isLoading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'announcements', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setIsLoading', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getIsLoading', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setAnnouncements', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setAnnouncements'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getAnnouncements', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getAnnouncements'), _class2.prototype)), _class2)) || _class);


var announcementStore = new AnnouncementStore();

exports['default'] = announcementStore;