'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6;

var _mobx = require('mobx');

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

function getDefaultLanguage() {
  var locale = void 0;
  if (typeof window !== 'undefined') {
    // locale = navigator.language || navigator.userLanguage || navigator.systemLanguage;
  }
  return locale ? locale.replace('-', '_') : 'zh_CN';
}

var AppState = (_class = function () {
  function AppState() {
    var _this = this;

    (0, _classCallCheck3['default'])(this, AppState);

    _initDefineProp(this, 'menuType', _descriptor, this);

    _initDefineProp(this, 'expanded', _descriptor2, this);

    _initDefineProp(this, 'userInfo', _descriptor3, this);

    _initDefineProp(this, 'debugger', _descriptor4, this);

    _initDefineProp(this, 'isUser', _descriptor5, this);

    _initDefineProp(this, 'hideMenu', _descriptor6, this);

    this.loadUserInfo = function () {
      return _axios2['default'].get('/iam/v1/users/self');
    };

    this.loadUserInfoByOrganizationId = function (organizationId) {
      return _axios2['default'].get('/iam/v1/users/self?organizationId=' + organizationId);
    };

    this.loadPortalEnterUrl = function () {
      return _axios2['default'].get('/itsm/v1/portal/' + _this.userInfo.currentOrganizationId + '/id');
    };
  } // 一个菜单对象 {id:'',name:'',type:''}

  // 调试模式

  (0, _createClass3['default'])(AppState, [{
    key: 'setDebugger',
    value: function setDebugger(data) {
      this['debugger'] = data;
    }
  }, {
    key: 'setUserInfo',
    value: function setUserInfo(user) {
      this.userInfo = user;
    }
  }, {
    key: 'setMenuExpanded',
    value: function setMenuExpanded(data) {
      this.expanded = data;
    }
  }, {
    key: 'setAuthenticated',
    value: function setAuthenticated(flag) {
      this.isAuthenticated = flag;
    }
  }, {
    key: 'changeMenuType',
    value: function changeMenuType(type) {
      sessionStorage.menType = JSON.stringify(type);
      sessionStorage.selectData = JSON.stringify(type);
      sessionStorage.type = type.type;
      this.menuType = type;
    }
  }, {
    key: 'setTypeUser',
    value: function setTypeUser(isUser) {
      sessionStorage.user = isUser ? 'user' : '';
      this.isUser = isUser;
    }
  }, {
    key: 'setHideMenu',
    value: function setHideMenu(hideMenu) {
      this.hideMenu = hideMenu;
    }
  }, {
    key: 'getUserId',
    // 是否隐藏菜单

    get: function get() {
      return this.userInfo.id;
    }
  }, {
    key: 'getDebugger',
    get: function get() {
      return this['debugger'];
    }
  }, {
    key: 'getType',
    get: function get() {
      return this.currentMenuType.type;
    }
  }, {
    key: 'getUserInfo',
    get: function get() {
      return this.userInfo;
    }
  }, {
    key: 'getMenuExpanded',
    get: function get() {
      return this.expanded;
    }
  }, {
    key: 'currentLanguage',
    get: function get() {
      return this.userInfo.language || getDefaultLanguage();
    }
  }, {
    key: 'isAuth',
    get: function get() {
      return !!this.userInfo.loginName;
    }
  }, {
    key: 'currentMenuType',
    get: function get() {
      return this.menuType;
    }
  }, {
    key: 'isTypeUser',
    get: function get() {
      return this.isUser;
    }
  }]);
  return AppState;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'menuType', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'expanded', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'userInfo', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'debugger', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'isUser', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'hideMenu', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'getUserId', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getUserId'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getDebugger', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getDebugger'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setDebugger', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setDebugger'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getType', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getType'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getUserInfo', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getUserInfo'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setUserInfo', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setUserInfo'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getMenuExpanded', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getMenuExpanded'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setMenuExpanded', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setMenuExpanded'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'currentLanguage', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'currentLanguage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'isAuth', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'isAuth'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'currentMenuType', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'currentMenuType'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setAuthenticated', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setAuthenticated'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'changeMenuType', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'changeMenuType'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setTypeUser', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setTypeUser'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'isTypeUser', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'isTypeUser'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setHideMenu', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setHideMenu'), _class.prototype)), _class);


var appState = new AppState();
exports['default'] = appState;