'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style2 = require('yqcloud-ui/lib/message/style');

var _message = require('yqcloud-ui/lib/message');

var _message2 = _interopRequireDefault(_message);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3; /**
                                                                                    * create by Pang Kanghua on 2018/11/22
                                                                                    * @target 日历
                                                                                    */

var _mobx = require('mobx');

var _store = require('../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var CalendarStore = (_dec = (0, _store2['default'])('CalendarStore'), _dec(_class = (_class2 = function (_LanguageStore) {
  (0, _inherits3['default'])(CalendarStore, _LanguageStore);

  function CalendarStore() {
    (0, _classCallCheck3['default'])(this, CalendarStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (CalendarStore.__proto__ || Object.getPrototypeOf(CalendarStore)).call(this, 'myCalendar'));

    _initDefineProp(_this, 'isLoading', _descriptor, _this);

    _initDefineProp(_this, 'tagData', _descriptor2, _this);

    _initDefineProp(_this, 'userBacklog', _descriptor3, _this);

    _this.loadWorkCalendar = function (iamOrganizationId) {
      return _axios2['default'].get('fnd/v1/' + iamOrganizationId + '/sys/calendars/work');
    };

    _this.loadTagData = function (iamOrganizationId, code) {
      return _axios2['default'].get('/fnd/v1/' + iamOrganizationId + '/lookup/code?' + (code ? 'lookupTypeCode=' + code : ''));
    };

    _this.getStrokeById = function (iamOrganizationId, strokeId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/stroke/' + strokeId);
    };

    _this.loadDoneStrokeList = function (iamOrganizationId, date) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/stroke/self/done' + (date ? '?date=' + date : ''));
    };

    _this.loadUndoneStrokeList = function (iamOrganizationId, date) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/stroke/self/undone' + (date ? '?date=' + date : ''));
    };

    _this.deleteStroke = function (iamOrganizationId, strokeId, objectVersionNumber) {
      return _axios2['default']['delete']('/portal/v1/' + iamOrganizationId + '/stroke/' + strokeId + '/' + objectVersionNumber);
    };

    _this.updateStroke = function (iamOrganizationId, strokeInfo) {
      return _axios2['default'].put('/portal/v1/' + iamOrganizationId + '/stroke', JSON.stringify(strokeInfo));
    };

    _this.createStroke = function (iamOrganizationId, strokeInfo) {
      return _axios2['default'].post('/portal/v1/' + iamOrganizationId + '/stroke', JSON.stringify(strokeInfo));
    };

    _this.getStrokeDate = function (iamOrganizationId, date) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/stroke/days?date=' + date);
    };

    _this.getTypeCode = function (iamOrganizationId, code) {
      return _axios2['default'].get('fnd/v1/' + iamOrganizationId + '/lookup/value/dto/site?lookupTypeCode=' + code);
    };

    _this.getCode = function (code) {
      return _axios2['default'].get('/fnd/v1/sys/messages/queryCode?messageCode=' + code).then(function (data) {
        var infailed = data.failed;

        var types = data.type;
        if (!infailed) {
          _message2['default'][types](data.content, undefined, undefined, '' + data.placement);
        } else {
          _message2['default'][types](code, undefined, undefined, '' + data.placement);
        }
      });
    };

    return _this;
  }

  (0, _createClass3['default'])(CalendarStore, [{
    key: 'setIsLoading',
    value: function setIsLoading(flag) {
      this.isLoading = flag;
    }
  }, {
    key: 'setTagData',
    value: function setTagData(data) {
      this.tagData = data;
    }
  }, {
    key: 'setUserBacklog',
    value: function setUserBacklog(data) {
      this.userBacklog = data;
    }
  }, {
    key: 'getIsLoading',
    get: function get() {
      return this.isLoading;
    }
  }, {
    key: 'getTagData',
    get: function get() {
      return this.tagData;
    }
  }, {
    key: 'getUserBacklog',
    get: function get() {
      return this.userBacklog;
    }

    /* 获取工作日历 */


    /* 加载快码标签数据 */


    /* 通过id查询行程信息 */


    /* 加载用户未完成行程列表 */


    /* 加载用户已完成行程列表 */


    /* 删除行程 */


    /* 修改行程 */


    /* 创建行程 */


    /* 查询行程日期 */


    /* 查询类型 */

  }]);
  return CalendarStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'isLoading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'tagData', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'userBacklog', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setIsLoading', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getIsLoading', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setTagData', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setTagData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getTagData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getTagData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setUserBacklog', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setUserBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getUserBacklog', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getUserBacklog'), _class2.prototype)), _class2)) || _class);


var calendarStore = new CalendarStore();

exports['default'] = calendarStore;