'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _mobx = require('mobx');

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _common = require('../common');

var _AppState = require('./AppState');

var _AppState2 = _interopRequireDefault(_AppState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var DashboardStore = (_class = function () {
  function DashboardStore() {
    (0, _classCallCheck3['default'])(this, DashboardStore);

    _initDefineProp(this, 'dashboardGroup', _descriptor, this);

    _initDefineProp(this, 'editing', _descriptor2, this);

    _initDefineProp(this, 'loading', _descriptor3, this);

    _initDefineProp(this, 'dirty', _descriptor4, this);
  }

  (0, _createClass3['default'])(DashboardStore, [{
    key: 'setEditing',
    value: function setEditing(editing) {
      this.editing = editing;
    }
  }, {
    key: 'changeVisible',
    value: function changeVisible(data, visible) {
      (0, _mobx.set)(data, 'visible', visible);
      this.dirty = true;
    }
  }, {
    key: 'updateCachedData',
    value: function updateCachedData(_ref) {
      var level = _ref.level,
          code = _ref.code,
          name = _ref.name,
          title = _ref.title,
          icon = _ref.icon,
          namespace = _ref.namespace;

      var group = this.dashboardGroup[level];
      Object.keys(group).forEach(function (key) {
        var found = group[key] && group[key].find(function (_ref2) {
          var dashboardCode = _ref2.dashboardCode,
              dashboardNamespace = _ref2.dashboardNamespace;
          return dashboardCode === code && dashboardNamespace === namespace;
        });
        if (found) {
          (0, _mobx.set)(found, 'dashboardTitle', title);
          (0, _mobx.set)(found, 'dashboardName', name);
          (0, _mobx.set)(found, 'dashboardIcon', icon);
        }
      });
    }
  }, {
    key: 'setDashboardData',
    value: function setDashboardData(data, childType, id) {
      (0, _mobx.set)(this.dashboardGroup[childType], id, data);
      this.dirty = false;
    }
  }, {
    key: 'loadDashboardData',
    value: function loadDashboardData() {
      var _this = this;

      var _AppState$currentMenu = _AppState2['default'].currentMenuType,
          _AppState$currentMenu2 = _AppState$currentMenu.id,
          id = _AppState$currentMenu2 === undefined ? '0' : _AppState$currentMenu2,
          _AppState$currentMenu3 = _AppState$currentMenu.type,
          type = _AppState$currentMenu3 === undefined ? 'site' : _AppState$currentMenu3;

      var dashboardData = this.dashboardData(type, id);
      if (dashboardData.length) {
        return Promise.resolve(dashboardData);
      }
      this.loading = true;
      return _axios2['default'].get('/iam/v1/home/dashboard?level=' + type + '&source_id=' + id).then((0, _mobx.action)(function (data) {
        _this.loading = false;
        if (!data.failed) {
          _this.setDashboardData(data, type, id);
        }
        return data;
      }))['catch']((0, _mobx.action)(function (error) {
        _this.loading = false;
        (0, _common.handleResponseError)(error);
      }));
    }
  }, {
    key: 'updateDashboardData',
    value: function updateDashboardData() {
      var _this2 = this;

      this.loading = true;
      var _AppState$currentMenu4 = _AppState2['default'].currentMenuType,
          _AppState$currentMenu5 = _AppState$currentMenu4.id,
          id = _AppState$currentMenu5 === undefined ? '0' : _AppState$currentMenu5,
          _AppState$currentMenu6 = _AppState$currentMenu4.type,
          type = _AppState$currentMenu6 === undefined ? 'site' : _AppState$currentMenu6;

      return _axios2['default'].post('/iam/v1/home/dashboard?level=' + type + '&source_id=' + id, JSON.stringify(this.dashboardData(type, id))).then((0, _mobx.action)(function (data) {
        _this2.loading = false;
        if (!data.failed) {
          _this2.setDashboardData(data, type, id);
        }
        return data;
      }))['catch']((0, _mobx.action)(function (error) {
        _this2.loading = false;
        (0, _common.handleResponseError)(error);
      }));
    }
  }, {
    key: 'dashboardData',
    value: function dashboardData(type, id) {
      return (0, _mobx.get)(this.dashboardGroup[type], id) || [];
    }
  }, {
    key: 'getDashboardData',
    get: function get() {
      var _AppState$currentMenu7 = _AppState2['default'].currentMenuType,
          _AppState$currentMenu8 = _AppState$currentMenu7.id,
          id = _AppState$currentMenu8 === undefined ? '0' : _AppState$currentMenu8,
          _AppState$currentMenu9 = _AppState$currentMenu7.type,
          type = _AppState$currentMenu9 === undefined ? 'site' : _AppState$currentMenu9;

      return this.dashboardData(type, id);
    }
  }]);
  return DashboardStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'dashboardGroup', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {
      site: { 0: [] },
      organization: {},
      project: {}
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'editing', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'loading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'dirty', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'setEditing', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setEditing'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'changeVisible', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'changeVisible'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'updateCachedData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'updateCachedData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setDashboardData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setDashboardData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getDashboardData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getDashboardData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'loadDashboardData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'loadDashboardData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'updateDashboardData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'updateDashboardData'), _class.prototype)), _class);


var dashboardStore = new DashboardStore();

exports['default'] = dashboardStore;