'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12;

var _mobx = require('mobx');

var _object = require('object.omit');

var _object2 = _interopRequireDefault(_object);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _store = require('../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var ORGANIZATION_TYPE = 'organization';
var PROJECT_TYPE = 'project';

function findDataIndex(collection, value) {
  return collection ? collection.findIndex(function (_ref) {
    var id = _ref.id,
        organizationId = _ref.organizationId;
    return id === value.id && (!organizationId && !value.organizationId || organizationId === value.organizationId);
  }) : -1;
}

// 保留多少recent内容
function saveRecent() {
  var collection = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var value = arguments[1];
  var number = arguments[2];

  var index = findDataIndex(collection, value);
  if (index !== -1) {
    return collection.splice(index, 1).concat(collection.slice());
  } else {
    collection.unshift(value);
    return collection.slice(0, number);
  }
}

var HeaderStore = (_dec = (0, _store2['default'])('HeaderStore'), _dec(_class = (_class2 = function (_LanguageStore) {
  (0, _inherits3['default'])(HeaderStore, _LanguageStore);

  function HeaderStore() {
    (0, _classCallCheck3['default'])(this, HeaderStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (HeaderStore.__proto__ || Object.getPrototypeOf(HeaderStore)).call(this, 'bootHeader'));

    _initDefineProp(_this, 'orgData', _descriptor, _this);

    _initDefineProp(_this, 'proData', _descriptor2, _this);

    _initDefineProp(_this, 'selected', _descriptor3, _this);

    _initDefineProp(_this, 'recentItem', _descriptor4, _this);

    _initDefineProp(_this, 'userPreferenceVisible', _descriptor5, _this);

    _initDefineProp(_this, 'menuTypeVisible', _descriptor6, _this);

    _initDefineProp(_this, 'inboxVisible', _descriptor7, _this);

    _initDefineProp(_this, 'inboxData', _descriptor8, _this);

    _initDefineProp(_this, 'statusList', _descriptor9, _this);

    _initDefineProp(_this, 'successList', _descriptor10, _this);

    _initDefineProp(_this, 'exportList', _descriptor11, _this);

    _initDefineProp(_this, 'inboxLoaded', _descriptor12, _this);

    _this.axiosGetOrgMsg = function (iamOrganizationId, userId) {
      return _axios2['default'].get('iam/v1/users/' + iamOrganizationId + '/' + userId + '/organization');
    };

    _this.getNotice = function (iamOrganizationId, data) {
      return _axios2['default'].post('/message/v1/' + iamOrganizationId + '/query/match/anyOne', JSON.stringify(data)).then(function (res) {
        console.log(res);
        if (res.success) {
          var beChangeArray = [];
          for (var key in res.result) {
            beChangeArray.unshift({
              id: key,
              content: res.result[key]
            });
          }
          console.log('arr ====>', beChangeArray);
          return beChangeArray;
        }
        return {};
      });
    };

    _this.allToReads = function (iamOrganizationId) {
      return _axios2['default'].put('/message/v1/' + iamOrganizationId + '/msg/notice/read/marks');
    };

    _this.getNoticeNum = function (iamOrganizationId, data) {
      return _axios2['default'].post('/message/v1/' + iamOrganizationId + '/query/number', JSON.stringify(data));
    };

    _this.readMsg = function (iamOrganizationId, ids) {
      return _axios2['default'].put('/message/v1/' + iamOrganizationId + '/msg/notice/read/marks/ids', JSON.stringify(ids));
    };

    _this.noticeDelete = function (iamOrganizationId, ids) {
      return _axios2['default']['delete']('/message/v1/' + iamOrganizationId + '/msg/notice/delete', { data: JSON.stringify(ids) });
    };

    _this.queryNotice = function (iamOrganizationId, data) {
      return _axios2['default'].post('/message/v1/' + iamOrganizationId + '/query/match/anyOne', JSON.stringify(data)).then(function (res) {
        console.log(res);
        if (res.success) {
          var beChangeArray = [];
          for (var key in res.result) {
            beChangeArray.unshift({
              id: key,
              content: res.result[key]
            });
          }
          console.log('arr ====>', beChangeArray);
          return beChangeArray;
        }
        return {};
      });
    };

    _this.downloadFile = function (iamOrganizationId, fileId) {
      return _axios2['default'].get('fileService/v1/' + iamOrganizationId + '/file/' + fileId);
    };

    _this.getAnnouncementById = function (iamOrganizationId, announcementId) {
      return _axios2['default'].get('portal/v1/' + iamOrganizationId + '/announcement/detail/' + announcementId)['catch'](function (err) {
        console.log(err);
      });
    };

    _this.queryStatusList = function (iamOrganizationId) {
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'FND_APP_SYSTEM';
      return _axios2['default'].get('fnd/v1/' + iamOrganizationId + '/lookup/value/dto/site?lookupTypeCode=' + code).then(function (data) {
        _this.setStatusList(data);
      });
    };

    _this.querySuccessList = function (iamOrganizationId) {
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'FND_DOWNLOAD_STATUS';
      return _axios2['default'].get('fnd/v1/' + iamOrganizationId + '/lookup/value/dto/site?lookupTypeCode=' + code).then(function (data) {
        _this.setSuccessList(data);
      });
    };

    _this.queryExportList = function (iamOrganizationId) {
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'FND_TASK_TYPE';
      return _axios2['default'].get('fnd/v1/' + iamOrganizationId + '/lookup/value/dto/site?lookupTypeCode=' + code).then(function (data) {
        _this.setExportList(data);
      });
    };

    _this.deleteMission = function (iamOrganizationId, missionId) {
      return _axios2['default']['delete']('scheduler/v1/' + iamOrganizationId + '/file/mission/' + missionId);
    };

    _this.downloadMission = function (iamOrganizationId, fileId, missionId) {
      return _axios2['default'].get('fileService/v1/' + iamOrganizationId + '/file/mission/' + fileId + '?missionId=' + missionId);
    };

    _this.loadFileMission = function (iamOrganizationId) {
      return _axios2['default'].get('scheduler/v1/' + iamOrganizationId + '/file/mission/mine');
    };

    _this.getOrganizations = function (iamOrganizationId) {
      return _axios2['default'].get('/iam/v1/' + iamOrganizationId + '/organizations');
    };

    _this.getQueryString = function (name) {
      var url = window.location.hash;
      var theRequest = {};
      if (url.indexOf('?') !== -1) {
        var str = url.substr(1);
        var strs = str.split('&');
        for (var i = 0; i < strs.length; i += 1) {
          theRequest[strs[i].split('=')[0]] = unescape(strs[i].split('=')[1]);
        }
        return theRequest[name];
      }
    };

    return _this;
  }

  (0, _createClass3['default'])(HeaderStore, [{
    key: 'setStatusList',
    value: function setStatusList(statusList) {
      this.statusList = statusList;
    }
  }, {
    key: 'setSuccessList',
    value: function setSuccessList(successList) {
      this.successList = successList;
    }
  }, {
    key: 'setExportList',
    value: function setExportList(exportList) {
      this.exportList = exportList;
    }
  }, {
    key: 'setSelected',
    value: function setSelected(data) {
      this.selected = data;
    }
  }, {
    key: 'setOrgData',
    value: function setOrgData(data) {
      this.orgData = data.filter(function (item) {
        return item.enabled === true;
      });
    }
  }, {
    key: 'setUserPreferenceVisible',
    value: function setUserPreferenceVisible(userPreferenceVisible) {
      this.userPreferenceVisible = userPreferenceVisible;
    }
  }, {
    key: 'setMenuTypeVisible',
    value: function setMenuTypeVisible(menuTypeVisible) {
      this.menuTypeVisible = menuTypeVisible;
    }
  }, {
    key: 'setInboxVisible',
    value: function setInboxVisible(inboxVisible) {
      this.inboxVisible = inboxVisible;
    }
  }, {
    key: 'axiosGetOrgAndPro',
    value: function axiosGetOrgAndPro(userId) {
      var _this2 = this;

      return _axios2['default'].all([_axios2['default'].get('/iam/v1/users/' + userId + '/organizations'), _axios2['default'].get('/iam/v1/users/' + userId + '/projects')]).then(function (data) {
        var _data = (0, _slicedToArray3['default'])(data, 2),
            organizations = _data[0],
            projects = _data[1];

        organizations.forEach(function (value) {
          value.type = ORGANIZATION_TYPE;
        });
        projects.forEach(function (value) {
          value.type = PROJECT_TYPE;
        });
        _this2.setOrgData(organizations);
        _this2.setProData(projects);
        return data;
      });
    }

    // axiosGetUserMsg(iamOrganizationId) {
    //   return axios.get(`/message/v1/${iamOrganizationId}/msg/notice/page/list?${queryString.stringify({
    //     isRead: 0,
    //     page: 0,
    //     size: 1000,
    //   })}`)
    //     .then(action(({ content }) => {
    //       this.inboxData = content || [];
    //       this.inboxLoaded = true;
    //     }));
    // }
    // 获取通知信息数据
    // axiosGetUserMsg(iamOrganizationId, data) {
    //   return axios.get(`/message/v1/${iamOrganizationId}/msg/notice/classify/page/list?${queryString.stringify(data)}`)
    //     .then(action(({ result }) => {
    //       this.inboxData = result || [];
    //       this.inboxLoaded = true;
    //     }));
    // }

    // 消息归类查询
    // getNotice = (iamOrganizationId, data) => axios.get(`/message/v1/${iamOrganizationId}/msg/notice/classify/page/list?${queryString.stringify(data)}`);

    // es通知查询


    // 全部标记以读


    // 通知数量查询


    // 消息全部标记已读


    // 批量删除


    // 高级搜索


    /* 下载附件 */


    /* 查询公告信息 */

  }, {
    key: 'setProData',
    value: function setProData(data) {
      this.proData = data.filter(function (item) {
        return item.enabled === true;
      });
    }
  }, {
    key: 'addProject',
    value: function addProject(project) {
      project.type = PROJECT_TYPE;
      if (this.proData) {
        this.proData.unshift(project);
      } else {
        this.proData = [project];
      }
    }
  }, {
    key: 'updateProject',
    value: function updateProject(project) {
      project.type = PROJECT_TYPE;
      if (this.proData) {
        var index = this.proData.findIndex(function (_ref2) {
          var id = _ref2.id;
          return id === project.id;
        });
        if (index !== -1) {
          this.proData.splice(index, 1, project);
        }
      }
      this.updateRecentItem(project);
    }
  }, {
    key: 'addOrg',
    value: function addOrg(org) {
      org.type = ORGANIZATION_TYPE;
      if (this.orgData) {
        this.orgData.unshift(org);
      } else {
        this.orgData = [org];
      }
    }
  }, {
    key: 'updateOrg',
    value: function updateOrg(org) {
      org.type = ORGANIZATION_TYPE;
      if (this.orgData) {
        var index = this.orgData.findIndex(function (_ref3) {
          var id = _ref3.id;
          return id === org.id;
        });
        if (index !== -1) {
          this.orgData.splice(index, 1, org);
        }
      }
      this.updateRecentItem(org);
    }
  }, {
    key: 'updateRecentItem',
    value: function updateRecentItem(recent) {
      if (recent) {
        var recentItem = JSON.parse(localStorage.recentItem);
        var index = recentItem.findIndex(function (_ref4) {
          var id = _ref4.id,
              organizationId = _ref4.organizationId;
          return id === recent.id && (!organizationId || organizationId === recent.organizationId);
        });
        if (index !== -1) {
          recentItem.splice(index, 1, recent);
          localStorage.recentItem = JSON.stringify(recentItem);
          this.recentItem = recentItem;
        }
      }
    }

    // 来源系统快码


    // 查询成功状态


    // 查询任务类型

  }, {
    key: 'setRecentItem',
    value: function setRecentItem(recent) {
      if (recent) {
        var recentItem = saveRecent(this.getRecentItem, (0, _object2['default'])(recent, 'children'), 10);
        localStorage.recentItem = JSON.stringify(recentItem);
        this.recentItem = recentItem;
      }
    }

    // 删除任务中心下载列表


    // 任务中心下载列表


    // 获取任务中心文件列表


    // 获取租户信息


    // 获取url里的参数

  }, {
    key: 'getStatusList',
    get: function get() {
      return this.statusList;
    }
  }, {
    key: 'getSuccessList',
    get: function get() {
      return this.successList;
    }
  }, {
    key: 'getExportList',
    get: function get() {
      return this.exportList;
    }
  }, {
    key: 'getUnreadMsg',
    get: function get() {
      return this.inboxData.filter(function (v) {
        return v.noticeType === '站内信' || '待办';
      });
    }
  }, {
    key: 'getSelected',
    get: function get() {
      return this.selected;
    }
  }, {
    key: 'getOrgData',
    get: function get() {
      return this.orgData;
    }
  }, {
    key: 'getProData',
    get: function get() {
      return this.proData;
    }
  }, {
    key: 'getRecentItem',
    get: function get() {
      var _this3 = this;

      var recents = [];
      if (this.recentItem) {
        recents = this.recentItem;
      } else if (localStorage.recentItem) {
        recents = JSON.parse(localStorage.recentItem).map(function (recent) {
          return (0, _object2['default'])(recent, 'children');
        });
      }
      return recents.filter(function (value) {
        return findDataIndex(_this3.orgData, value) !== -1 || findDataIndex(_this3.proData, value) !== -1;
      });
    }
  }]);
  return HeaderStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'orgData', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'proData', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'selected', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'recentItem', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'userPreferenceVisible', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'menuTypeVisible', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'inboxVisible', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'inboxData', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'statusList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'successList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'exportList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, 'inboxLoaded', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setStatusList', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setStatusList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getStatusList', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getStatusList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setSuccessList', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setSuccessList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getSuccessList', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getSuccessList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setExportList', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setExportList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getExportList', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getExportList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getUnreadMsg', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getUnreadMsg'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getSelected', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getSelected'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setSelected', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setSelected'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getOrgData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getOrgData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setOrgData', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setOrgData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getProData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getProData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setUserPreferenceVisible', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setUserPreferenceVisible'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setMenuTypeVisible', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setMenuTypeVisible'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setInboxVisible', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setInboxVisible'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setProData', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setProData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addProject', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'addProject'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'updateProject', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'updateProject'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addOrg', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'addOrg'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'updateOrg', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'updateOrg'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getRecentItem', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getRecentItem'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'updateRecentItem', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'updateRecentItem'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setRecentItem', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setRecentItem'), _class2.prototype)), _class2)) || _class);


var headerStore = new HeaderStore();

exports['default'] = headerStore;