'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9; /**
                                                                                                                                                         * Created by jaywoods on 2017/6/24.
                                                                                                                                                         */


var _mobx = require('mobx');

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _AppState = require('./AppState');

var _AppState2 = _interopRequireDefault(_AppState);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

function getMenuType() {
  var menuType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _AppState2['default'].currentMenuType;
  var isUser = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _AppState2['default'].isTypeUser;

  return isUser ? 'user' : menuType.type;
}

function filterEmptyMenus(menuData, parent) {
  var newMenuData = menuData.filter(function (item) {
    var name = item.name,
        type = item.type,
        subMenus = item.subMenus;

    return name !== null && (type === 'menu' || subMenus !== null && filterEmptyMenus(subMenus, item).length > 0);
  });
  if (parent) {
    parent.subMenus = newMenuData;
  }
  return newMenuData;
}

var MenuStore = (_class = function (_LanguageStore) {
  (0, _inherits3['default'])(MenuStore, _LanguageStore);

  function MenuStore() {
    (0, _classCallCheck3['default'])(this, MenuStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (MenuStore.__proto__ || Object.getPrototypeOf(MenuStore)).call(this, 'menu'));

    _initDefineProp(_this, 'menuGroup', _descriptor, _this);

    _initDefineProp(_this, 'collapsed', _descriptor2, _this);

    _initDefineProp(_this, 'activeMenu', _descriptor3, _this);

    _initDefineProp(_this, 'selected', _descriptor4, _this);

    _initDefineProp(_this, 'leftOpenKeys', _descriptor5, _this);

    _initDefineProp(_this, 'openKeys', _descriptor6, _this);

    _initDefineProp(_this, 'type', _descriptor7, _this);

    _initDefineProp(_this, 'isUser', _descriptor8, _this);

    _initDefineProp(_this, 'id', _descriptor9, _this);

    return _this;
  }

  (0, _createClass3['default'])(MenuStore, [{
    key: 'setCollapsed',
    value: function setCollapsed(collapsed) {
      this.collapsed = collapsed;
    }
  }, {
    key: 'setActiveMenu',
    value: function setActiveMenu(activeMenu) {
      this.activeMenu = activeMenu;
    }
  }, {
    key: 'setSelected',
    value: function setSelected(selected) {
      this.selected = selected;
    }
  }, {
    key: 'setLeftOpenKeys',
    value: function setLeftOpenKeys(leftOpenKeys) {
      this.leftOpenKeys = leftOpenKeys;
    }
  }, {
    key: 'setOpenKeys',
    value: function setOpenKeys(openKeys) {
      this.openKeys = openKeys;
    }
  }, {
    key: 'setType',
    value: function setType(type) {
      this.type = type;
    }
  }, {
    key: 'setIsUser',
    value: function setIsUser(isUser) {
      this.isUser = isUser;
    }
  }, {
    key: 'setId',
    value: function setId(id) {
      this.id = id;
    }
  }, {
    key: 'loadMenuData',
    value: function loadMenuData() {
      var _this2 = this;

      var menuType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _AppState2['default'].currentMenuType;
      var isUser = arguments[1];

      var type = getMenuType(menuType, isUser) || 'site';
      var _menuType$id = menuType.id,
          id = _menuType$id === undefined ? 0 : _menuType$id;

      var menu = this.menuData(type, id);
      if (menu.length) {
        return Promise.resolve(menu);
      }
      return _axios2['default'].get('/iam/v1/menus?level=' + type + '&source_id=' + id).then((0, _mobx.action)(function (data) {
        var child = filterEmptyMenus(data);
        _this2.setMenuData(child, type, id);
        return child;
      }));
    }
  }, {
    key: 'setMenuData',
    value: function setMenuData(child, childType) {
      var id = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _AppState2['default'].currentMenuType.id;

      var data = filterEmptyMenus(child);
      if (id) {
        (0, _mobx.set)(this.menuGroup[childType], id, data);
      } else {
        (0, _mobx.set)(this.menuGroup, childType, data);
      }
    }
  }, {
    key: 'menuData',
    value: function menuData() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getMenuType();
      var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _AppState2['default'].currentMenuType.id;

      var data = void 0;
      if (type) {
        if (id) {
          data = (0, _mobx.get)(this.menuGroup[type], id);
        } else {
          data = (0, _mobx.get)(this.menuGroup, type);
        }
      }
      return data || [];
    }
  }, {
    key: 'treeReduce',
    value: function treeReduce(tree, callback) {
      var _this3 = this;

      var childrenName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'subMenus';
      var parents = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

      if (tree.code) {
        parents.push(tree);
      }
      return tree[childrenName].some(function (node, index) {
        var newParents = parents.slice(0);
        if (node[childrenName] && node[childrenName].length > 0) {
          return _this3.treeReduce(node, callback, childrenName, newParents);
        }
        return callback(node, parents, index);
      });
    }
  }, {
    key: 'getMenuData',
    get: function get() {
      return this.menuData();
    }
  }, {
    key: 'getSiteMenuData',
    get: function get() {
      return this.menuData('site', 0);
    }
  }]);
  return MenuStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'menuGroup', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {
      site: [],
      user: [],
      organization: {},
      project: {}
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'collapsed', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'activeMenu', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'selected', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'leftOpenKeys', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'openKeys', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class.prototype, 'type', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class.prototype, 'isUser', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class.prototype, 'id', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'setCollapsed', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setCollapsed'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setActiveMenu', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setActiveMenu'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setSelected', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setSelected'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setLeftOpenKeys', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setLeftOpenKeys'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setOpenKeys', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setOpenKeys'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setType', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setType'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setIsUser', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setIsUser'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setId', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setId'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'loadMenuData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'loadMenuData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setMenuData', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setMenuData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getMenuData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getMenuData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'getSiteMenuData', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'getSiteMenuData'), _class.prototype)), _class);


var menuStore = new MenuStore();

exports['default'] = menuStore;