'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style2 = require('yqcloud-ui/lib/message/style');

var _message = require('yqcloud-ui/lib/message');

var _message2 = _interopRequireDefault(_message);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4; /**
                                                                                                  * Created by kaicheng.liu on 2018/10/9.
                                                                                                  */

var _mobx = require('mobx');

var _store = require('../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var MyTasksStore = (_dec = (0, _store2['default'])('MyTasksStore'), _dec(_class = (_class2 = function (_LanguageStore) {
  (0, _inherits3['default'])(MyTasksStore, _LanguageStore);

  function MyTasksStore() {
    (0, _classCallCheck3['default'])(this, MyTasksStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (MyTasksStore.__proto__ || Object.getPrototypeOf(MyTasksStore)).call(this, 'task'));

    _initDefineProp(_this, 'isLoading', _descriptor, _this);

    _initDefineProp(_this, 'userAlreadyBacklog', _descriptor2, _this);

    _initDefineProp(_this, 'userBacklog', _descriptor3, _this);

    _initDefineProp(_this, 'itsmBacklog', _descriptor4, _this);

    _this.loopList = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var tag = arguments[1];

      if (tag === 'itsm') {
        return data.map(function (item, index) {
          var result = (0, _extends3['default'])({
            key: index + 1,
            source: 'ITSM'
          }, item);
          return result;
        });
      } else {
        return data.map(function (item, index) {
          var result = (0, _extends3['default'])({
            key: index + 1
          }, item);
          return result;
        });
      }
    };

    _this.getTodoCount = function (iamOrganizationId) {
      return _axios2['default'].get('portal/v1/' + iamOrganizationId + '/todoList/todo/count');
    };

    _this.inviteOk = function (iamOrganizationId, email, iamOrganizationIdBeInvitee) {
      return _axios2['default'].post('iam/v1/organizations/' + iamOrganizationId + '/users/invitation/accept?emailName=' + email + '&iamOrganizationIdBeInvitee=' + iamOrganizationIdBeInvitee);
    };

    _this.inviteReject = function (iamOrganizationId, email, iamOrganizationIdBeInvitee) {
      return _axios2['default'].post('iam/v1/organizations/' + iamOrganizationId + '/users/invitation/refuse?emailName=' + email + '&iamOrganizationIdBeInvitee=' + iamOrganizationIdBeInvitee);
    };

    _this.loadUserBacklog = function (iamOrganizationId) {
      return _axios2['default'].get('portal/v1/' + iamOrganizationId + '/todoList/todo/notPage');
    };

    _this.loadItsmBacklog = function (iamOrganizationId, page, size) {
      return _axios2['default'].get('itsm/v1/' + iamOrganizationId + '/organizations/event/v2/to/do/page?page=' + page + '&size=' + size);
    };

    _this.getCode = function (code) {
      return _axios2['default'].get('/fnd/v1/sys/messages/queryCode?messageCode=' + code).then(function (data) {
        var infailed = data.failed;

        var types = data.type;
        if (!infailed) {
          _message2['default'][types](data.content, undefined, undefined, '' + data.placement);
        } else {
          _message2['default'][types](code, undefined, undefined, '' + data.placement);
        }
      });
    };

    _this.todoDone = function (iamOrganizationId, data) {
      return _axios2['default'].put('portal/v1/' + iamOrganizationId + '/todoList/done', JSON.stringify(data));
    };

    return _this;
  }

  (0, _createClass3['default'])(MyTasksStore, [{
    key: 'setIsLoading',
    value: function setIsLoading(flag) {
      this.isLoading = flag;
    }
  }, {
    key: 'setUserAlreadyBacklog',
    value: function setUserAlreadyBacklog(data) {
      this.userAlreadyBacklog = data;
    }
  }, {
    key: 'setUserBacklog',
    value: function setUserBacklog(data) {
      this.userBacklog = data;
    }
  }, {
    key: 'setItsmBacklog',
    value: function setItsmBacklog(data) {
      this.userBacklog = data;
    }
  }, {
    key: 'getIsLoading',
    get: function get() {
      return this.isLoading;
    }
  }, {
    key: 'getUserAlreadyBacklog',
    get: function get() {
      return this.userAlreadyBacklog;
    }
  }, {
    key: 'getUserBacklog',
    get: function get() {
      return this.userBacklog;
    }
  }, {
    key: 'getItsmBacklog',
    get: function get() {
      return this.userBacklog;
    }

    /* 代办事项数 */


    /* 同意邀请 */


    /* 拒绝邀请 */

  }]);
  return MyTasksStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'isLoading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'userAlreadyBacklog', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'userBacklog', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'itsmBacklog', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setIsLoading', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getIsLoading', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setUserAlreadyBacklog', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setUserAlreadyBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getUserAlreadyBacklog', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getUserAlreadyBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setUserBacklog', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setUserBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getUserBacklog', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getUserBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setItsmBacklog', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setItsmBacklog'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getItsmBacklog', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getItsmBacklog'), _class2.prototype)), _class2)) || _class);


var myTasksStore = new MyTasksStore();

exports['default'] = myTasksStore;