'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class, _descriptor; /**
                                         * Created by HughHzWu on 2018/5/23.
                                         */


var _mobx = require('mobx');

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var DELAY = 300;

var PermissionStore = (_class = function () {
  function PermissionStore() {
    (0, _classCallCheck3['default'])(this, PermissionStore);

    _initDefineProp(this, 'permissions', _descriptor, this);

    this.queue = [];
  }

  (0, _createClass3['default'])(PermissionStore, [{
    key: 'clear',
    value: function clear() {
      this.permissions = [];
    }
  }, {
    key: 'check',
    value: function check(props) {
      var _this = this;

      this.judgeServices(props).forEach(function (item) {
        return _this.checkItem(item);
      });
    }
  }, {
    key: 'access',
    value: function access(props) {
      var _this2 = this;

      var status = 'success';
      var allFailure = this.judgeServices(props).every(function (item) {
        var _findPermission = _this2.findPermission(item),
            key = _findPermission.key,
            approve = _findPermission.approve;

        if (approve) {
          status = 'success';
          return false;
        }
        if (!key) {
          status = 'pending';
        }
        return true;
      });
      if (allFailure && status !== 'pending') {
        status = 'failure';
      }
      return status;
    }
  }, {
    key: 'fetch',
    value: function fetch() {
      var _this3 = this;

      _axios2['default'].post('/iam/v1/permissions/checkPermission', JSON.stringify(this.queue)).then((0, _mobx.action)(function (data) {
        data.forEach(function (_ref) {
          var code = _ref.code,
              resourceType = _ref.resourceType,
              organizationId = _ref.organizationId,
              projectId = _ref.projectId,
              approve = _ref.approve;

          if (resourceType) {
            var item = _this3.judgeService(code, resourceType, organizationId, projectId);
            _this3.permissions.push({
              key: JSON.stringify(item),
              approve: approve
            });
          }
        });
      }));
      this.queue = [];
    }
  }, {
    key: 'checkItem',
    value: function checkItem(item) {
      var found = this.findPermission(item);
      if (found.key) {
        return found.approve;
      } else if (item) {
        this.quequeCheck(item);
      }
      return false;
    }
  }, {
    key: 'quequeCheck',
    value: function quequeCheck(item) {
      var _this4 = this;

      if (this.queue.findIndex(function (q) {
        return JSON.stringify(q) === JSON.stringify(item);
      }) === -1) {
        this.queue.push(item);
        if (this.delayId) {
          clearTimeout(this.delayId);
        }
        this.delayId = setTimeout(function () {
          _this4.fetch();
        }, DELAY);
      }
    }
  }, {
    key: 'judgeServices',
    value: function judgeServices(_ref2) {
      var _this5 = this;

      var service = _ref2.service,
          type = _ref2.type,
          organizationId = _ref2.organizationId,
          projectId = _ref2.projectId;

      if (service && service.length) {
        return service.map(function (code) {
          return _this5.judgeService(code, type, organizationId, projectId);
        });
      } else {
        return [];
      }
    }
  }, {
    key: 'judgeService',
    value: function judgeService(code, type, organizationId, projectId) {
      switch (type) {
        case 'organization':
          return {
            code: code,
            organizationId: Number(organizationId),
            resourceType: type
          };
        case 'project':
          return {
            code: code,
            organizationId: Number(organizationId),
            projectId: Number(projectId),
            resourceType: type
          };
        case 'site':
          return {
            code: code,
            resourceType: type
          };
        default:
          return null;
      }
    }
  }, {
    key: 'findPermission',
    value: function findPermission(item) {
      return this.permissions.find(function (_ref3) {
        var key = _ref3.key;
        return key === JSON.stringify(item);
      }) || { approve: false };
    }
  }]);
  return PermissionStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'permissions', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class.prototype, 'clear', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'clear'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'check', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'check'), _class.prototype)), _class);


var permissionStore = new PermissionStore();

exports['default'] = permissionStore;