'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6; /**
                                                                                                                              * Created by kaicheng.liu on 2018/9/26.
                                                                                                                              */

var _mobx = require('mobx');

var _store = require('../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var PortalStore = (_dec = (0, _store2['default'])('PortalStore'), _dec(_class = (_class2 = function () {
  function PortalStore() {
    var _this = this;

    (0, _classCallCheck3['default'])(this, PortalStore);

    _initDefineProp(this, 'isLoading', _descriptor, this);

    _initDefineProp(this, 'loading', _descriptor2, this);

    _initDefineProp(this, 'layoutList', _descriptor3, this);

    _initDefineProp(this, 'applications', _descriptor4, this);

    _initDefineProp(this, 'announcements', _descriptor5, this);

    _initDefineProp(this, 'modules', _descriptor6, this);

    this.loopLayoutList = function (data) {
      return data.map(function (item) {
        var result = (0, _extends3['default'])({
          key: item.moduleId
        }, item);
        return result;
      });
    };

    this.displayOrder = function (iamOrganizationId, orgPortalConfigurationId, displayOrder) {
      return _axios2['default'].post('/portal/v1/' + iamOrganizationId + '/organization/module/configuration/' + orgPortalConfigurationId + '/displayOrder/' + displayOrder);
    };

    this.updateConfiguration = function (iamOrganizationId, userPortalConfigurationId, data) {
      return _axios2['default'].post('/portal/v1/' + iamOrganizationId + '/organization/module/configuration/' + userPortalConfigurationId, JSON.stringify(data));
    };

    this.getConfigurationById = function (iamOrganizationId, userPortalConfigurationId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/organization/module/user/onePortal/' + userPortalConfigurationId);
    };

    this.loadModules = function (iamOrganizationId, appId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/module/info/module/' + appId).then(function (data) {
        if (data) {
          _this.setModules(data);
        }
      });
    };

    this.loadUserModules = function (iamOrganizationId, appId, portalId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/module/info/module/' + appId + '/user' + (portalId ? '?portalId=' + portalId : '')).then(function (data) {
        if (data) {
          _this.setModules(data);
        }
      });
    };

    this.loadApplication = function (iamOrganizationId) {
      return _axios2['default'].get('/portal/v1/' + iamOrganizationId + '/module/info/app').then(function (data) {
        if (data) {
          _this.setApplications(data);
        }
      });
    };

    this.loadLayoutModule = function (iamOrganizationId) {
      return _axios2['default'].get('portal/v1/' + iamOrganizationId + '/organization/module/user');
    };

    this.deleteUserWrokBenchModel = function (iamOrganizationId, data) {
      return _axios2['default']['delete']('portal/v1/' + iamOrganizationId + '/organization/module/user', { data: JSON.stringify(data) });
    };

    this.createConfiguration = function (iamOrganizationId, data) {
      return _axios2['default'].post('portal/v1/' + iamOrganizationId + '/organization/module/user', JSON.stringify(data));
    };

    this.updataUserModelLayout = function (iamOrganizationId, data) {
      return _axios2['default'].post('portal/v1/' + iamOrganizationId + '/organization/module/user/batch', JSON.stringify(data));
    };

    this.updataUserModelLayoutSingle = function (iamOrganizationId, data) {
      return _axios2['default'].put('portal/v1/' + iamOrganizationId + '/organization/module/user/single', JSON.stringify(data));
    };
  } // 工作台组件需要不同loading

  (0, _createClass3['default'])(PortalStore, [{
    key: 'setIsLoading',
    value: function setIsLoading(flag) {
      this.isLoading = flag;
    }
  }, {
    key: 'setLayoutList',
    value: function setLayoutList(data) {
      this.layoutList = data;
    }
  }, {
    key: 'setApplications',
    value: function setApplications(data) {
      this.applications = data;
    }
  }, {
    key: 'setModules',
    value: function setModules(data) {
      this.modules = data;
    }
  }, {
    key: 'setAnnouncements',
    value: function setAnnouncements(data) {
      this.announcements = data;
    }
  }, {
    key: 'getIsLoading',
    get: function get() {
      return this.isLoading;
    }
  }, {
    key: 'getLayoutList',
    get: function get() {
      return this.layoutList;
    }
  }, {
    key: 'getApplications',
    get: function get() {
      return this.applications;
    }
  }, {
    key: 'getModules',
    get: function get() {
      return this.modules;
    }
  }, {
    key: 'getAnnouncements',
    get: function get() {
      return this.announcements.slice();
    }

    /* 修改展示模块排序 */


    /* 更新应用模块 */


    /* 查询应用模块具体信息 */


    /* 模块列表 */


    /* 用户模块列表 */


    /* 应用列表 */


    /* 加载工作台默认布局列表 */


    /* 删除用户工作台模块 */


    /* 新增工作台应用模块 */


    /* 用户拖拽的时候，储存拖拽结束后的数据 */


    /* 更新单个模块信息 */

  }]);
  return PortalStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'isLoading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'loading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'layoutList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'applications', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'announcements', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'modules', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setIsLoading', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getIsLoading', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getIsLoading'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setLayoutList', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setLayoutList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getLayoutList', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getLayoutList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setApplications', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setApplications'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getApplications', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getApplications'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setModules', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setModules'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getModules', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getModules'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setAnnouncements', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setAnnouncements'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getAnnouncements', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getAnnouncements'), _class2.prototype)), _class2)) || _class);


var portalStore = new PortalStore();

exports['default'] = portalStore;