'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6; /**
                                                                                                                                                                             * Created by jaywoods on 2017/6/24.
                                                                                                                                                                             */


var _mobx = require('mobx');

var _axios = require('../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _AppState = require('./AppState');

var _AppState2 = _interopRequireDefault(_AppState);

var _languageStore = require('./language/languageStore');

var _languageStore2 = _interopRequireDefault(_languageStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var DEFAULT_PAGE = {
  page: 1,
  size: 10
};

var queryParam = function queryParam(data) {
  var arr = [];
  for (var key in data) {
    arr.push(key + '=' + data[key]);
  }
  return arr.join('&');
};

var SearchBoxStore = (_dec = _mobx.action.bound, _dec2 = _mobx.action.bound, _dec3 = _mobx.action.bound, _dec4 = _mobx.action.bound, _dec5 = _mobx.action.bound, _dec6 = _mobx.action.bound, _dec7 = _mobx.action.bound, _dec8 = _mobx.action.bound, _dec9 = _mobx.action.bound, (_class = function (_LanguageStore) {
  (0, _inherits3['default'])(SearchBoxStore, _LanguageStore);

  function SearchBoxStore() {
    (0, _classCallCheck3['default'])(this, SearchBoxStore);

    var _this = (0, _possibleConstructorReturn3['default'])(this, (SearchBoxStore.__proto__ || Object.getPrototypeOf(SearchBoxStore)).call(this, 'searchBox'));

    _initDefineProp(_this, 'loading', _descriptor, _this);

    _initDefineProp(_this, 'query', _descriptor2, _this);

    _initDefineProp(_this, 'serviceDirResultList', _descriptor3, _this);

    _initDefineProp(_this, 'serviceOrderResultList', _descriptor4, _this);

    _initDefineProp(_this, 'knowledgeResultList', _descriptor5, _this);

    _initDefineProp(_this, 'questionResultList', _descriptor6, _this);

    return _this;
  }

  (0, _createClass3['default'])(SearchBoxStore, [{
    key: 'setLoading',
    value: function setLoading(loading) {
      this.loading = loading;
    }
  }, {
    key: 'setQuery',
    value: function setQuery(query) {
      this.query = query;
    }
  }, {
    key: 'setResultList',
    value: function setResultList(dirList, orderList, knowledgeList, questionList) {
      if (dirList !== -1) {
        this.serviceDirResultList = dirList.concat([]);
      } else {
        this.serviceDirResultList = [];
      }
      if (orderList !== -1) {
        this.serviceOrderResultList = orderList.concat([]);
      } else {
        this.serviceOrderResultList = [];
      }
      if (knowledgeList !== -1) {
        this.knowledgeResultList = knowledgeList.concat([]);
      } else {
        this.knowledgeResultList = [];
      }
      if (questionList !== -1) {
        this.questionResultList = questionList.concat([]);
      } else {
        this.questionResultList = [];
      }
    }

    // 服务目录请求

  }, {
    key: 'searchRequestForServiceDir',
    value: function searchRequestForServiceDir(appState) {
      if (!appState) return;
      if (!this.query) return;

      var param = { catalogueName: this.query };
      var url = '/itsm/v1/' + appState.menuType.organizationId + '/catalogue/authority/employee/' + appState.userInfo.employeeId + '?' + queryParam(param);

      return new Promise(function (resolve) {
        _axios2['default'].get(url, param).then(function (json) {
          if (!json.failed) {
            resolve(json);
          } else {
            resolve(-1);
          }
        });
      });
    }

    // 服务单请求

  }, {
    key: 'searchRequestForServiceOrder',
    value: function searchRequestForServiceOrder(appState) {
      if (!appState) return;
      if (!this.query) return;

      var param = {
        iamOrganizationId: appState.menuType.organizationId,
        sort: '_score',
        queryContent: this.query,
        direction: 'desc',
        page: DEFAULT_PAGE.page,
        size: DEFAULT_PAGE.size,
        fragmentSize: 100,
        // fragmentOffset: 20,
        employeeId: appState.userInfo.employeeId
      };

      var url = '/itsm/v1/' + appState.menuType.organizationId + '/organizations/elastic/event?' + queryParam(param);

      return new Promise(function (resolve) {
        _axios2['default'].get(url).then(function (json) {
          if (!json.failed) {
            resolve(json.elasticDTOList);
          } else {
            resolve(-1);
          }
        });
      });
    }

    // 问答库请求

  }, {
    key: 'searchRequestForQuestion',
    value: function searchRequestForQuestion(appState) {
      if (!appState) return;
      if (!this.query) return;

      var param = {
        iamOrganizationId: appState.menuType.organizationId,
        sort: '_score',
        queryText: this.query,
        direction: 'desc',
        page: DEFAULT_PAGE.page,
        size: DEFAULT_PAGE.size
      };

      var url = '/chatrobot/v1/' + appState.menuType.organizationId + '/question/qa/query?' + queryParam(param);

      return new Promise(function (resolve) {
        _axios2['default'].get(url).then(function (json) {
          if (json.success) {
            resolve(json.result.crQaQuestions);
          } else {
            resolve(-1);
          }
        });
      });
    }

    // 知识库请求

  }, {
    key: 'searchRequestForKnowlege',
    value: function searchRequestForKnowlege(appState) {
      if (!appState) return;
      if (!this.query) return;

      var param = {
        direction: 'desc',
        sort: 'score',
        iamOrganizationId: appState.menuType.organizationId,
        knowledgeType: 'all',
        page: DEFAULT_PAGE.page,
        size: DEFAULT_PAGE.size,
        userId: appState.userInfo.id,
        searchRange: 'all',
        searchField: {
          accuracy: 'fuzzy',
          field: 'all',
          searchText: this.query
        },
        sourceField: {
          accuracy: 'precise',
          field: 'source',
          searchText: 'ALL' // 必须大写
        }
      };

      var url = '/km/v1/' + appState.menuType.organizationId + '/query/match/anyOne';
      return new Promise(function (resolve) {
        _axios2['default'].post(url, param).then(function (json) {
          if (!json.failed) {
            resolve(json.indexTemplateList);
          } else {
            resolve(-1);
          }
        });
      });
    }
  }, {
    key: 'fetchData',
    value: function fetchData(appState) {
      var _this2 = this;

      if (!this.query) {
        this.setResultList([], [], [], []);
        return;
      }

      this.setLoading(true);
      Promise.all([this.searchRequestForServiceDir(appState), this.searchRequestForServiceOrder(appState), this.searchRequestForKnowlege(appState), this.searchRequestForQuestion(appState)]).then(function (resultArr) {
        // setTimeout(() => {
        _this2.setResultList.apply(_this2, (0, _toConsumableArray3['default'])(resultArr));
        _this2.setLoading(false);
        // }, 500)
      });
    }
  }, {
    key: 'reset',
    value: function reset() {
      this.setResultList([], [], [], []);
    }
  }]);
  return SearchBoxStore;
}(_languageStore2['default']), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'loading', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'query', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'serviceDirResultList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'serviceOrderResultList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'knowledgeResultList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'questionResultList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class.prototype, 'setLoading', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, 'setLoading'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setQuery', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'setQuery'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setResultList', [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, 'setResultList'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'searchRequestForServiceDir', [_dec4], Object.getOwnPropertyDescriptor(_class.prototype, 'searchRequestForServiceDir'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'searchRequestForServiceOrder', [_dec5], Object.getOwnPropertyDescriptor(_class.prototype, 'searchRequestForServiceOrder'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'searchRequestForQuestion', [_dec6], Object.getOwnPropertyDescriptor(_class.prototype, 'searchRequestForQuestion'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'searchRequestForKnowlege', [_dec7], Object.getOwnPropertyDescriptor(_class.prototype, 'searchRequestForKnowlege'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'fetchData', [_dec8], Object.getOwnPropertyDescriptor(_class.prototype, 'fetchData'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'reset', [_dec9], Object.getOwnPropertyDescriptor(_class.prototype, 'reset'), _class.prototype)), _class));


var searchBoxStore = new SearchBoxStore();

exports['default'] = searchBoxStore;