'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2; /**
                                                                      * Create By liuchuan on 2018/12/25.
                                                                      */


var _mobx = require('mobx');

var _store = require('../../components/store');

var _store2 = _interopRequireDefault(_store);

var _axios = require('../../components/axios');

var _axios2 = _interopRequireDefault(_axios);

var _zh_CN = require('./locale/zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

var _en_US = require('./locale/en_US');

var _en_US2 = _interopRequireDefault(_en_US);

var _ja_JP = require('./locale/ja_JP');

var _ja_JP2 = _interopRequireDefault(_ja_JP);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var LanguageStore = (_dec = (0, _store2['default'])('LanguageStore'), _dec(_class = (_class2 = function () {
  function LanguageStore(flag) {
    var _this = this;

    (0, _classCallCheck3['default'])(this, LanguageStore);

    _initDefineProp(this, 'language', _descriptor, this);

    _initDefineProp(this, 'languageEnv', _descriptor2, this);

    this.queryLanguage = function (iamOrganizationId) {
      var language = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'zh_CN';
      var otherCode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

      var allLanglist = {};
      var zhCnList = (0, _extends3['default'])({}, _zh_CN2['default'][_this.flag], _zh_CN2['default'].common);
      if (language === 'en_US') {
        allLanglist = (0, _extends3['default'])({}, _en_US2['default'][_this.flag], _en_US2['default'].common);
      } else if (language === 'ja_JP') {
        allLanglist = (0, _extends3['default'])({}, _ja_JP2['default'][_this.flag], _ja_JP2['default'].common);
      } else {
        allLanglist = zhCnList;
      }
      var requestCode = [].concat((0, _toConsumableArray3['default'])(Object.keys(zhCnList)), (0, _toConsumableArray3['default'])(otherCode));
      _this.setLanguage(allLanglist);
      // 先查租户  后查平台
      // return axios.post(`fnd/v1/${iamOrganizationId}/prompts/multi/lan`, JSON.stringify(requestCode))
      // 只查平台
      return _axios2['default'].post('fnd/v1/' + iamOrganizationId + '/prompts/multi/language/site', JSON.stringify(requestCode)).then(function (lang) {
        var langlist = {};
        requestCode.forEach(function (v) {
          langlist[v] = lang[v] || v;
        });
        _this.setLanguage(langlist);
        return lang;
      });
    };

    this.queryLanguageEnv = function () {
      _axios2['default'].get('iam/v1/languages/list').then(function (allLanguage) {
        _this.setLanguageEnv(allLanguage);
      });
    };

    this.flag = flag;
  }

  (0, _createClass3['default'])(LanguageStore, [{
    key: 'setLanguage',
    value: function setLanguage(flag) {
      this.language = flag;
    }
  }, {
    key: 'setLanguageEnv',
    value: function setLanguageEnv(flag) {
      this.languageEnv = flag;
    }
  }, {
    key: 'getLanguage',
    get: function get() {
      return this.language;
    }
  }, {
    key: 'getLanguageEnv',
    get: function get() {
      return this.languageEnv;
    }
  }]);
  return LanguageStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'language', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'languageEnv', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'setLanguage', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setLanguage'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getLanguage', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getLanguage'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setLanguageEnv', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setLanguageEnv'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'getLanguageEnv', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, 'getLanguageEnv'), _class2.prototype)), _class2)) || _class);
exports['default'] = LanguageStore;